        .586p
DGROUP group _DATA,_BSS
_TEXT  segment dword public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

; Petter Schau 1997

include defs.inc



public copper_updatedma_
copper_updatedma_:              test    byte ptr [_copperdma],1
                                jz      copper_updatedma_wasoff

                                ; Here copper was on, test if it is still on.

                                test    byte ptr [_dmacon],080h
                                jnz     copper_updatedma_stillon

                                ; Here copper is being turned off

                                push    edx
                                mov     edx,dword ptr [_nxtcopaccess]
                                mov     dword ptr [_coppersuspendedwait],edx
                                pop     edx
                                mov     dword ptr [_nxtcopaccess],-1
                                mov     byte ptr [_copperdma],0

copper_updatedma_stillon:       ret

copper_updatedma_wasoff:        ; Here copper was off, test if it is still off

                                test    byte ptr [_dmacon],080h
                                jz      copper_updatedma_stilloff

                                ; Here copper is being turned on

                                push    edx
                                mov     edx,dword ptr [_coppersuspendedwait]
                                cmp     edx,-1
                                je      copper_updatedma_hanging
                                cmp     edx,dword ptr [_curcycle]
                                ja      copper_updatedma_hanging
                                mov     edx,dword ptr [_curcycle]
                                add     edx,4
copper_updatedma_hanging:       mov     dword ptr [_nxtcopaccess],edx
                                pop     edx
                                mov     byte ptr [_copperdma],1

copper_updatedma_stilloff:      ret



public copper_restart_
copper_restart_:                mov     edx,dword ptr [_cop1lc]
                                mov     dword ptr [_curcopptr],edx
                                test    byte ptr [_copperdma],1
                                jz      copper_restart_not
                                mov     dword ptr [_coppersuspendedwait],40
                                mov     dword ptr [_nxtcopaccess],40
copper_restart_not:             ret


public copper_load1_
copper_load1_:                  mov     edx,dword ptr [_cop1lc]
                                mov     dword ptr [_curcopptr],edx
                                test    byte ptr [_copperdma],1
                                jz      copper_load1_not
                                push    edx
                                mov     edx,dword ptr [_curcycle]
                                add     edx,4
                                mov     dword ptr [_nxtcopaccess],edx
                                pop     edx
copper_load1_not:               ret


public copper_load2_
copper_load2_:                  mov     edx,dword ptr [_cop2lc]
                                mov     dword ptr [_curcopptr],edx
                                test    byte ptr [_copperdma],1
                                jz      copper_load2_not
                                push    edx
                                mov     edx,dword ptr [_curcycle]
                                add     edx,4
                                mov     dword ptr [_nxtcopaccess],edx
                                pop     edx
copper_load2_not:               ret




public copemu
copemu:
        push    ebx
        push    ecx
        push    edx
	mov     ecx,dword ptr _curcopptr
	mov     edx,dword ptr _cmem[ecx]
	bswap   edx
        add     ecx,4
        and     ecx,01ffffeh
        mov     dword ptr _curcopptr,ecx
        cmp     edx,0fffffffeh
        je      notokay
        mov     ecx,edx
	and     edx,0ffffh
	shr     ecx,16
	test    ecx,01h                          ; Zero is MOVE
	jnz     cwait
	and     ecx,000001feh                   ; Move (This works)
	mov     ebx,dword ptr _curcycle
	add     ebx,4
	mov     dword ptr _nxtcopaccess,ebx
	cmp     ecx,80h                         ;
	jae     okay
        test    dword ptr _copcon,0ffffh             ; Access to $40-$7e?
	jz      notokay
	cmp     ecx,40h
	jb      notokay
okay:   call    dword ptr _iowrite+ecx*2
        pop     edx
        pop     ecx
        pop     ebx
        ret
notokay:mov     dword ptr _nxtcopaccess,-1
        pop     edx
        pop     ecx
        pop     ebx
        ret
        

	align   4
cwait:  and     ecx,0fffeh
        test    edx,01h                         ; Zero is Wait (Works??)
        jnz     cskip                           ;       (Not really!)

        ; Calculate our line, masked with vmask
        ; bl - masked ypos 

        mov     ebx,dword ptr _ypos
        or      edx,00008000h                  ; use mask on ypos
        xor     ebp,ebp                         ; Used to indicate
                                                ; correct line or not
        and     bl,dh
        cmp     bl,ch                   ; Compare masked y with wait line.
        ja      cexit                   ; We have passed the line, set up
                                        ; next instruction immediately.
        jb      notnever                ; We are above the line, calculate
                                        ; the cycle when wait is true.

        ; Here we are on the correct line

        ; Calculate our xposition, masked with hmask
        ; al - masked xpos
        

        mov     eax,dword ptr _xpos
        inc     ebp
	and     al,dl                   ; Use mask on xpos
        cmp     al,cl                   ; Compare masked x with wait x
        jae     cexit                   ; Position reached, set up
                                        ; next instruction immediately.

        ; Here the wait position is not reached yet, calculate
        ; cycle when wait is true.
        ; Previous position checks should assure that
        ; a calculated position is not less than the current cycle.

notnever:
        not     edx                     ; Invert masks
        mov     ebx,dword ptr _ypos
        and     bl,dh                   ; Get bits that is not masked out
        or      bl,ch                   ; Mask in bits from waitypos
        mov     ebx,dword ptr _copperytable[ebx*4]
        
        ; When wait is on same line, use masking stuff on xpos,
        ; else on xpos = 0

        and     ecx,0feh                ; Prepare waitxpos
        xor     eax,eax
        test    ebp,ebp
        jz      copwaitnotsameline
        mov     eax,dword ptr _xpos
copwaitnotsameline:
        and     edx,0feh
        and     eax,edx                 ; Get unmasked bits from current x
        or      ecx,eax                 ; Mask in horizontal waitpos
        add     ebx,ecx
        add     ebx,4
        mov     dword ptr _nxtcopaccess,ebx
        pop     edx
        pop     ecx
        pop     ebx
        ret
        


	align   4

; to help the copper to wait line 256, do some tests here
; Here we have detected a wait position that we are past.
; Check if current line is 255, then if line we are supposed
; to wait for are less than 60, do the wait afterall.

; Here we have detected a wait that has been passed.

cexit:  ;jmp     ctrueexit
        cmp     dword ptr _ypos,255
        jne     ctrueexit               ; Do some tests if line is 255
        cmp     ch,40h                  ; Test line to be waited for
        ja      ctrueexit               ; Line is 256-313, wrong to not wait


; Better to do the wait afterall.
; Here we recalculate the wait stuff,

	not     edx                     ; Invert masks
	mov     ebx,dword ptr _ypos
        or      ebx,0100h
	and     bl,dh                   ; Get missing bits
	or      bl,ch                   ; Mask them into vertical position
        imul    ebx,CYCLESPERLINE
	and     ecx,0feh
	mov     eax,dword ptr _xpos
	and     edx,0feh
	and     eax,edx
	or      ecx,eax                 ; Mask in horizontal
	add     ecx,ebx
	add     ecx,4
	cmp     ecx,dword ptr _curcycle
        ja      cnofix
        mov     ecx,dword ptr _curcycle
cnofix:
        add     ecx,32
fluks:  
	mov     dword ptr _nxtcopaccess,ecx
        pop     edx
        pop     ecx
        pop     ebx
        
        ret
        


; Here we must do a new copper access immediately (in 4 cycles)
ctrueexit:
        mov     ebx,dword ptr _curcycle
	add     ebx,4
;        add     ebx,32
        mov     dword ptr _nxtcopaccess,ebx
        pop     edx
        pop     ecx
        pop     ebx
        
        ret
        
; New skip, copied from cwait just to try something

	align   4
cskip: 


        ; Calculate our line, masked with vmask
        ; bl - masked ypos 

        mov     ebx,dword ptr _ypos
        or      edx,00008000h                  ; use mask on ypos
        xor     ebp,ebp                         ; Used to indicate
                                                ; correct line or not
        and     bl,dh
        cmp     bl,ch                   ; Compare masked y with wait line.
        ja      cdoskip                 ; We have passed the line, set up
                                        ; next instruction immediately.
        jb      cdontskip               ; Above line, don't skip

        ; Here we are on the correct line

        ; Calculate our xposition, masked with hmask
        ; al - masked xpos
        

        mov     eax,dword ptr _xpos
        inc     ebp
	and     al,dl                   ; Use mask on xpos
        cmp     al,cl                   ; Compare masked x with wait x
        jb      cdontskip               ; Position reached, set up
                                        ; next instruction immediately.
cdoskip:
        add     dword ptr [_curcopptr],4
cdontskip:
        add     ebx,4
        mov     dword ptr _nxtcopaccess,ebx
        pop     edx
        pop     ecx
        pop     ebx
        ret
        
_TEXT ends

_DATA segment dword public 'DATA'

include data\memory.inc
include data\chip.inc
include data\bus.inc

_copperdma:                     dd      0
_coppersuspendedwait:        dd      0


_DATA ends

_BSS segment dword public 'DATA'
_BSS ends

end

