        .586p
DGROUP group _DATA,_BSS
_TEXT  segment dword public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

; Petter Schau 1997
; Assembler routines for the graphics-emulation, except the actual
; drawing to VGA-memory.
; Might be replaced by equivalent C-routines with USE_C

include defs.inc

#ifdef USE_ASM

; All the MMX macros assumes that eax and ebx is zeroed
; and that esi is loaded with a pointer to the temporary line

LOAD_BITPLANE_WORD_MMX macro BITPLANEPTR, DECOTABLE
local   skipword
                psubd   mm0,mm0
                psubd   mm1,mm1
                test    word ptr [_cmem + BITPLANEPTR],0ffffh
                jz      skipword
                mov     al,byte ptr [_cmem + BITPLANEPTR]
                mov     bl,byte ptr [_cmem + 1 + BITPLANEPTR]
                movq    mm0,[DECOTABLE + 8*eax]
                movq    mm1,[DECOTABLE + 8*ebx]
skipword:       add     BITPLANEPTR,2
endm


OR_BITPLANE_WORD_MMX macro BITPLANEPTR, DECOTABLE
local   skipword
                test    word ptr [_cmem + BITPLANEPTR],0ffffh
                jz      skipword
                mov     al,byte ptr [_cmem + BITPLANEPTR]
                mov     bl,byte ptr [_cmem + 1 + BITPLANEPTR]
                por     mm0,[DECOTABLE + 8*eax]
                por     mm1,[DECOTABLE + 8*ebx]
skipword:       add     BITPLANEPTR,2
endm

STORE_DECODED_DATA_MMX macro
                movq    [esi],mm0
                movq    8[esi],mm1
                add     esi,16
endm

SETUP_LOOP_MMX macro
        xor     eax,eax
        xor     ebx,ebx
        mov     edi,dword ptr [_decodetmp]
endm

ITERATE_LOOP_MMX macro THE_LABEL
        dec     edi
        jnz     THE_LABEL
endm

LOAD_BITPLANE_PTR macro REGISTER, PTR
        mov     REGISTER, dword ptr [PTR]
endm

SAVE_BITPLANE_PTR macro REGISTER, PTR
        mov     dword ptr [PTR],REGISTER
endm

;----------------------------------
; Lores planar to chunky conversion
;----------------------------------

public decode0_ 
decode0_:             ret

public decode1_
decode1_:
                        test    dword ptr [_bplcon0],08000h
                        jnz     decodehi1_
                        mov     eax,dword ptr _DDFnumberofwords
			test    eax,eax
			jz      nndcl1nowork
			mov     dword ptr _decodetmp,eax
			mov     eax,dword ptr _oddscroll

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode

; Setup loop, calculate position of playfield start in line array
			mov     esi,offset _linje
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl1oddloop:		mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]

; Loop ended for odd bitplanes

			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl1oddloop

; End of odd bitplane decode
; Add modulos

nndcl1modulos:		xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			mov     esi,dword ptr _bpl1mod
			mov     eax,dword ptr _bpl1pt
			add     eax,esi
			and     eax,01ffffeh
			mov     dword ptr _bpl1pt,eax
nndcl1nowork:		ret

public decode2_
decode2_:
                        test    dword ptr [_bplcon0],08000h
                        jnz     decodehi2_
                        mov     eax,dword ptr _DDFnumberofwords
			test    eax,eax
			jz      nndcl2nowork
			mov     dword ptr _decodetmp,eax
			mov     eax,dword ptr _oddscroll
			cmp     eax,dword ptr _evenscroll
			je      nndcl2oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode

; Setup loop, calculate position of playfield start in line array

			mov     esi,offset _linje
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl2oddloop:		mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]

; Loop ended for odd bitplanes

			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl2oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array

			mov     eax,dword ptr _DDFnumberofwords
			mov     dword ptr _decodetmp,eax
			mov     esi,offset _linje
			add     esi,dword ptr _evenscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl2evenloop:		mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco2  +8*edx]
			mov     ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco2  +8*edx]
			mov     ebp,dword ptr [_deco2+4+8*edx]

; Loop ended for even bitplanes

			or      dword ptr [esi],eax
			or      dword ptr 4[esi],ebx
			or      dword ptr 8[esi],edi
			or      dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl2evenloop
			jmp     nndcl2modulos

; End of even bitplane decode
; The case when odd and even scroll is equal

nndcl2oddevenequal:

; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode

; Setup loop, calculate position of playfield start in line array

			mov     esi,offset _linje
			add     esi,dword ptr _oddscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl2equalloop:	mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]
			mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl2equalskip2
			mov     dl,cl
			or      eax,dword ptr [_deco2  +8*edx]
			or      ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco2  +8*edx]
			or      ebp,dword ptr [_deco2+4+8*edx]

nndcl2equalskip2:
; Loop ended for all bitplanes
			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl2equalloop

; End of all bitplane decode

nndcl2modulos:
; Add modulos
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			mov     esi,dword ptr _bpl1mod
			mov     edi,dword ptr _bpl2mod
			mov     eax,dword ptr _bpl1pt
			mov     ebx,dword ptr _bpl2pt
			add     eax,esi
			add     ebx,edi
			mov     esi,01ffffeh
			and     eax,esi
			and     ebx,esi
			mov     dword ptr _bpl1pt,eax
			mov     dword ptr _bpl2pt,ebx
nndcl2nowork:		ret

public decode3_
decode3_:
                        test    dword ptr [_bplcon0],08000h
                        jnz     decodehi3_
                        mov     eax,dword ptr _DDFnumberofwords
			test    eax,eax
			jz      nndcl3nowork
			mov     dword ptr _decodetmp,eax
			mov     eax,dword ptr _oddscroll
			cmp     eax,dword ptr _evenscroll
			je      nndcl3oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode

; Setup loop, calculate position of playfield start in line array

			mov     esi,offset _linje
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl3oddloop:		mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]
			mov     ecx,dword ptr _bpl3pt           ; bp3
			add     ecx,2
			mov     dword ptr _bpl3pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl3skip3
			mov     dl,cl
			or      eax,dword ptr [_deco3  +8*edx]
			or      ebx,dword ptr [_deco3+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco3  +8*edx]
			or      ebp,dword ptr [_deco3+4+8*edx]
nndcl3skip3:

; Loop ended for odd bitplanes

			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl3oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array

			mov     eax,dword ptr _DDFnumberofwords
			mov     dword ptr _decodetmp,eax
			mov     esi,offset _linje
			add     esi,dword ptr _evenscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl3evenloop:		mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco2  +8*edx]
			mov     ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco2  +8*edx]
			mov     ebp,dword ptr [_deco2+4+8*edx]

; Loop ended for even bitplanes
			or      dword ptr [esi],eax
			or      dword ptr 4[esi],ebx
			or      dword ptr 8[esi],edi
			or      dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl3evenloop
			jmp     nndcl3modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndcl3oddevenequal:

; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode

; Setup loop, calculate position of playfield start in line array

			mov     esi,offset _linje
			add     esi,dword ptr _oddscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl3equalloop:	mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]
			mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl3equalskip2
			mov     dl,cl
			or      eax,dword ptr [_deco2  +8*edx]
			or      ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco2  +8*edx]
			or      ebp,dword ptr [_deco2+4+8*edx]

nndcl3equalskip2:       mov     ecx,dword ptr _bpl3pt           ; bp3
			add     ecx,2
			mov     dword ptr _bpl3pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl3equalskip3
			mov     dl,cl
			or      eax,dword ptr [_deco3  +8*edx]
			or      ebx,dword ptr [_deco3+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco3  +8*edx]
			or      ebp,dword ptr [_deco3+4+8*edx]

nndcl3equalskip3:
; Loop ended for all bitplanes
			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl3equalloop

; End of all bitplane decode

nndcl3modulos:
; Add modulos
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			mov     esi,dword ptr _bpl1mod
			mov     edi,dword ptr _bpl2mod
			mov     eax,dword ptr _bpl1pt
			mov     ebx,dword ptr _bpl2pt
			mov     ecx,dword ptr _bpl3pt
			add     eax,esi
			add     ecx,esi
			add     ebx,edi
			mov     esi,01ffffeh
			and     eax,esi
			and     ebx,esi
			and     ecx,esi
			mov     dword ptr _bpl1pt,eax
			mov     dword ptr _bpl2pt,ebx
			mov     dword ptr _bpl3pt,ecx
nndcl3nowork:		ret

public decode4_
decode4_:
                        test    dword ptr [_bplcon0],08000h
                        jnz     decodehi4_
                        mov     eax,dword ptr _DDFnumberofwords
			test    eax,eax
			jz      nndcl4nowork
			mov     dword ptr _decodetmp,eax
			mov     eax,dword ptr _oddscroll
			cmp     eax,dword ptr _evenscroll
			je      nndcl4oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode

; Setup loop, calculate position of playfield start in line array

			mov     esi,offset _linje
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl4oddloop:		mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]

			mov     ecx,dword ptr _bpl3pt           ; bp3
			add     ecx,2
			mov     dword ptr _bpl3pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl4skip3
			mov     dl,cl
			or      eax,dword ptr [_deco3  +8*edx]
			or      ebx,dword ptr [_deco3+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco3  +8*edx]
			or      ebp,dword ptr [_deco3+4+8*edx]

nndcl4skip3:

; Loop ended for odd bitplanes
			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl4oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode

; Setup loop, calculate position of playfield start in line array

			mov     eax,dword ptr _DDFnumberofwords
			mov     dword ptr _decodetmp,eax
			mov     esi,offset _linje
			add     esi,dword ptr _evenscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl4evenloop:		mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco2  +8*edx]
			mov     ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco2  +8*edx]
			mov     ebp,dword ptr [_deco2+4+8*edx]

			mov     ecx,dword ptr _bpl4pt           ; bp4
			add     ecx,2
			mov     dword ptr _bpl4pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl4skip4
			mov     dl,cl
			or      eax,dword ptr [_deco4  +8*edx]
			or      ebx,dword ptr [_deco4+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco4  +8*edx]
			or      ebp,dword ptr [_deco4+4+8*edx]

nndcl4skip4:
; Loop ended for even bitplanes
			or      dword ptr [esi],eax
			or      dword ptr 4[esi],ebx
			or      dword ptr 8[esi],edi
			or      dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl4evenloop
			jmp     nndcl4modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndcl4oddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array

			mov     esi,offset _linje
			add     esi,dword ptr _oddscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl4equalloop:
			mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]

			mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl4equalskip2
			mov     dl,cl
			or      eax,dword ptr [_deco2  +8*edx]
			or      ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco2  +8*edx]
			or      ebp,dword ptr [_deco2+4+8*edx]

nndcl4equalskip2:
			mov     ecx,dword ptr _bpl3pt           ; bp3
			add     ecx,2
			mov     dword ptr _bpl3pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl4equalskip3
			mov     dl,cl
			or      eax,dword ptr [_deco3  +8*edx]
			or      ebx,dword ptr [_deco3+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco3  +8*edx]
			or      ebp,dword ptr [_deco3+4+8*edx]

nndcl4equalskip3:
			mov     ecx,dword ptr _bpl4pt           ; bp4
			add     ecx,2
			mov     dword ptr _bpl4pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl4equalskip4
			mov     dl,cl
			or      eax,dword ptr [_deco4  +8*edx]
			or      ebx,dword ptr [_deco4+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco4  +8*edx]
			or      ebp,dword ptr [_deco4+4+8*edx]

nndcl4equalskip4:
; Loop ended for all bitplanes
			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl4equalloop

; End of all bitplane decode

nndcl4modulos:
; Add modulos
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			mov     esi,dword ptr _bpl1mod
			mov     edi,dword ptr _bpl2mod
			mov     eax,dword ptr _bpl1pt
			mov     ebx,dword ptr _bpl2pt
			mov     ecx,dword ptr _bpl3pt
			mov     edx,dword ptr _bpl4pt
			add     eax,esi
			add     ecx,esi
			add     ebx,edi
			add     edx,edi
			mov     esi,01ffffeh
			and     eax,esi
			and     ebx,esi
			and     ecx,esi
			and     edx,esi
			mov     dword ptr _bpl1pt,eax
			mov     dword ptr _bpl2pt,ebx
			mov     dword ptr _bpl3pt,ecx
			mov     dword ptr _bpl4pt,edx
nndcl4nowork:		ret




public decode5_
decode5_:
			mov     eax,dword ptr _DDFnumberofwords
			test    eax,eax
			jz      nndcl5nowork
			mov     dword ptr _decodetmp,eax
			mov     eax,dword ptr _oddscroll
			cmp     eax,dword ptr _evenscroll
			je      nndcl5oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array

			mov     esi,offset _linje
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode


        
nndcl5oddloop:
			mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]

			mov     ecx,dword ptr _bpl3pt           ; bp3
			add     ecx,2
			mov     dword ptr _bpl3pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl5skip3
			mov     dl,cl
			or      eax,dword ptr [_deco3  +8*edx]
			or      ebx,dword ptr [_deco3+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco3  +8*edx]
			or      ebp,dword ptr [_deco3+4+8*edx]

nndcl5skip3:
			mov     ecx,dword ptr _bpl5pt           ; bp5
			add     ecx,2
			mov     dword ptr _bpl5pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl5skip5
			mov     dl,cl
			or      eax,dword ptr [_deco5  +8*edx]
			or      ebx,dword ptr [_deco5+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco5  +8*edx]
			or      ebp,dword ptr [_deco5+4+8*edx]

nndcl5skip5:
; Loop ended for odd bitplanes
			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl5oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array

			mov     eax,dword ptr _DDFnumberofwords
			mov     dword ptr _decodetmp,eax
			mov     esi,offset _linje
			add     esi,dword ptr _evenscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl5evenloop:
			mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco2  +8*edx]
			mov     ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco2  +8*edx]
			mov     ebp,dword ptr [_deco2+4+8*edx]

			mov     ecx,dword ptr _bpl4pt           ; bp4
			add     ecx,2
			mov     dword ptr _bpl4pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl5skip4
			mov     dl,cl
			or      eax,dword ptr [_deco4  +8*edx]
			or      ebx,dword ptr [_deco4+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco4  +8*edx]
			or      ebp,dword ptr [_deco4+4+8*edx]

nndcl5skip4:
; Loop ended for even bitplanes
			or      dword ptr [esi],eax
			or      dword ptr 4[esi],ebx
			or      dword ptr 8[esi],edi
			or      dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl5evenloop
			jmp     nndcl5modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndcl5oddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array

			mov     esi,offset _linje
			add     esi,dword ptr _oddscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl5equalloop:
			mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]

			mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			test    cx,cx
			jz      nndcl5equalskip2
			or      eax,dword ptr [_deco2  +8*edx]
			or      ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco2  +8*edx]
			or      ebp,dword ptr [_deco2+4+8*edx]

nndcl5equalskip2:
			mov     ecx,dword ptr _bpl3pt           ; bp3
			add     ecx,2
			mov     dword ptr _bpl3pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			test    cx,cx
			jz      nndcl5equalskip3
			or      eax,dword ptr [_deco3  +8*edx]
			or      ebx,dword ptr [_deco3+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco3  +8*edx]
			or      ebp,dword ptr [_deco3+4+8*edx]

nndcl5equalskip3:
			mov     ecx,dword ptr _bpl4pt           ; bp4
			add     ecx,2
			mov     dword ptr _bpl4pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			test    cx,cx
			jz      nndcl5equalskip4
			or      eax,dword ptr [_deco4  +8*edx]
			or      ebx,dword ptr [_deco4+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco4  +8*edx]
			or      ebp,dword ptr [_deco4+4+8*edx]

nndcl5equalskip4:
			mov     ecx,dword ptr _bpl5pt           ; bp5
			add     ecx,2
			mov     dword ptr _bpl5pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			test    cx,cx
			jz      nndcl5equalskip5
			or      eax,dword ptr [_deco5  +8*edx]
			or      ebx,dword ptr [_deco5+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco5  +8*edx]
			or      ebp,dword ptr [_deco5+4+8*edx]

nndcl5equalskip5:
; Loop ended for all bitplanes
			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl5equalloop

; End of all bitplane decode

nndcl5modulos:
; Add modulos
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			mov     esi,dword ptr _bpl1mod
			mov     edi,dword ptr _bpl2mod
			mov     eax,dword ptr _bpl1pt
			mov     ebx,dword ptr _bpl2pt
			mov     ecx,dword ptr _bpl3pt
			mov     edx,dword ptr _bpl4pt
			mov     ebp,dword ptr _bpl5pt
			add     eax,esi
			add     ecx,esi
			add     ebp,esi
			add     ebx,edi
			add     edx,edi
			mov     esi,01ffffeh
			and     eax,esi
			and     ebx,esi
			and     ecx,esi
			and     edx,esi
			and     ebp,esi
			mov     dword ptr _bpl1pt,eax
			mov     dword ptr _bpl2pt,ebx
			mov     dword ptr _bpl3pt,ecx
			mov     dword ptr _bpl4pt,edx
			mov     dword ptr _bpl5pt,ebp
nndcl5nowork:		ret


public decode6_
decode6_:
			mov     eax,dword ptr _DDFnumberofwords
			test    eax,eax
			jz      nndcl6nowork
			mov     dword ptr _decodetmp,eax
			mov     eax,dword ptr _oddscroll
			cmp     eax,dword ptr _evenscroll
			je      nndcl6oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array

		        mov     esi,offset _linje
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl6oddloop:
			mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]

			mov     ecx,dword ptr _bpl3pt           ; bp3
			add     ecx,2
			mov     dword ptr _bpl3pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl6skip3
			mov     dl,cl
			or      eax,dword ptr [_deco3  +8*edx]
			or      ebx,dword ptr [_deco3+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco3  +8*edx]
			or      ebp,dword ptr [_deco3+4+8*edx]

nndcl6skip3:
			mov     ecx,dword ptr _bpl5pt           ; bp5
			add     ecx,2
			mov     dword ptr _bpl5pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl6skip5
			mov     dl,cl
			or      eax,dword ptr [_deco5  +8*edx]
			or      ebx,dword ptr [_deco5+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco5  +8*edx]
			or      ebp,dword ptr [_deco5+4+8*edx]

nndcl6skip5:
; Loop ended for odd bitplanes
			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl6oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
 
			mov     eax,dword ptr _DDFnumberofwords
			mov     dword ptr _decodetmp,eax
			mov     esi,offset _linje
			add     esi,dword ptr _evenscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl6evenloop:
			mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco2  +8*edx]
			mov     ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco2  +8*edx]
			mov     ebp,dword ptr [_deco2+4+8*edx]

			mov     ecx,dword ptr _bpl4pt           ; bp4
			add     ecx,2
			mov     dword ptr _bpl4pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl6skip4
			mov     dl,cl
			or      eax,dword ptr [_deco4  +8*edx]
			or      ebx,dword ptr [_deco4+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco4  +8*edx]
			or      ebp,dword ptr [_deco4+4+8*edx]

nndcl6skip4:
			mov     ecx,dword ptr _bpl6pt           ; bp6
			add     ecx,2
			mov     dword ptr _bpl6pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl6skip6
			mov     dl,cl
			or      eax,dword ptr [_deco6  +8*edx]
			or      ebx,dword ptr [_deco6+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco6  +8*edx]
			or      ebp,dword ptr [_deco6+4+8*edx]

nndcl6skip6:
; Loop ended for even bitplanes
			or      dword ptr [esi],eax
			or      dword ptr 4[esi],ebx
			or      dword ptr 8[esi],edi
			or      dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl6evenloop
			jmp     nndcl6modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndcl6oddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array

		        mov     esi,offset _linje
			add     esi,dword ptr _oddscroll
			add     esi,dword ptr _DDFstartpos     ; linje position calculated
			xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcl6equalloop:
			mov     ecx,dword ptr _bpl1pt           ; bp1
			add     ecx,2
			mov     dword ptr _bpl1pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			mov     dl,cl
			mov     eax,dword ptr [_deco1  +8*edx]
			mov     ebx,dword ptr [_deco1+4+8*edx]
			mov     dl,ch
			mov     edi,dword ptr [_deco1  +8*edx]
			mov     ebp,dword ptr [_deco1+4+8*edx]

			mov     ecx,dword ptr _bpl2pt           ; bp2
			add     ecx,2
			mov     dword ptr _bpl2pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl6equalskip2
			mov     dl,cl
			or      eax,dword ptr [_deco2  +8*edx]
			or      ebx,dword ptr [_deco2+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco2  +8*edx]
			or      ebp,dword ptr [_deco2+4+8*edx]

nndcl6equalskip2:
			mov     ecx,dword ptr _bpl3pt           ; bp3
			add     ecx,2
			mov     dword ptr _bpl3pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl6equalskip3
			mov     dl,cl
			or      eax,dword ptr [_deco3  +8*edx]
			or      ebx,dword ptr [_deco3+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco3  +8*edx]
			or      ebp,dword ptr [_deco3+4+8*edx]

nndcl6equalskip3:
			mov     ecx,dword ptr _bpl4pt           ; bp4
			add     ecx,2
			mov     dword ptr _bpl4pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl6equalskip4
			mov     dl,cl
			or      eax,dword ptr [_deco4  +8*edx]
			or      ebx,dword ptr [_deco4+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco4  +8*edx]
			or      ebp,dword ptr [_deco4+4+8*edx]

nndcl6equalskip4:
			mov     ecx,dword ptr _bpl5pt           ; bp5
			add     ecx,2
			mov     dword ptr _bpl5pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl6equalskip5
			mov     dl,cl
			or      eax,dword ptr [_deco5  +8*edx]
			or      ebx,dword ptr [_deco5+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco5  +8*edx]
			or      ebp,dword ptr [_deco5+4+8*edx]

nndcl6equalskip5:
			mov     ecx,dword ptr _bpl6pt           ; bp6
			add     ecx,2
			mov     dword ptr _bpl6pt,ecx
			mov     ecx,dword ptr _cmem-2[ecx]
			test    cx,cx
			jz      nndcl6equalskip6
			mov     dl,cl
			or      eax,dword ptr [_deco6  +8*edx]
			or      ebx,dword ptr [_deco6+4+8*edx]
			mov     dl,ch
			or      edi,dword ptr [_deco6  +8*edx]
			or      ebp,dword ptr [_deco6+4+8*edx]

nndcl6equalskip6:
; Loop ended for all bitplanes
			mov     dword ptr [esi],eax
			mov     dword ptr 4[esi],ebx
			mov     dword ptr 8[esi],edi
			mov     dword ptr 12[esi],ebp
			add     esi,16
			dec     dword ptr _decodetmp
			jnz     nndcl6equalloop

; End of all bitplane decode

nndcl6modulos:
; Add modulos
			xor     edx,edx                        ; zero edx
			mov     dword ptr [esi],edx             ; Do some padding
			mov     dword ptr 4[esi],edx             ; Do some padding
			mov     dword ptr 8[esi],edx             ; Do some padding
			mov     dword ptr 12[esi],edx             ; Do some padding
			mov     esi,dword ptr _bpl1mod
			mov     edi,dword ptr _bpl2mod
			mov     eax,dword ptr _bpl1pt
			mov     ebx,dword ptr _bpl2pt
			mov     ecx,dword ptr _bpl3pt
			mov     edx,dword ptr _bpl4pt
			mov     ebp,dword ptr _bpl5pt
			add     eax,esi
			add     ecx,esi
			add     ebp,esi
			add     ebx,edi
			add     edx,edi
			mov     esi,01ffffeh
			and     eax,esi
			and     ebx,esi
			and     ecx,esi
			and     edx,esi
			and     ebp,esi
			mov     dword ptr _bpl1pt,eax
			mov     dword ptr _bpl2pt,ebx
			mov     dword ptr _bpl3pt,ecx
			mov     dword ptr _bpl4pt,edx
			mov     dword ptr _bpl5pt,ebp
			mov     eax,dword ptr _bpl6pt
			add     eax,edi
			and     eax,esi
			mov     dword ptr _bpl6pt,eax
nndcl6nowork:		ret


public decodehi1_
decodehi1_:             mov     eax,[_DDFnumberofwords]
                        test    eax,eax
                        jz      nndch1nowork
                        mov     [_decodetmp],eax
                        mov     eax,[_oddhiscroll]
                        mov     esi,offset _linje
                        add     esi,[_DDFstartpos]  ; linje position calculated
                        xor     edx,edx                        ; zero edx
                        mov     [esi],edx             ; Do some padding
                        mov     4[esi],edx             ; Do some padding
                        mov     8[esi],edx             ; Do some padding
                        mov     12[esi],edx             ; Do some padding
                        add     esi,eax                        ; Oddscroll, from test
nndch1oddloop:          mov     ecx,[_bpl1pt]           ; bp1
                        add     ecx,2
                        mov     [_bpl1pt],ecx
                        mov     ecx,[_cmem-2+ecx]
                        mov     dl,cl
                        mov     eax,[_deco1  +8*edx]
                        mov     ebx,[_deco1+4+8*edx]
                        mov     dl,ch
                        mov     edi,[_deco1  +8*edx]
                        mov     ebp,[_deco1+4+8*edx]
                        mov     [esi],eax
                        mov     4[esi],ebx
                        mov     8[esi],edi
                        mov     12[esi],ebp
                        add     esi,16
                        dec     dword ptr [_decodetmp]
                        jnz     nndch1oddloop

; End of odd bitplane decode

nndch1modulos:
; Add modulos
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        mov     esi,dword ptr _bpl1mod
        mov     eax,dword ptr _bpl1pt
        add     eax,esi
        and     eax,01ffffeh
        mov     dword ptr _bpl1pt,eax
nndch1nowork:
        ret

public decodehi2_
decodehi2_:
        test    byte ptr [_mmx_detected],1
        jnz     decodehi2mmx_
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndch2nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll
        cmp     eax,dword ptr _evenhiscroll
        je      nndch2oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch2oddloop:
                mov     ecx,dword ptr _bpl1pt           ; bp1
                add     ecx,2
                mov     dword ptr _bpl1pt,ecx
                mov     ecx,dword ptr _cmem-2[ecx]
                mov     dl,cl
                mov     eax,dword ptr [_deco1  +8*edx]
                mov     ebx,dword ptr [_deco1+4+8*edx]
                mov     dl,ch
                mov     edi,dword ptr [_deco1  +8*edx]
                mov     ebp,dword ptr [_deco1+4+8*edx]

; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch2oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje
        add     esi,dword ptr _evenhiscroll
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode




nndch2evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco2  +8*edx]
        mov     ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco2  +8*edx]
        mov     ebp,dword ptr [_deco2+4+8*edx]

; Loop ended for even bitplanes
        or      dword ptr [esi],eax
        or      dword ptr 4[esi],ebx
        or      dword ptr 8[esi],edi
        or      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch2evenloop
        jmp     nndch2modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndch2oddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _oddhiscroll
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode


nndch2equalloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch2equalskip2
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndch2equalskip2:
; Loop ended for all bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch2equalloop

; End of all bitplane decode

nndch2modulos:
; Add modulos
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        add     eax,esi
        add     ebx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
nndch2nowork:
        ret


public decodehi2mmx_
decodehi2mmx_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndch2mmxnowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll
        cmp     eax,dword ptr _evenhiscroll
        je      nndch2mmxoddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

        xor     eax,eax
        xor     ebx,ebx
        mov     ecx,dword ptr _bpl1pt           ; bp1
nndch2mmxoddloop:
        mov     al,byte ptr [_cmem + ecx]
        mov     bl,byte ptr [_cmem + 1 + ecx]
        add     ecx,2
        movq    mm0,[_deco1 + 8*eax]
        movq    mm1,[_deco1 + 8*ebx]
        movq    [esi],mm0
        movq    8[esi],mm1
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch2mmxoddloop
        mov     dword ptr [_bpl1pt],ecx

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje
        add     esi,dword ptr _evenhiscroll
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode




nndch2mmxevenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco2  +8*edx]
        mov     ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco2  +8*edx]
        mov     ebp,dword ptr [_deco2+4+8*edx]

; Loop ended for even bitplanes
        or      dword ptr [esi],eax
        or      dword ptr 4[esi],ebx
        or      dword ptr 8[esi],edi
        or      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch2mmxevenloop
        jmp     nndch2mmxmodulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndch2mmxoddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _oddhiscroll
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

        LOAD_BITPLANE_PTR       ecx, _bpl1pt
        LOAD_BITPLANE_PTR       edx, _bpl2pt
        SETUP_LOOP_MMX
nndch2mmxequalloop:
        LOAD_BITPLANE_WORD_MMX  ecx, _deco1
        OR_BITPLANE_WORD_MMX    edx, _deco2
        STORE_DECODED_DATA_MMX
        ITERATE_LOOP_MMX        nndch2mmxequalloop

        SAVE_BITPLANE_PTR       ecx,_bpl1pt
        SAVE_BITPLANE_PTR       edx,_bpl2pt

; End of all bitplane decode

nndch2mmxmodulos:
; Add modulos
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        add     eax,esi
        add     ebx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
nndch2mmxnowork:
        ret

public decodehi3_
decodehi3_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndch3nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll
        cmp     eax,dword ptr _evenhiscroll
        je      nndch3oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch3skip3
        mov     dl,cl
        or      eax,dword ptr [_deco3  +8*edx]
        or      ebx,dword ptr [_deco3+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco3  +8*edx]
        or      ebp,dword ptr [_deco3+4+8*edx]

nndch3skip3:

; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch3oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje
        add     esi,dword ptr _evenhiscroll
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco2  +8*edx]
        mov     ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco2  +8*edx]
        mov     ebp,dword ptr [_deco2+4+8*edx]

; Loop ended for even bitplanes
        or      dword ptr [esi],eax
        or      dword ptr 4[esi],ebx
        or      dword ptr 8[esi],edi
        or      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch3evenloop
        jmp     nndch3modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndch3oddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _oddhiscroll
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3equalloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch3equalskip2
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndch3equalskip2:
        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch3equalskip3
        mov     dl,cl
        or      eax,dword ptr [_deco3  +8*edx]
        or      ebx,dword ptr [_deco3+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco3  +8*edx]
        or      ebp,dword ptr [_deco3+4+8*edx]

nndch3equalskip3:
; Loop ended for all bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch3equalloop

; End of all bitplane decode

nndch3modulos:
; Add modulos
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        add     eax,esi
        add     ecx,esi
        add     ebx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
nndch3nowork:
        ret


public decodehi4_
decodehi4_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndch4nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll
        cmp     eax,dword ptr _evenhiscroll
        je      nndch4oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch4oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch4skip3
        mov     dl,cl
        or      eax,dword ptr [_deco3  +8*edx]
        or      ebx,dword ptr [_deco3+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco3  +8*edx]
        or      ebp,dword ptr [_deco3+4+8*edx]

nndch4skip3:

; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch4oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje
        add     esi,dword ptr _evenhiscroll
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch4evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco2  +8*edx]
        mov     ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco2  +8*edx]
        mov     ebp,dword ptr [_deco2+4+8*edx]

        mov     ecx,dword ptr _bpl4pt           ; bp4
        add     ecx,2
        mov     dword ptr _bpl4pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch4skip4
        mov     dl,cl
        or      eax,dword ptr [_deco4  +8*edx]
        or      ebx,dword ptr [_deco4+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco4  +8*edx]
        or      ebp,dword ptr [_deco4+4+8*edx]

nndch4skip4:
; Loop ended for even bitplanes
        or      dword ptr [esi],eax
        or      dword ptr 4[esi],ebx
        or      dword ptr 8[esi],edi
        or      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch4evenloop
        jmp     nndch4modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndch4oddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _oddhiscroll
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch4equalloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch4equalskip2
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndch4equalskip2:
        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch4equalskip3
        mov     dl,cl
        or      eax,dword ptr [_deco3  +8*edx]
        or      ebx,dword ptr [_deco3+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco3  +8*edx]
        or      ebp,dword ptr [_deco3+4+8*edx]

nndch4equalskip3:
        mov     ecx,dword ptr _bpl4pt           ; bp4
        add     ecx,2
        mov     dword ptr _bpl4pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch4equalskip4
        mov     dl,cl
        or      eax,dword ptr [_deco4  +8*edx]
        or      ebx,dword ptr [_deco4+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco4  +8*edx]
        or      ebp,dword ptr [_deco4+4+8*edx]

nndch4equalskip4:
; Loop ended for all bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndch4equalloop

; End of all bitplane decode

nndch4modulos:
; Add modulos
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        mov     edx,dword ptr _bpl4pt
        add     eax,esi
        add     ecx,esi
        add     ebx,edi
        add     edx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        and     edx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
        mov     dword ptr _bpl4pt,edx
nndch4nowork:
        ret


public decodedual2_
decodedual2_:
        test    dword ptr [_bplcon0],08000h
        jnz     decodedualhi2_
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndcldual2nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddscroll

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcldual2oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndcldual2oddloop

        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

; End of odd bitplane decode

; Decode even bitplanes, and write result to the linje2 array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje2
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,dword ptr _evenscroll
        xor     edx,edx
; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcldual2evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

; Loop ended for even bitplanes

        mov      dword ptr [esi],eax
        mov      dword ptr 4[esi],ebx
        mov      dword ptr 8[esi],edi
        mov      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndcldual2evenloop
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

nndcldual2modulos:
; Add modulos
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        add     eax,esi
        add     ebx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
nndcldual2nowork:
        ret


public decodedual3_
decodedual3_:
        test    dword ptr [_bplcon0],08000h
        jnz     decodedualhi3_
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndcldual3nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddscroll

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcldual3oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndcldual3skip3
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndcldual3skip3:
; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndcldual3oddloop

        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

; End of odd bitplane decode

; Decode even bitplanes, and write result to the linje2 array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje2
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,dword ptr _evenscroll
        ;xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcldual3evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

; Loop ended for even bitplanes
        ;mov     ecx,020202020h
        ;or      eax,ecx
        ;or      ebx,ecx
        ;or      edi,ecx
        ;or      ebp,ecx

        mov      dword ptr [esi],eax
        mov      dword ptr 4[esi],ebx
        mov      dword ptr 8[esi],edi
        mov      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndcldual3evenloop
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

nndcldual3modulos:
; Add modulos
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        add     eax,esi
        add     ecx,esi
        add     ebx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
nndcldual3nowork:
        ret


public decodedual4_
decodedual4_:
        test    dword ptr [_bplcon0],08000h
        jnz     decodedualhi4_
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      orgnndcldual5nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddscroll

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

orgnndcldual5oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      orgnndcldual5skip3
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

orgnndcldual5skip3:
orgnndcldual5skip5:
; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     orgnndcldual5oddloop

        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

; End of odd bitplane decode

; Decode even bitplanes, and write result to the linje2 array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje2
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,dword ptr _evenscroll
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

orgnndcldual5evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl4pt           ; bp4
        add     ecx,2
        mov     dword ptr _bpl4pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      orgnndcldual5skip4
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

orgnndcldual5skip4:
; Loop ended for even bitplanes
        ;mov     ecx,020202020h
        ;or      eax,ecx
        ;or      ebx,ecx
        ;or      edi,ecx
        ;or      ebp,ecx

        mov      dword ptr [esi],eax
        mov      dword ptr 4[esi],ebx
        mov      dword ptr 8[esi],edi
        mov      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     orgnndcldual5evenloop
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

orgnndcldual5modulos:
; Add modulos
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        mov     edx,dword ptr _bpl4pt
        add     eax,esi
        add     ecx,esi
        add     ebx,edi
        add     edx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        and     edx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
        mov     dword ptr _bpl4pt,edx
orgnndcldual5nowork:
        ret

public decodedual5_
decodedual5_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndcldual5nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddscroll

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcldual5oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndcldual5skip3
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndcldual5skip3:
        mov     ecx,dword ptr _bpl5pt           ; bp5
        add     ecx,2
        mov     dword ptr _bpl5pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndcldual5skip5
        mov     dl,cl
        or      eax,dword ptr [_deco3  +8*edx]
        or      ebx,dword ptr [_deco3+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco3  +8*edx]
        or      ebp,dword ptr [_deco3+4+8*edx]

nndcldual5skip5:
; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndcldual5oddloop

        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

; End of odd bitplane decode

; Decode even bitplanes, and write result to the linje2 array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje2
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,dword ptr _evenscroll
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcldual5evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl4pt           ; bp4
        add     ecx,2
        mov     dword ptr _bpl4pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndcldual5skip4
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndcldual5skip4:
; Loop ended for even bitplanes
        ;mov     ecx,020202020h
        ;or      eax,ecx
        ;or      ebx,ecx
        ;or      edi,ecx
        ;or      ebp,ecx

        mov      dword ptr [esi],eax
        mov      dword ptr 4[esi],ebx
        mov      dword ptr 8[esi],edi
        mov      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndcldual5evenloop
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

nndcldual5modulos:
; Add modulos
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        mov     edx,dword ptr _bpl4pt
        mov     ebp,dword ptr _bpl5pt
        add     eax,esi
        add     ecx,esi
        add     ebp,esi
        add     ebx,edi
        add     edx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        and     edx,esi
        and     ebp,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
        mov     dword ptr _bpl4pt,edx
        mov     dword ptr _bpl5pt,ebp
nndcldual5nowork:
        ret



public decodedual6_
decodedual6_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndcldual6nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddscroll

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcldual6oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndcldual6skip3
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndcldual6skip3:
        mov     ecx,dword ptr _bpl5pt           ; bp5
        add     ecx,2
        mov     dword ptr _bpl5pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndcldual6skip5
        mov     dl,cl
        or      eax,dword ptr [_deco3  +8*edx]
        or      ebx,dword ptr [_deco3+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco3  +8*edx]
        or      ebp,dword ptr [_deco3+4+8*edx]

nndcldual6skip5:
; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndcldual6oddloop

        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

; End of odd bitplane decode

; Decode even bitplanes, and write result to the linje2 array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje2
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,dword ptr _evenscroll

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndcldual6evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl4pt           ; bp4
        add     ecx,2
        mov     dword ptr _bpl4pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndcldual6skip4
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndcldual6skip4:
        mov     ecx,dword ptr _bpl6pt           ; bp6
        add     ecx,2
        mov     dword ptr _bpl6pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndcldual6skip6
        mov     dl,cl
        or      eax,dword ptr [_deco3  +8*edx]
        or      ebx,dword ptr [_deco3+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco3  +8*edx]
        or      ebp,dword ptr [_deco3+4+8*edx]

nndcldual6skip6:
; Loop ended for even bitplanes
        ;mov     ecx,020202020h
        ;or      eax,ecx
        ;or      ebx,ecx
        ;or      edi,ecx
        ;or      ebp,ecx

        mov      dword ptr [esi],eax
        mov      dword ptr 4[esi],ebx
        mov      dword ptr 8[esi],edi
        mov      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndcldual6evenloop
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

nndcldual6modulos:
; Add modulos
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        mov     edx,dword ptr _bpl4pt
        mov     ebp,dword ptr _bpl5pt
        add     eax,esi
        add     ecx,esi
        add     ebp,esi
        add     ebx,edi
        add     edx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        and     edx,esi
        and     ebp,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
        mov     dword ptr _bpl4pt,edx
        mov     dword ptr _bpl5pt,ebp
        mov     eax,dword ptr _bpl6pt
        add     eax,edi
        and     eax,esi
        mov     dword ptr _bpl6pt,eax
nndcldual6nowork:
        ret


public decodedualhi2_
decodedualhi2_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndchdual2nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndchdual2oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndchdual2oddloop

        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

; End of odd bitplane decode

; Decode even bitplanes, and write result to the linje2 array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje2
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,dword ptr _evenhiscroll
        ;xor     edx,edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndchdual2evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

; Loop ended for even bitplanes
        ;mov     ecx,020202020h
        ;or      eax,ecx
        ;or      ebx,ecx
        ;or      edi,ecx
        ;or      ebp,ecx

        mov      dword ptr [esi],eax
        mov      dword ptr 4[esi],ebx
        mov      dword ptr 8[esi],edi
        mov      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndchdual2evenloop
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

nndchdual2modulos:
; Add modulos
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        add     eax,esi
        add     ebx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
nndchdual2nowork:
        ret


public decodedualhi3_
decodedualhi3_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndchdual3nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndchdual3oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndchdual3skip3
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndchdual3skip3:
; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndchdual3oddloop

        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

; End of odd bitplane decode

; Decode even bitplanes, and write result to the linje2 array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje2
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,dword ptr _evenhiscroll

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndchdual3evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

; Loop ended for even bitplanes
        ;mov     ecx,020202020h
        ;or      eax,ecx
        ;or      ebx,ecx
        ;or      edi,ecx
        ;or      ebp,ecx

        mov      dword ptr [esi],eax
        mov      dword ptr 4[esi],ebx
        mov      dword ptr 8[esi],edi
        mov      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndchdual3evenloop
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

nndchdual3modulos:
; Add modulos
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        add     eax,esi
        add     ecx,esi
        add     ebx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
nndchdual3nowork:
        ret



public decodedualhi4_
decodedualhi4_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndchdual4nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndchdual4oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndchdual4skip3
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndchdual4skip3:
; Loop ended for odd bitplanes
        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndchdual4oddloop

        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

; End of odd bitplane decode

; Decode even bitplanes, and write result to the linje2 array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje2
        add     esi,dword ptr _DDFstartpos     ; linje position calculated
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        add     esi,dword ptr _evenhiscroll

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndchdual4evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     eax,dword ptr [_deco1  +8*edx]
        mov     ebx,dword ptr [_deco1+4+8*edx]
        mov     dl,ch
        mov     edi,dword ptr [_deco1  +8*edx]
        mov     ebp,dword ptr [_deco1+4+8*edx]

        mov     ecx,dword ptr _bpl4pt           ; bp4
        add     ecx,2
        mov     dword ptr _bpl4pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndchdual4skip4
        mov     dl,cl
        or      eax,dword ptr [_deco2  +8*edx]
        or      ebx,dword ptr [_deco2+4+8*edx]
        mov     dl,ch
        or      edi,dword ptr [_deco2  +8*edx]
        or      ebp,dword ptr [_deco2+4+8*edx]

nndchdual4skip4:
; Loop ended for even bitplanes
        ;mov     ecx,020202020h
        ;or      eax,ecx
        ;or      ebx,ecx
        ;or      edi,ecx
        ;or      ebp,ecx

        mov      dword ptr [esi],eax
        mov      dword ptr 4[esi],ebx
        mov      dword ptr 8[esi],edi
        mov      dword ptr 12[esi],ebp
        add     esi,16
        dec     dword ptr _decodetmp
        jnz     nndchdual4evenloop
        ;mov     edx,020202020h                        ; zero edx
        xor     edx,edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding

nndchdual4modulos:
; Add modulos
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        mov     edx,dword ptr _bpl4pt
        add     eax,esi
        add     ecx,esi
        add     ebx,edi
        add     edx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        and     edx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
        mov     dword ptr _bpl4pt,edx
nndchdual4nowork:
        ret


public decode320hi1_
decode320hi1_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndch1nowork320

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx              ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        shr     eax,1
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch1oddloop320:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi1+4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi1+4*edx]

; Loop ended for odd bitplanes
        mov     dword ptr [esi],edi
        mov     dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch1oddloop320

; End of odd bitplane decode

nndch1modulos320:
; Add modulos
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        mov     esi,dword ptr _bpl1mod
        mov     eax,dword ptr _bpl1pt
        add     eax,esi
        and     eax,01ffffeh
        mov     dword ptr _bpl1pt,eax
nndch1nowork320:
        ret

public decode320hi2_
decode320hi2_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndch3202nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll
        cmp     eax,dword ptr _evenhiscroll
        je      nndch3202oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx                       ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        shr     eax,1
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3202oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi1  +4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi1+4*edx]

; Loop ended for odd bitplanes
        mov     dword ptr [esi],edi
        mov     dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch3202oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje
        mov     edx,dword ptr _evenhiscroll
        shr     edx,1
        add     esi,edx
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3202evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi2  +4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi2 +4*edx]

; Loop ended for even bitplanes
        or      dword ptr [esi],edi
        or      dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch3202evenloop
        jmp     nndch3202modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndch3202oddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        mov     edx,dword ptr _oddhiscroll
        shr     edx,1
        add     esi,edx
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3202equalloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi1  +4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi1+4*edx]

        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch3202equalskip2
        mov     dl,cl
        or      edi,dword ptr [_deco320hi2  +4*edx]
        mov     dl,ch
        or      ebp,dword ptr [_deco320hi2+4*edx]

nndch3202equalskip2:
; Loop ended for all bitplanes
        mov     dword ptr [esi],edi
        mov     dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch3202equalloop

; End of all bitplane decode

nndch3202modulos:
; Add modulos
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        add     eax,esi
        add     ebx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
nndch3202nowork:
        ret


public decode320hi3_
decode320hi3_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndch3203nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll
        cmp     eax,dword ptr _evenhiscroll
        je      nndch3203oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx                       ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        shr     eax,1
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3203oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi1  +4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi1+4*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        or      edi,dword ptr [_deco320hi3  +4*edx]
        mov     dl,ch
        or      ebp,dword ptr [_deco320hi3+4*edx]

; Loop ended for odd bitplanes
        mov     dword ptr [esi],edi
        mov     dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch3203oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje
        mov     edx,dword ptr _evenhiscroll
        shr     edx,1
        add     esi,edx
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3203evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi2  +4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi2 +4*edx]

; Loop ended for even bitplanes
        or      dword ptr [esi],edi
        or      dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch3203evenloop
        jmp     nndch3203modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndch3203oddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        mov     edx,dword ptr _oddhiscroll
        shr     edx,1
        add     esi,edx
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3203equalloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi1  +4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi1+4*edx]

        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch3203equalskip2
        mov     dl,cl
        or      edi,dword ptr [_deco320hi2  +4*edx]
        mov     dl,ch
        or      ebp,dword ptr [_deco320hi2+4*edx]
nndch3203equalskip2:

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch3203equalskip3
        mov     dl,cl
        or      edi,dword ptr [_deco320hi3  +4*edx]
        mov     dl,ch
        or      ebp,dword ptr [_deco320hi3+4*edx]

nndch3203equalskip3:
; Loop ended for all bitplanes
        mov     dword ptr [esi],edi
        mov     dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch3203equalloop

; End of all bitplane decode

nndch3203modulos:
; Add modulos
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        add     eax,esi
        add     ecx,esi
        add     ebx,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
nndch3203nowork:
        ret

public decode320hi4_
decode320hi4_:
        mov     eax,dword ptr _DDFnumberofwords
        test    eax,eax
        jz      nndch3204nowork

        mov     dword ptr _decodetmp,eax

        mov     eax,dword ptr _oddhiscroll
        cmp     eax,dword ptr _evenhiscroll
        je      nndch3204oddevenequal

; The case when odd and even scroll is different

; Decode odd bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx                       ; linje position calculated
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        shr     eax,1
        add     esi,eax                        ; Oddscroll, from test

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3204oddloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi1  +4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi1+4*edx]

        mov     ecx,dword ptr _bpl3pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        or      edi,dword ptr [_deco320hi3  +4*edx]
        mov     dl,ch
        or      ebp,dword ptr [_deco320hi3+4*edx]

; Loop ended for odd bitplanes
        mov     dword ptr [esi],edi
        mov     dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch3204oddloop

; End of odd bitplane decode

; Decode even bitplanes, and OR result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     eax,dword ptr _DDFnumberofwords
        mov     dword ptr _decodetmp,eax
        mov     esi,offset _linje
        mov     edx,dword ptr _evenhiscroll
        shr     edx,1
        add     esi,edx
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3204evenloop:
        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi2  +4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi2 +4*edx]


        mov     ecx,dword ptr _bpl4pt           ; bp4
        add     ecx,2
        mov     dword ptr _bpl4pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        or      edi,dword ptr [_deco320hi4  +4*edx]
        mov     dl,ch
        or      ebp,dword ptr [_deco320hi4+4*edx]

; Loop ended for even bitplanes
        or      dword ptr [esi],edi
        or      dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch3204evenloop
        jmp     nndch3204modulos

; End of even bitplane decode

; The case when odd and even scroll is equal

nndch3204oddevenequal:


; Decode all bitplanes, and write result to the line array,
; eax - pixel 0-3
; ebx - pixel 4-7
; edi - pixel 8-11
; ebp - pixel 12-15
; edx - index to decodetable
; ecx - intermediate data word variable, and pointer to bitplane
; esi - pointer to line array with scroll and position added 
; Variable decodetmp counts words left to decode


; Setup loop, calculate position of playfield start in line array
        mov     esi,offset _linje
        mov     edx,dword ptr _oddhiscroll
        shr     edx,1
        add     esi,edx
        mov     edx,dword ptr _DDFstartpos
        shr     edx,1
        add     esi,edx     ; linje position calculated
        xor     edx,edx                        ; zero edx

; Loop:  Get bitplane word, decode it to the registers
;         Repeat for all involved bitplanes
;         Loop until no more data words to decode

nndch3204equalloop:
        mov     ecx,dword ptr _bpl1pt           ; bp1
        add     ecx,2
        mov     dword ptr _bpl1pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        mov     dl,cl
        mov     edi,dword ptr [_deco320hi1  +4*edx]
        mov     dl,ch
        mov     ebp,dword ptr [_deco320hi1+4*edx]

        mov     ecx,dword ptr _bpl2pt           ; bp2
        add     ecx,2
        mov     dword ptr _bpl2pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch3204equalskip2
        mov     dl,cl
        or      edi,dword ptr [_deco320hi2  +4*edx]
        mov     dl,ch
        or      ebp,dword ptr [_deco320hi2+4*edx]
nndch3204equalskip2:

        mov     ecx,dword ptr _bpl3pt           ; bp3
        add     ecx,2
        mov     dword ptr _bpl3pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch3204equalskip3
        mov     dl,cl
        or      edi,dword ptr [_deco320hi3  +4*edx]
        mov     dl,ch
        or      ebp,dword ptr [_deco320hi3+4*edx]

nndch3204equalskip3:
        mov     ecx,dword ptr _bpl4pt           ; bp4
        add     ecx,2
        mov     dword ptr _bpl4pt,ecx
        mov     ecx,dword ptr _cmem-2[ecx]
        test    cx,cx
        jz      nndch3204equalskip4
        mov     dl,cl
        or      edi,dword ptr [_deco320hi4  +4*edx]
        mov     dl,ch
        or      ebp,dword ptr [_deco320hi4+4*edx]

nndch3204equalskip4:
; Loop ended for all bitplanes
        mov     dword ptr [esi],edi
        mov     dword ptr 4[esi],ebp
        add     esi,8
        dec     dword ptr _decodetmp
        jnz     nndch3204equalloop

; End of all bitplane decode

nndch3204modulos:
; Add modulos
        xor     edx,edx                        ; zero edx
        mov     dword ptr [esi],edx             ; Do some padding
        mov     dword ptr 4[esi],edx             ; Do some padding
        mov     dword ptr 8[esi],edx             ; Do some padding
        mov     dword ptr 12[esi],edx             ; Do some padding
        mov     esi,dword ptr _bpl1mod
        mov     edi,dword ptr _bpl2mod
        mov     eax,dword ptr _bpl1pt
        mov     ebx,dword ptr _bpl2pt
        mov     ecx,dword ptr _bpl3pt
        mov     ebp,dword ptr _bpl4pt
        add     eax,esi
        add     ecx,esi
        add     ebx,edi
        add     ebp,edi
        mov     esi,01ffffeh
        and     eax,esi
        and     ebx,esi
        and     ecx,esi
        and     ebp,esi
        mov     dword ptr _bpl1pt,eax
        mov     dword ptr _bpl2pt,ebx
        mov     dword ptr _bpl3pt,ecx
        mov     dword ptr _bpl4pt,ebp
nndch3204nowork:
        ret

                        align   4

public decodedual320hi2_
decodedual320hi2_:      mov     eax,[_DDFnumberofwords]
                        test    eax,eax
                        jz      nndcdh3202nowork
                        mov     [_decodetmp],eax
                        mov     esi,offset _linje          ; odd
                        mov     edx,dword ptr _DDFstartpos
                        shr     edx,1
                        add     esi,edx                       ; linje position calculated
                        xor     edx,edx                        ; zero edx
                        mov     dword ptr [esi],edx             ; Do some padding
                        mov     dword ptr 4[esi],edx             ; Do some padding
                        mov     dword ptr 8[esi],edx             ; Do some padding
                        mov     dword ptr 12[esi],edx             ; Do some padding
                        shr     eax,1
                        add     esi,[_oddhiscroll]
nndcdh3202oddloop:      mov     ecx,dword ptr _bpl1pt           ; bp1
                        add     ecx,2
                        mov     dword ptr _bpl1pt,ecx
                        mov     ecx,dword ptr _cmem-2[ecx]
                        mov     dl,cl
                        mov     edi,dword ptr [_deco320hi1  +4*edx]
                        mov     dl,ch
                        mov     ebp,dword ptr [_deco320hi1+4*edx]
                        mov     dword ptr [esi],edi
                        mov     dword ptr 4[esi],ebp
                        add     esi,8
                        dec     dword ptr _decodetmp
                        jnz     nndcdh3202oddloop
                        mov     eax,dword ptr _DDFnumberofwords
                        mov     dword ptr _decodetmp,eax
                        mov     esi,offset _linje2
                        mov     edx,dword ptr _evenhiscroll
                        shr     edx,1
                        add     esi,edx
                        mov     edx,dword ptr _DDFstartpos
                        shr     edx,1
                        add     esi,edx     ; linje position calculated
                        xor     edx,edx                        ; zero edx
nndcdh3202evenloop:     mov     ecx,dword ptr _bpl2pt           ; bp2
                        add     ecx,2
                        mov     dword ptr _bpl2pt,ecx
                        mov     ecx,dword ptr _cmem-2[ecx]
                        mov     dl,cl
                        mov     edi,dword ptr [_deco320hi2  +4*edx]
                        mov     dl,ch
                        mov     ebp,dword ptr [_deco320hi2 +4*edx]
                        or      dword ptr [esi],edi
                        or      dword ptr 4[esi],ebp
                        add     esi,8
                        dec     dword ptr _decodetmp
                        jnz     nndcdh3202evenloop
nndcdh3202modulos:      xor     edx,edx                        ; zero edx
                        mov     dword ptr [esi],edx             ; Do some padding
                        mov     dword ptr 4[esi],edx             ; Do some padding
                        mov     dword ptr 8[esi],edx             ; Do some padding
                        mov     dword ptr 12[esi],edx             ; Do some padding
                        mov     esi,dword ptr _bpl1mod
                        mov     edi,dword ptr _bpl2mod
                        mov     eax,dword ptr _bpl1pt
                        mov     ebx,dword ptr _bpl2pt
                        add     eax,esi
                        add     ebx,edi
                        mov     esi,01ffffeh
                        and     eax,esi
                        and     ebx,esi
                        mov     dword ptr _bpl1pt,eax
                        mov     dword ptr _bpl2pt,ebx
nndcdh3202nowork:       ret


                        align   4

public decodedual320hi3_
decodedual320hi3_:      mov     eax,[_DDFnumberofwords]
                        test    eax,eax
                        jz      nndcdh3203nowork
                        mov     [_decodetmp],eax
                        mov     esi,offset _linje          ; odd
                        mov     edx,dword ptr _DDFstartpos
                        shr     edx,1
                        add     esi,edx                       ; linje position calculated
                        xor     edx,edx                        ; zero edx
                        mov     dword ptr [esi],edx             ; Do some padding
                        mov     dword ptr 4[esi],edx             ; Do some padding
                        mov     dword ptr 8[esi],edx             ; Do some padding
                        mov     dword ptr 12[esi],edx             ; Do some padding
                        shr     eax,1
                        add     esi,[_oddhiscroll]
nndcdh3203oddloop:      mov     ecx,dword ptr _bpl1pt           ; bp1
                        add     ecx,2
                        mov     dword ptr _bpl1pt,ecx
                        mov     ecx,dword ptr _cmem-2[ecx]
                        mov     dl,cl
                        mov     edi,dword ptr [_deco320hi1  +4*edx]
                        mov     dl,ch
                        mov     ebp,dword ptr [_deco320hi1+4*edx]
                        mov     ecx,dword ptr _bpl3pt           ; bp1
                        add     ecx,2
                        mov     dword ptr _bpl3pt,ecx
                        mov     ecx,dword ptr _cmem-2[ecx]
                        mov     dl,cl
                        or      edi,dword ptr [_deco320hi3  +4*edx]
                        mov     dl,ch
                        or      ebp,dword ptr [_deco320hi3+4*edx]
                        mov     dword ptr [esi],edi
                        mov     dword ptr 4[esi],ebp
                        add     esi,8
                        dec     dword ptr _decodetmp
                        jnz     nndcdh3203oddloop
                        mov     eax,dword ptr _DDFnumberofwords
                        mov     dword ptr _decodetmp,eax
                        mov     esi,offset _linje2
                        mov     edx,dword ptr _evenhiscroll
                        shr     edx,1
                        add     esi,edx
                        mov     edx,dword ptr _DDFstartpos
                        shr     edx,1
                        add     esi,edx     ; linje position calculated
                        xor     edx,edx                        ; zero edx
nndcdh3203evenloop:     mov     ecx,dword ptr _bpl2pt           ; bp2
                        add     ecx,2
                        mov     dword ptr _bpl2pt,ecx
                        mov     ecx,dword ptr _cmem-2[ecx]
                        mov     dl,cl
                        mov     edi,dword ptr [_deco320hi2  +4*edx]
                        mov     dl,ch
                        mov     ebp,dword ptr [_deco320hi2 +4*edx]
                        or      dword ptr [esi],edi
                        or      dword ptr 4[esi],ebp
                        add     esi,8
                        dec     dword ptr _decodetmp
                        jnz     nndcdh3203evenloop
nndcdh3203modulos:      xor     edx,edx                        ; zero edx
                        mov     dword ptr [esi],edx             ; Do some padding
                        mov     dword ptr 4[esi],edx             ; Do some padding
                        mov     dword ptr 8[esi],edx             ; Do some padding
                        mov     dword ptr 12[esi],edx             ; Do some padding
                        mov     esi,dword ptr _bpl1mod
                        mov     edi,dword ptr _bpl2mod
                        mov     eax,dword ptr _bpl1pt
                        mov     ebx,dword ptr _bpl2pt
                        mov     ecx,dword ptr _bpl3pt
                        add     eax,esi
                        add     ecx,esi
                        add     ebx,edi
                        mov     esi,01ffffeh
                        and     eax,esi
                        and     ebx,esi
                        and     ecx,esi
                        mov     dword ptr _bpl1pt,eax
                        mov     dword ptr _bpl2pt,ebx
                        mov     dword ptr _bpl3pt,ecx
nndcdh3203nowork:       ret


                        align   4

public decodedual320hi4_
decodedual320hi4_:      mov     eax,[_DDFnumberofwords]
                        test    eax,eax
                        jz      nndcdh3204nowork
                        mov     [_decodetmp],eax
                        mov     esi,offset _linje          ; odd
                        mov     edx,dword ptr _DDFstartpos
                        shr     edx,1
                        add     esi,edx                       ; linje position calculated
                        xor     edx,edx                        ; zero edx
                        mov     dword ptr [esi],edx             ; Do some padding
                        mov     dword ptr 4[esi],edx             ; Do some padding
                        mov     dword ptr 8[esi],edx             ; Do some padding
                        mov     dword ptr 12[esi],edx             ; Do some padding
                        shr     eax,1
                        add     esi,[_oddhiscroll]
nndcdh3204oddloop:      mov     ecx,dword ptr _bpl1pt           ; bp1
                        add     ecx,2
                        mov     dword ptr _bpl1pt,ecx
                        mov     ecx,dword ptr _cmem-2[ecx]
                        mov     dl,cl
                        mov     edi,dword ptr [_deco320hi1  +4*edx]
                        mov     dl,ch
                        mov     ebp,dword ptr [_deco320hi1+4*edx]
                        mov     ecx,dword ptr _bpl3pt           ; bp1
                        add     ecx,2
                        mov     dword ptr _bpl3pt,ecx
                        mov     ecx,dword ptr _cmem-2[ecx]
                        mov     dl,cl
                        or      edi,dword ptr [_deco320hi3  +4*edx]
                        mov     dl,ch
                        or      ebp,dword ptr [_deco320hi3+4*edx]
                        mov     dword ptr [esi],edi
                        mov     dword ptr 4[esi],ebp
                        add     esi,8
                        dec     dword ptr _decodetmp
                        jnz     nndcdh3204oddloop
                        mov     eax,dword ptr _DDFnumberofwords
                        mov     dword ptr _decodetmp,eax
                        mov     esi,offset _linje2
                        mov     edx,dword ptr _evenhiscroll
                        shr     edx,1
                        add     esi,edx
                        mov     edx,dword ptr _DDFstartpos
                        shr     edx,1
                        add     esi,edx     ; linje position calculated
                        xor     edx,edx                        ; zero edx
nndcdh3204evenloop:     mov     ecx,dword ptr _bpl2pt           ; bp2
                        add     ecx,2
                        mov     dword ptr _bpl2pt,ecx
                        mov     ecx,dword ptr _cmem-2[ecx]
                        mov     dl,cl
                        mov     edi,dword ptr [_deco320hi2  +4*edx]
                        mov     dl,ch
                        mov     ebp,dword ptr [_deco320hi2 +4*edx]
                        mov     ecx,dword ptr _bpl4pt           ; bp4
                        add     ecx,2
                        mov     dword ptr _bpl4pt,ecx
                        mov     ecx,dword ptr _cmem-2[ecx]
                        mov     dl,cl
                        or      edi,dword ptr [_deco320hi4  +4*edx]
                        mov     dl,ch
                        or      ebp,dword ptr [_deco320hi4+4*edx]
                        or      dword ptr [esi],edi
                        or      dword ptr 4[esi],ebp
                        add     esi,8
                        dec     dword ptr _decodetmp
                        jnz     nndcdh3204evenloop
nndcdh3204modulos:      xor     edx,edx                        ; zero edx
                        mov     dword ptr [esi],edx             ; Do some padding
                        mov     dword ptr 4[esi],edx             ; Do some padding
                        mov     dword ptr 8[esi],edx             ; Do some padding
                        mov     dword ptr 12[esi],edx             ; Do some padding
                        mov     esi,dword ptr _bpl1mod
                        mov     edi,dword ptr _bpl2mod
                        mov     eax,dword ptr _bpl1pt
                        mov     ebx,dword ptr _bpl2pt
                        mov     ecx,dword ptr _bpl3pt
                        mov     ebp,dword ptr _bpl4pt
                        add     eax,esi
                        add     ecx,esi
                        add     ebx,edi
                        add     ebp,edi
                        mov     esi,01ffffeh
                        and     eax,esi
                        and     ebx,esi
                        and     ecx,esi
                        and     ebp,esi
                        mov     dword ptr _bpl1pt,eax
                        mov     dword ptr _bpl2pt,ebx
                        mov     dword ptr _bpl3pt,ecx
                        mov     dword ptr _bpl4pt,ebp
nndcdh3204nowork:       ret



#endif

_TEXT ends

_DATA segment dword public 'DATA'

include data\chip.inc
include data\memory.inc
include data\inout.inc
include data\fellow.inc
include data\graphem.inc

_DATA ends

_BSS segment dword public 'DATA'
_BSS ends

end


