        .586p
DGROUP group _DATA,_BSS
_TEXT  segment dword public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

; Petter Schau 1996

include defs.inc
include func\memory.inc
include func\inout.inc
include func\chip.inc
include func\sound.inc
include func\floppy.inc

#ifdef DEBUGBUILD
include eventid.inc
#endif

include mac\drawmode.mac
include mac\memory.mac



extrn dmainittransfer_:near
extrn dmastarttransfer_:near
extrn drawddfline_:near

extrn print_emuspeed_:near

#ifdef PREFETCH

; Load prefetch word from PC
; Called at reset, irq, exception and jumps

; edx - PC to prefetch

                        align   4

public prefetch_fill_
prefetch_fill_:         push    ecx
                        push    edx
                        mov     ecx,edx
                        fetchw
                        mov     word ptr [_prefetch_word],dx
                        pop     edx
                        pop     ecx
                        ret

#endif

; Fixes a weird thing the compiler does

public fix_a7pointer_
fix_a7pointer_:
       push     eax
       lea      eax,[_a+28]
       mov      dword ptr _a7pointer,eax
       pop      eax
       ret


public i07_B_1_                 ; X
public i07_W_1_                 ; X
public i07_L_1_                 ; X
public i07_B_2_                 ; X
public i07_W_2_                 ; X
public i07_L_2_                 ; X
public i08_B_                   ; X
public i08_W_                   ; X
public i08_L_                   ; X
public i08_B_CCR_               ; X
public i08_W_SR_                ; X
public i09_RI_I_B_              ; X
public i09_LE_I_B_              ; X
public i09_RI_I_W_              ; X
public i09_LE_I_W_              ; X
public i09_RI_I_L_              ; X
public i09_LE_I_L_              ; X
public i09_RI_R_B_              ; X
public i09_LE_R_B_              ; X
public i09_RI_R_W_              ; X
public i09_LE_R_W_              ; X
public i09_RI_R_L_              ; X
public i09_LE_R_L_              ; X
public i09_RI_M_W_              ; X
public i09_LE_M_W_              ; X
public i12_D_L_                 ; X
public i12_D_B_                 ; X
public i12_S_L_                 ; X
public i12_S_B_                 ; X
public i13_D_L_                 ; X
public i13_D_B_                 ; X
public i13_S_L_                 ; X
public i13_S_B_                 ; X
public i15_D_L_                 ; X
public i15_D_B_                 ; X
public i15_S_L_                 ; X
public i15_S_B_                 ; X
public i17_D_L_                 ; X
public i17_D_B_                 ; X
public i17_S_L_                 ; X
public i17_S_B_                 ; X
public i18_                     ; X
public i19_                     ; X
public i20_B_                   ; X
public i20_W_                   ; X
public i20_L_                   ; X
public i21_W_                   ; X
public i21_L_                   ; X
public i22_B_                   ; X
public i22_W_                   ; X
public i22_L_                   ; X
public i23_B_                   ; X
public i23_W_                   ; X
public i23_L_                   ; X
public i24_                     ; X
public i25_                     ; X
public i26_                     ; X
public i27_B_                   ; X
public i27_W_                   ; X
public i27_L_                   ; X
public i28_B_                   ; X
public i28_W_                   ; X
public i28_L_                   ; X
public i28_B_CCR_               ; X
public i28_W_SR_                ; X
public i29_                     ; X
public i30_W_                   ; X
public i30_L_                   ; X
public i33_                     ; X
public i34_                     ; X
public i35_RI_I_B_              ; X
public i35_LE_I_B_              ; X
public i35_RI_I_W_              ; X
public i35_LE_I_W_              ; X
public i35_RI_I_L_              ; X
public i35_LE_I_L_              ; X
public i35_RI_R_B_              ; X
public i35_LE_R_B_              ; X
public i35_RI_R_W_              ; X
public i35_LE_R_W_              ; X
public i35_RI_R_L_              ; X
public i35_LE_R_L_              ; X
public i35_RI_M_W_              ; X
public i35_LE_M_W_              ; X
public i38_                     ; X
public i39_                     ; X
public i40_                     ; X
public i41_1_                   ; X
public i41_2_                   ; X
public i42_W_                   ; X
public i42_L_                   ; X
public i43_W_PREM_
public i43_W_POSTR_
public i43_W_CONM_
public i43_W_CONR_
public i43_L_PREM_
public i43_L_POSTR_
public i43_L_CONM_
public i43_L_CONR_
public i44_W_1_                     ; X
public i44_L_1_                     ; X
public i44_W_2_                     ; X
public i44_L_2_                     ; X
public i45_                     ; X
public i46_                     ; X
public i47_                     ; X
public i48_B_                   ; X
public i49_B_                   ; X
public i49_W_                   ; X
public i49_L_                   ; X
public i52_B_                   ; X
public i52_W_                   ; X
public i52_L_                   ; X
public i53_B_1_                 ; X
public i53_W_1_                 ; X
public i53_L_1_                 ; X
public i53_B_2_                 ; X
public i53_W_2_                 ; X
public i53_L_2_                 ; X
public i54_B_                   ; X
public i54_W_                   ; X
public i54_L_                   ; X
public i54_B_CCR_               ; X
public i54_W_SR_                ; X
public i55_                     ; X
public i56_                     ; X
public i57_RI_I_B_              ; X
public i57_LE_I_B_              ; X
public i57_RI_I_W_              ; X
public i57_LE_I_W_              ; X
public i57_RI_I_L_              ; X
public i57_LE_I_L_              ; X
public i57_RI_R_B_              ; X
public i57_LE_R_B_              ; X
public i57_RI_R_W_              ; X
public i57_LE_R_W_              ; X
public i57_RI_R_L_              ; X
public i57_LE_R_L_              ; X
public i57_RI_M_W_              ; X
public i57_LE_M_W_              ; X
public i59_RI_I_B_              ; X
public i59_LE_I_B_              ; X
public i59_RI_I_W_              ; X
public i59_LE_I_W_              ; X
public i59_RI_I_L_              ; X
public i59_LE_I_L_              ; X
public i59_RI_R_B_              ; X
public i59_LE_R_B_              ; X
public i59_RI_R_W_              ; X
public i59_LE_R_W_              ; X
public i59_RI_R_L_              ; X
public i59_LE_R_L_              ; X
public i59_RI_M_W_              ; X
public i59_LE_M_W_              ; X
public i64_1_                   ; X
public i64_2_                   ; X
public i65_                     ; X
public i66_                     ; X
public i67_B_1_                 ; X
public i67_W_1_                 ; X
public i67_L_1_                 ; X
public i67_B_2_                 ; X
public i67_W_2_                 ; X
public i67_L_2_                 ; X
public i68_W_                   ; X
public i68_L_                   ; X
public i69_B_                   ; X
public i69_W_                   ; X
public i69_L_                   ; X
public i70_B_                   ; X
public i70_W_                   ; X
public i70_L_                   ; X
public i70_ADR_                 ; X
public i72_                     ; X
public i73_                     ; X
public i76_B_                   ; X
public i76_W_                   ; X
public i76_L_                   ; X


; Takes new SR in edx and maintains the integrity of the super/user state
; I think this one is OK
; BUG, when an interrupt is waiting, and the irq-level becomes 7,
; the waiting irq is lost, added a fix for it,
; simply cancel the irq and let it be reissued when the irq-level
; comes down again.

                        align   4

updateSR:               and     edx,0ffffh
                        mov     ecx,[_a+28]    ; Get current stack pointer
                        test    byte ptr [_sr+1],20h     ; Are we in super mode?
                        jnz     upsup
                        mov     [_usp],ecx     ; No, save current stack pointer to usp
                        jmp     upd2
upsup:                  mov     [_ssp],ecx     ; Yes, save current stack pointer to ssp
upd2:                   test    dh,20h                   ; Check new super/user mode
                        jnz     upsup2
                        mov     ecx,[_usp]     ; New mode is user, get usp
                        jmp     upd3
upsup2:                 mov     ecx,[_ssp]     ; New mode is super, get ssp
upd3:                   mov     [_a+28],ecx    ; Set new stack pointer
                        mov     [_sr],edx      ; Set new SR
                        cmp     dword ptr [_interruptflag],1
                        jne     upd4
                        cmp     dword ptr [_cpustopflag],1
                        je      upd4
                        ; Here irq is scheduled, cancel and search for new
                        mov     dword ptr [_interruptflag],0
upd4:                   call    raise_interrupt_         ; Waiting interrupts might run now
                        ret

	align   4

; No parameters, just checking for waiting interrupts
; Sets a flag, _interruptswaiting, the interrupt is set up before the 
; next instruction starts.  _interruptlevel and _interruptaddress is also set
; if cpu is stopper, set up irq immediately

public raise_interrupt_
raise_interrupt_:
	pushad
        cmp     dword ptr _interruptflag,1  ; Race condition detection
        jne     rinz
        cmp     dword ptr _cpustopflag,1
        jne     rinend

rinz:
	mov     eax,dword ptr _intreq   ; get interrupt requests
	shl     eax,1                   ; Put NMI bit on top (unmaskable)
	mov     ebx,15                  ; Current interrupt level (15)
rin1:   shl     ax,1                    ; Shift bit into Carry bit
	jc      rinout                  ; Bit set???
	dec     ebx                     ; No, check next bit, decrease level
	jnz     rin1                    ; Loop if not at level 0
	jmp     rinend                  ; Finished, no interrupts are waiting
rinout: dec     ebx                     ; Decrease level to get bit number of interrupt
	mov     ecx,dword ptr [_int2int+ebx*4] ; Get base vector nr for this interrupt
	bt      word ptr _intena,bx     ; Is this interrupt enabled?
        jc      rin2                    ; If not, back to checking for lower interrupts
        test    ebx,ebx
        jnz     rin1
        jmp     rinend
rin2:
	mov     eax,dword ptr _sr       ; Get SR
        and     eax,00000700h           ; Extract runlevel
	shr     eax,8
	cmp     eax,ecx                 ; Check interrupt against current runlevel
	jae     rinend                  ; Exit, SR is higher, remaining ints won't run
                                        ; Now have a valid interrupt, get vector adress

#ifdef DEBUGBUILD
; Log code from here
        mov     eax,dword ptr _loglast
        and     eax,EVENTMASK
        shl     eax,6

        cmp     ebx,0     ; Check if log is enabled for these IRQs
        jne     jup1
        cmp     dword ptr _logserialtransmitbufferemptyirq,1
        jne     jupnei
        mov     ebx,IRQ1_0_TBE
        jmp     jupja
jup1:   cmp     ebx,1
        jne     jup2
        cmp     dword ptr _logdiskdmatransferdoneirq,1
        jne     jupnei
        mov     ebx,IRQ1_1_DSKBLK
        jmp     jupja
jup2:   cmp     ebx,2
        jne     jup3
        cmp     dword ptr _logsoftwareirq,1
        jne     jupnei
        mov     ebx,IRQ1_2_SOFT
        jmp     jupja
jup3:   cmp     ebx,3
        jne     jup4
        cmp     dword ptr _logciaairq,1
        jne     jupnei
        mov     ebx,IRQ2_CIAA
        jmp     jupja
jup4:   cmp     ebx,4
        jne     jup5
        cmp     dword ptr _logcopperirq,1
        jne     jupnei
        mov     ebx,IRQ3_0_COPPER
        jmp     jupja
jup5:   cmp     ebx,5
        jne     jup6
        cmp     dword ptr _logverticalblankirq,1
        jne     jupnei
        mov     ebx,IRQ3_1_VBL
        jmp     jupja
jup6:   cmp     ebx,6
        jne     jup7
        cmp     dword ptr _logblitterreadyirq,1
        jne     jupnei
        mov     ebx,IRQ3_2_BLIT
        jmp     jupja
jup7:   cmp     ebx,7
        jne     jup8
        cmp     dword ptr _logaudioirq,1
        jne     jupnei
        mov     ebx,IRQ4_AUD
        jmp     jupja
jup8:   cmp     ebx,8
        jne     jup9
        cmp     dword ptr _logaudioirq,1
        jne     jupnei
        mov     ebx,IRQ4_AUD
        jmp     jupja
jup9:   cmp     ebx,9
        jne     jup10
        cmp     dword ptr _logaudioirq,1
        jne     jupnei
        mov     ebx,IRQ4_AUD
        jmp     jupja
jup10:  cmp     ebx,10
        jne     jup11
        cmp     dword ptr _logaudioirq,1
        jne     jupnei
        mov     ebx,IRQ4_AUD
        jmp     jupja
jup11:  cmp     ebx,11
        jne     jup12
        cmp     dword ptr _logserialreceivebufferfullirq,1
        jne     jupnei
        mov     ebx,IRQ5_0_RBF
        jmp     jupja
jup12:  cmp     ebx,12
        jne     jup13
        cmp     dword ptr _logdisksyncvaluerecognizedirq,1
        jne     jupnei
        mov     ebx,IRQ5_1_DSKSYN
        jmp     jupja
jup13:  cmp     ebx,13
        jne     jup14
        cmp     dword ptr _logciabirq,1
        jne     jupnei
        mov     ebx,IRQ6_0_CIAB
jup14:
jupja:  ; Jump here when log is enabled
        mov     dword ptr _logbuffer[eax],ebx
	mov     ebx,dword ptr _frames
        mov     dword ptr _logbuffer+4[eax],ebx
	mov     ebx,dword ptr _ypos
        mov     dword ptr _logbuffer+8[eax],ebx
	mov     ebx,dword ptr _xpos
        mov     dword ptr _logbuffer+12[eax],ebx
        mov     ebx,dword ptr _pc
        mov     dword ptr _logbuffer+16[eax],ebx
        inc     dword ptr _loglast
        mov     ebx,dword ptr _loglast
        sub     ebx,dword ptr _logfirst
        cmp     ebx,EVENTCOUNT
        jne     jupnei
        inc     dword ptr _logfirst
jupnei:    ; Exit point when logging isnt enabled
; Log code ended here
#endif

        lea     ebx,[060h+ecx*4]
        mov     dword ptr _interruptlevel,ecx
	mov     edx,dword ptr _cmem[ebx]
	bswap   edx
        mov     dword ptr _interruptaddress,edx
	mov     dword ptr _interruptflag,1
        cmp     dword ptr _cpustopflag,1
        jne     rinnostop
        mov     dword ptr _interruptcyclesleft,1
        mov     dword ptr _cpustopflag,0
        jmp     rinend
rinnostop:
        mov     dword ptr _interruptcyclesleft,8
rinend: popad
	ret


                        align   4

public set_up_interrupt_
set_up_interrupt_:      mov     ecx,dword ptr [_a+28]    ; get stack pointer
                        test    byte ptr [_sr+1],20h     ; Check if we are in super mode
                        jnz     pisuper                  ; If not, save stack pointer to usp and get ssp
                        mov     dword ptr _usp,ecx       ; Save usp
                        mov     ecx,dword ptr _ssp       ; Get ssp
pisuper:                sub     ecx,4
                        mov     edx,dword ptr _pc
                        writel                     ; Save pc to stack
                        mov     edx,dword ptr _sr
                        sub     ecx,2                                     ; Save _sr to stack
                        mov     dword ptr [_a+28],ecx                      ; Set A7 to SSP
                        writew
                        mov     edx,dword ptr _interruptaddress
                        mov     dword ptr _pc,edx      ; Set PC, 
                        mov     edx,dword ptr _sr
                        and     edx,0fffff0ffh
                        mov     ecx,dword ptr _interruptlevel
                        shl     ecx,8
                        and     ecx,0700h
                        or      edx,ecx
                        or      edx,2000h
                        mov     dword ptr _sr,edx
                        mov     dword ptr _interruptflag,0
#ifdef PREFETCH
                        mov     edx,dword ptr [_pc]
                        call    prefetch_fill_
#endif
                        ret

	



; Sets up an exception - ebx - adress of vector


				align   4

public prepare_exception_
prepare_exception_:             push    eax

#ifdef DEBUGBUILD
				push	ebx
				mov	eax,[_loglast]
				and	eax,EVENTMASK
				shl	eax,6
				cmp	ebx,08h
				jne	eup1
				cmp	byte ptr [_logbuserrorex],1
				jne	eupnei
				mov	ebx,EXBUSERROR
				jmp	eupja
eup1:				cmp	ebx,0ch
				jne	eup2
				cmp	byte ptr [_logoddaddressex],1
				jne	eupnei
				mov	ebx,EXODDADDRESS
				jmp	eupja
eup2:				cmp	ebx,010h 
				jne	eup3
				cmp	byte ptr [_logillegalinstructionex],1
				jne	eupnei
				mov	ebx,EXILLEGAL
				jmp	eupja
eup3:				cmp	ebx,014h
                                jne     eup6
				cmp	byte ptr [_logdivisionby0ex],1
				jne	eupnei
				mov	ebx,EXDIVBYZERO
				jmp	eupja
eup6:				cmp	ebx,020h
				jne	eup7
				cmp	byte ptr [_logprivilegieviolationex],1
				jne 	eupnei
				mov	ebx,EXPRIV
				jmp	eupja
eup7:				cmp	ebx,080h
				jbe	eupnei
				cmp	ebx,0bch
				ja	eupnei
				cmp	byte ptr [_logtrapex],1
				jne	eupnei
				mov	[_logbuffer+20+eax],ebx
				mov	ebx,EXTRAP
eupja:                          mov     [_logbuffer+eax],ebx
				mov	ebx,[_frames]
				mov	[_logbuffer+4+eax],ebx
				mov	ebx,[_ypos]
				mov	[_logbuffer+8+eax],ebx
				mov	ebx,[_xpos]
				mov	[_logbuffer+12+eax],ebx
				mov	ebx,[_pc]
				mov	[_logbuffer+16+eax],ebx
                                inc     dword ptr [_loglast]
				mov	ebx,[_loglast]
				sub	ebx,[_logfirst]
				cmp	ebx,EVENTCOUNT
				jne	eupnei
                                inc     dword ptr [_logfirst]
eupnei:                         pop     ebx
#endif

				mov	ecx,[_a+28]				; get stack pointer
				test	byte ptr [_sr+1],20h		; Check if we are in super mode
				jnz	pesuper				; If not, save stack pointer to usp and get ssp
				mov	[_usp],ecx				; Save usp
				mov	ecx,[_ssp]				; Get ssp
pesuper:                        test    cl,1
				jnz	really_messed_up_now
				cmp	ebx,8
				je	prenoac
				cmp	ebx,12
				jne	prenoab
prenoac:			sub	ecx,8					; These words should contain something
prenoab:			sub	ecx,4
				mov	edx,esi
        			mov	[_a+28],ecx				; Set A7 to SSP
				writel					; Save pc to stack
				mov	ecx,[_a+28]				; Set A7 to SSP
				mov	edx,[_sr]
				sub	ecx,2					; Save _sr to stack
				mov	[_a+28],ecx				; Set A7 to SSP
				writew
				mov	ecx,[_cmem+ebx]
				bswap	ecx
				mov	[_pc],ecx				; Set PC, 
				or	byte ptr [_sr+1],20h		; Set supermodus
                                and     byte ptr [_sr+1],03fh
                                mov     dword ptr [_cpustopflag],0
				pop	eax
				mov	esp,[_exceptionstack]
#ifdef PREFETCH
                                mov     edx,dword ptr [_pc]
                                call    prefetch_fill_
#endif
                                jmp     dword ptr [_exceptionbackdooraddress]
really_messed_up_now:           pop     eax
                                mov     dword ptr [_debugging],1
                                jmp     dword ptr [_exceptionbackdooraddress]


; Konvensjon: Alle ixxxx inst returnerer cycles i eax

	align   4

;
; Adressmode routines to read byte,word,longword
; With PC increase
; Parameters:  In:  edx - pointer to register   esi - current PC position     
;             Out:  edx - result                esi - current PC position
;

; Dx        read
; --------------
; Ax        read
; --------------


                align   4

public arb00_
public arw00_
public arl00_
public arw01_
public arl01_

arb00_:
arw00_:
arl00_:
arw01_:
arl01_:         mov     edx,dword ptr [edx]             
                ret                                     
						

; (Ax)      read
; --------------


                align   4

public arl02_
arl02_:         mov     ecx,dword ptr [edx]
                jmp     fetl


                align   4

public arw02_
arw02_:         mov     ecx,dword ptr [edx]
                jmp     fetw


                align   4

public arb02_
arb02_:         mov     ecx,dword ptr [edx]
                jmp     fetb


; (Ax)+     read
; --------------


                align   4

public arl03_
arl03_:         mov     ecx,dword ptr [edx]
                add     dword ptr [edx],4
                jmp     fetl


                align   4

public arw03_
arw03_:         mov     ecx,dword ptr [edx]
                add     dword ptr [edx],2
                jmp     fetw


                align   4

public arb03_
arb03_:         mov     ecx,dword ptr [edx]
                inc     dword ptr [edx]
                cmp     edx,dword ptr [_a7pointer]
                jne     fetb
                inc     dword ptr [edx]
                jmp     fetb


; -(Ax)     read
; --------------


                align   4

public arl04_
arl04_:         sub     dword ptr [edx],4
                mov     ecx,dword ptr [edx]
                jmp     fetl


                align   4

public arw04_
arw04_:         sub     dword ptr [edx],2
                mov     ecx,dword ptr [edx]
                jmp     fetw


                align   4

public arb04_
arb04_:         dec     dword ptr [edx]
                cmp     edx,dword ptr [_a7pointer]
                jne     arw04a
                dec     dword ptr [edx]
arw04a:         mov     ecx,dword ptr [edx]
                jmp     fetb


; disp(Ax)  read
; --------------


                align   4

public arl05_
arl05_:         push    edx               
                mov     ecx,esi           
                fetchwopcode_inc_pos
                movsx   ecx,dx
                pop     edx                     
                add     esi,2                   
                add     ecx,dword ptr [edx]     
                jmp     fetl


                align   4

public arw05_
arw05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                pop     edx
                add     esi,2
                add     ecx,dword ptr [edx]
                jmp     fetw


                align   4

public arb05_
arb05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                pop     edx
                add     esi,2
                add     ecx,dword ptr [edx]
                jmp     fetb


; disp(Ax,Ri) read
; ----------------


                align   4

public arl06_
arl06_:         push    ebx                   
                mov     ebx,edx               
                mov     ecx,esi               
                fetchwopcode_inc_pos
                add     esi,2                 
                movsx   ecx,dl                
                add     ecx,dword ptr [ebx]   
                mov     ebx,edx               
                shr     ebx,10                
                and     ebx,03ch              
                mov     ebx,dword ptr [_d+ebx]
                test    dh,08h                
                jnz     xx1                   
                movsx   ebx,bx                
xx1:            add     ecx,ebx               
                pop     ebx                   
                jmp     fetl                  


                align   4

public arw06_
arw06_:         push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx2
                movsx   ebx,bx
xx2:            add     ecx,ebx
                pop     ebx
                jmp     fetw


                align   4

public arb06_
arb06_:         push    ebx
                mov     ebx,edx
                mov     ecx,esi                         ; Get word for adressmode
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl                          ; Get displacement
                add     ecx,dword ptr [ebx]             ; Add adress register
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx3
                movsx   ebx,bx
xx3:            add     ecx,ebx                         ; Add dataregister
                pop     ebx
                jmp     fetb


; xxx.W     read
; --------------


                align   4

public arl70_
arl70_:         mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                jmp     fetl


                align   4

public arw70_
arw70_:         mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                jmp     fetw


                align   4

public arb70_
arb70_:         mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                jmp     fetb


; xxx.L     read
; --------------


                align   4

public arl71_

arl71_:         mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                jmp     fetl


                align   4

public arw71_
arw71_:         mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                jmp     fetw


                align   4

public arb71_
arb71_:         mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                jmp     fetb


; disp(pc)  read
; --------------


                align   4

public arl72_
arl72_:         mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                add     ecx,esi
                add     esi,2
                jmp     fetl


                align   4

public arw72_
arw72_:         mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                add     ecx,esi
                add     esi,2
                jmp     fetw


                align   4

public arb72_
arb72_:         mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                add     ecx,esi
                add     esi,2
                jmp    fetb


; disp(pc,Ri) read
; ----------------


                align   4

public arl73_
arl73_:         push    ebx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dl
                add     ecx,esi
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     esi,2
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx4
                movsx   ebx,bx
xx4:            add     ecx,ebx
                pop     ebx
                jmp     fetl


                align   4

public arw73_
arw73_:         push    ebx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dl
                add     ecx,esi
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     esi,2
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx5
                movsx   ebx,bx
xx5:            add     ecx,ebx
                pop     ebx
                jmp     fetw


                align   4

public arb73_
arb73_:         push    ebx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dl
                add     ecx,esi
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     esi,2
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx6
                movsx   ebx,bx
xx6:            add     ecx,ebx
                pop     ebx
                jmp     fetb


; #xxxxxxxx read
; --------------


                align   4

public arl74_
arl74_:         mov     ecx,esi
                add     esi,4
#ifdef PREFETCH
                fetchlopcode_inc_pos
                ret
#else
                jmp     fetl
#endif

                align   4

public arw74_
public arb74_
arw74_:
arb74_:         mov     ecx,esi
                add     esi,2
#ifdef PREFETCH
                fetchwopcode_inc_pos
                ret
#else
                jmp     fetw
#endif


;
; Adressemode Routiner for lesning av byte,word,longword
; UTEN PC KNING,  og An inc/dec
; Konstanter ved start:  edx - reg.nr*4   edx - retur  esi - PC
;


; (Ax)+     les
; -------------


                align   4

public parl03_
parl03_:        mov     ecx,dword ptr [edx]
                jmp     fetl


                align   4

public parw03_
parw03_:        mov     ecx,dword ptr [edx]
                jmp     fetw


                align   4

public parb03_
parb03_:        mov     ecx,dword ptr [edx]
                jmp     fetb


; -(Ax)     les
; -------------


                align   4

public parl04_
parl04_:        mov     ecx,dword ptr [edx]
                sub     ecx,4
                jmp     fetl


                align   4

public parw04_
parw04_:        mov     ecx,dword ptr [edx]
                sub     ecx,2
                jmp     fetw


                align   4

public parb04_
parb04_:        mov     ecx,dword ptr [edx]
                dec     ecx
                cmp     edx,dword ptr [_a7pointer]
                jne     fetb
                dec     ecx
                jmp     fetb


; disp(Ax)  les
; -------------


                align   4

public parl05_
parl05_:        push    edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                pop     edx
                add     ecx,dword ptr [edx]
                jmp     fetl


                align   4

public  parw05_
parw05_:        push    edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                pop     edx
                add     ecx,dword ptr [edx]
                jmp     fetw


                align   4

public parb05_
parb05_:        push    edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                pop     edx
                add     ecx,dword ptr [edx]
                jmp     fetb


; disp(Ax,Ri) les
; ---------------


                align   4

public parl06_
parl06_:        push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx1
                movsx   ebx,bx
pxx1:           add     ecx,ebx
                pop     ebx
                jmp     fetl


                align   4

public parw06_
parw06_:        push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx2
                movsx   ebx,bx
pxx2:           add     ecx,ebx
                pop     ebx
                jmp     fetw


                align   4

public parb06_
parb06_:        push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx3
                movsx   ebx,bx
pxx3:           add     ecx,ebx
                pop     ebx
                jmp     fetb


; xxx.W     les
; -------------


                align   4

public parl70_
parl70_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                jmp     fetl


                align   4

public parw70_
parw70_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                jmp     fetw


                align   4

public parb70_
parb70_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                jmp     fetb


; xxx.L     les
; -------------


                align   4

public parl71_
parl71_:        mov     ecx,esi
                fetchlopcode_keep_pos
                mov     ecx,edx
                jmp     fetl


                align   4

public parw71_
parw71_:        mov     ecx,esi
                fetchlopcode_keep_pos
                mov     ecx,edx
                jmp     fetw


                align   4

public parb71_
parb71_:        mov     ecx,esi
                fetchlopcode_keep_pos
                mov     ecx,edx
                jmp     fetb


; disp(pc)  les
; -------------


                align   4

public parl72_
parl72_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                add     ecx,esi
                jmp     fetl


                align   4

public parw72_
parw72_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                add     ecx,esi
                jmp     fetw


                align   4

public parb72_
parb72_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                add     ecx,esi
                jmp     fetb


; disp(pc,Ri) les
; ---------------


                align   4

public parl73_
parl73_:        push    ebx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     ecx,esi
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx4
                movsx   ebx,bx
pxx4:           add     ecx,ebx
                pop     ebx
                jmp     fetl


                align   4

public parw73_
parw73_:        push    ebx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     ecx,esi
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx5
                movsx   ebx,bx
pxx5:           add     ecx,ebx
                pop     ebx
                jmp     fetw


                align   4

public parb73_
parb73_:        push    ebx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     ecx,esi
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx6
                movsx   ebx,bx
pxx6:           add     ecx,ebx
                pop     ebx
                jmp     fetb


; #xxxxxxxx les
; -------------


                align   4

public parl74_
parl74_:        mov     ecx,esi
#ifdef PREFETCH
                fetchlopcode_keep_pos
                ret
#else
                jmp     fetl
#endif

                align   4

public parw74_
public parb74_
parw74_:
parb74_:        mov     ecx,esi
#ifdef PREFETCH
                fetchwopcode_keep_pos
                ret
#else
                jmp     fetw
#endif


;
; Adressemode rutiner for SKRIVING av byte,word,longword
; MED PC KNING
; Konstanter ved start: EBX - reg.nr EDX - data som skal skrives
;


; Dx     skriv
; -------------


                align   4

public awb00_
awb00_:         mov     byte ptr [ebx],dl
                ret


                align   4

public aww00_
aww00_:         mov     word ptr [ebx],dx
                ret


                align   4

public awl00_
awl00_:         mov     dword ptr [ebx],edx
                ret


; Ax      skriv
; -------------


                align   4

public aww01_
aww01_:         movsx   edx,dx
                mov     dword ptr [ebx],edx
                ret


                align   4

public awl01_
awl01_:         mov     dword ptr [ebx],edx
                ret


; (Ax)    skriv
; -------------


                align   4

public awl02_
awl02_:         mov     ecx,dword ptr [ebx]
                jmp     wril


                align   4

public aww02_
aww02_:         mov     ecx,dword ptr [ebx]
                jmp     wriw


                align   4

public awb02_
awb02_:         mov     ecx,dword ptr [ebx]
                jmp     wrib


; (Ax)+     skriv
; ---------------

                align   4

public awl03_
awl03_:         mov     ecx,dword ptr [ebx]
                add     dword ptr [ebx],4
                jmp     wril


                align   4

public aww03_
aww03_:         mov     ecx,dword ptr [ebx]
                add     dword ptr [ebx],2
                jmp     wriw


                align   4

public awb03_
awb03_:         mov     ecx,dword ptr [ebx]
                inc     dword ptr [ebx]
                cmp     ebx,dword ptr [_a7pointer]
                jne     wrib
                inc     dword ptr [ebx]
                jmp     wrib


; -(Ax)     skriv
; ---------------


                align   4

public awl04_
awl04_:         sub     dword ptr [ebx],4
                mov     ecx,dword ptr [ebx]
                jmp     wril


                align   4

public aww04_
aww04_:         sub     dword ptr [ebx],2
                mov     ecx,dword ptr [ebx]
                jmp     wriw


                align   4

public awb04_
awb04_:         dec     dword ptr [ebx]
                cmp     ebx,dword ptr [_a7pointer]
                jne     awb04a
                dec     dword ptr [ebx]
awb04a:         mov     ecx,dword ptr [ebx]
                jmp     wrib


; disp(Ax)  skriv
; -------------


                align   4

public awl05_
awl05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                add     ecx,dword ptr [ebx]
                pop     edx
                jmp     wril


                align   4

public aww05_
aww05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                add     ecx,dword ptr [ebx]
                pop     edx
                jmp     wriw


                align   4

public awb05_
awb05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                add     ecx,dword ptr [ebx]
                pop     edx
                jmp     wrib


; disp(Ax,Ri) skriv
; -----------------


                align   4

public awl06_
awl06_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     wxx1
                movsx   ebx,bx
wxx1:           add     ecx,ebx
                pop     edx
                jmp     wril


                align   4

public aww06_
aww06_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     wxx2
                movsx   ebx,bx
wxx2:           add     ecx,ebx
                pop     edx
                jmp     wriw


                align   4

public awb06_
awb06_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     wxx3
                movsx   ebx,bx
wxx3:           add     ecx,ebx
                pop     edx
                jmp     wrib


; xxx.W     skriv
; ---------------


                align   4

public awl70_
awl70_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                pop     edx
                jmp     wril


                align   4

public aww70_
aww70_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                pop     edx
                jmp     wriw


                align   4

public awb70_
awb70_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                pop     edx
                jmp     wrib


; xxx.L     skriv
; ---------------


                align   4

public awl71_
awl71_:         push    edx
                mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                pop     edx
                jmp     wril


                align   4

public aww71_
aww71_:         push    edx
                mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                pop     edx
                jmp     wriw


                align   4

public awb71_
awb71_:         push    edx
                mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                pop     edx
                jmp     wrib


;
; Adressemode rutiner for beregning av effective adress
; MED PC-kning
; Konstanter ved start:  edx - reg.nr*4+d   edx - retur  esi - PC
;


; (Ax)      les
; -------------


                align   4

public eac02_
eac02_:         mov     edx,dword ptr [edx] 
                ret                         


; disp(Ax)  les
; -------------


                align   4

public eac05_
eac05_:         push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   edx,dx
                add     edx,dword ptr [ebx]
                pop     ebx
                ret


; disp(Ax,Ri) les
; ---------------


                align   4

public eac06_
eac06_:         push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xxc1
                movsx   ebx,bx
xxc1:           add     ecx,ebx
                mov     edx,ecx
                pop     ebx
                ret


; xxx.W     les
; -------------


                align   4

public eac70_
eac70_:         mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   edx,dx
                ret


; xxx.L     les
; -------------


                align   4

public eac71_
eac71_:         mov     ecx,esi
                add     esi,4
#ifdef PREFETCH
                fetchlopcode_inc_pos
                ret
#else
                jmp     fetl
#endif


; disp(pc)  les
; -------------


                align   4

public eac72_
eac72_:         push    ebx
                mov     ebx,esi
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   edx,dx
                add     edx,ebx
                pop     ebx
                ret


; disp(pc,Ri) les
; ---------------


                align   4

public eac73_
eac73_:         push    ebx
                mov     ebx,esi
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,ebx
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xxc4
                movsx   ebx,bx
xxc4:           add     ecx,ebx
                mov     edx,ecx
                pop     ebx
                ret


;
; Rutiner for beregning av branch conditions
; Out:  dl = 1 means branch / 0 not
;


; RA (TRUE)
; ---------


                        align   4

public cc0_
cc0_:                   mov     dl,1
                        ret


; SR (TRUE) PC to stack
; ---------------------


                        align   4

public cc1_
cc1_:                   mov     ebx,ecx                 ; Save ecx
                        mov     ecx,dword ptr [_a+28]
                        sub     ecx,4
                        mov     dword ptr [_a+28],ecx
                        mov     edx,esi
                        cmp     dword ptr [edi+8],0
                        jne     cc1a
                        add     edx,2
cc1a:                   writel                          ; Push PC to stack
                        mov     ecx,ebx
                        mov     dl,1
                        ret


; F (FALSE)
; ---------


                        align   4

public cc1false_
cc1false_:              xor     edx,edx
                        ret


; HI (-C & -Z)
; ------------


                        align   4

public cc2_
cc2_:                   xor     edx,edx
                        test    byte ptr _sr,05h
                        jnz     cc2a
                        inc     edx
cc2a:                   ret


; LS (C OR Z)
; -----------


                        align   4

public cc3_
cc3_:                   mov     edx,dword ptr _sr
                        and     dl,05h
                        ret


; CC (-C)
; -------


                        align   4

public cc4_
cc4_:                   mov     edx,dword ptr _sr
                        and     dl,01h
                        xor     dl,01h
                        ret


; CS (C)
; ------


                        align   4

public cc5_
cc5_:                   mov     edx,dword ptr _sr
                        and     dl,01h
                        ret


; NE (-Z)
; -------


                        align   4

public cc6_
cc6_:                   mov     edx,dword ptr _sr
                        and     dl,04h
                        xor     dl,04h
                        ret


; EQ (Z)
; ------


                        align   4

public cc7_
cc7_:                   mov     edx,dword ptr _sr
                        and     dl,04h
                        ret


; VC (-V)
; -------


                        align   4

public cc8_
cc8_:                   mov     edx,dword ptr _sr
                        and     dl,02h
                        xor     dl,02h
                        ret


; VS (V)
; ------


                        align   4

public cc9_
cc9_:                   mov     edx,dword ptr _sr
                        and     dl,02h
                        ret


; PL (-N)
; -------


                        align   4

public cca_
cca_:                   mov     edx,dword ptr _sr
                        and     dl,08h
                        xor     dl,08h
                        ret


; MI (N)
; ------


                        align   4

public ccb_
ccb_:                   mov     edx,dword ptr _sr
                        and     dl,08h
                        ret


; GE (N AND V OR -N AND -V)
; -------------------------


                        align   4

public ccc_
ccc_:                   mov     edx,dword ptr _sr
                        and     edx,0fh
                        mov     dl,byte ptr [_ccctt+edx]
                        ret


; LT (N AND -V OR -N AND V)
; -------------------------


                        align   4

public ccd_
ccd_:                   mov     edx,dword ptr _sr
                        and     edx,0fh
                        mov     dl,byte ptr [_ccdtt+edx]
                        ret


; GT (N & V & Z) OR (-N & -V & -Z)
; --------------------------------


                        align   4

public cce_
cce_:                   mov     edx,dword ptr _sr
                        and     edx,0fh
                        mov     dl,byte ptr [_ccett+edx]
                        ret


; LE ( Z OR (N & -V) OR (-N & V) )
; --------------------------------

                        align   4

public ccf_
ccf_:                   mov     edx,dword ptr _sr
                        and     edx,0fh
                        mov     dl,byte ptr [_ccftt+edx]
                        ret


; End of branch conditions
;

;
; Exceptions
;


public privilegie_violation
privilegie_violation:   sub     esi,2
                        mov     ebx,020h
                        mov     eax,38
                        jmp     prepare_exception_


;
; Illegal instruction
;


public i00_
i00_:                   sub     esi,2
                        mov     ecx,esi
                        fetchw
                        and     dh,0f0h
                        cmp     dh,0f0h
                        je      i00fline
                        cmp     dh,0a0h
                        je      i00aline
                        mov     ebx,010h
                        mov     eax,38
                        jmp     prepare_exception_

i00fline:               mov     ebx,02ch
                        mov     eax,38
                        jmp     prepare_exception_

i00aline:               mov     ebx,028h
                        mov     eax,38
                        jmp     prepare_exception_


;
; Instruction 1   ABCD.B Dy,Dx    ABCD.B -(Ay),-(Ax)
; Tableusage  2 - rx*4(dest)  3 - ry*4
; Opcode*32 i edi
; FLAGS: XC  Not verified...
;
public i01_1_
i01_1_:
	mov     ebx,dword ptr [12+edi]          ; ebx - Source register
	mov     ecx,dword ptr [8+edi]           ; ecx - Destination register
	mov     edx,dword ptr _sr               ; edx - Flags
	movzx   eax,byte ptr [ebx]              ; eax - Get Source data
	movzx   ebx,byte ptr [_bcd2hex+eax]     ; ebx - Binary version of source
	movzx   eax,byte ptr [ecx]              ; eax - Get Destination data
	movzx   eax,byte ptr [_bcd2hex+eax]     ; eax - Binary version of source
	test    dl,10h                          ; Add X flag to bl
	jz      i01_1a                          ; 10
	inc     ebx                             ; 11
i01_1a: add     eax,ebx                         ; 12
	and     dl,0eh                         ; 13
	cmp     al,100                          ; 14 Carry?
	jb      i01_1b                          ; 15
	or      edx,11h                         ; 16 Carry!
	sub     al,100                          ; 17
i01_1b: test    al,al                           ; 18 Zero?
	jz      i01_1c                          ; 19
	and     dl,01bh                         ; 20 Non-Zero!
i01_1c: mov     byte ptr _sr,dl                  ; 21 Flags end
        and     eax,0ffh
        mov     al,byte ptr [_hex2bcd+eax]      ; 22
	mov     byte ptr [ecx],al               ; 23
	mov     eax,6
	ret                                     

public i01_2_
i01_2_:
        mov     ebx,dword ptr [12+edi]        ; Source
	mov     ecx,dword ptr [ebx]
	dec     ecx
        cmp     ebx,dword ptr [_a7pointer]
        jne     i01_2i
        dec     ecx
i01_2i:
	mov     dword ptr [ebx],ecx
	xor     edx,edx
        fetchb
        xor     ebx,ebx
        mov     bl,byte ptr [_bcd2hex+edx]                           ; bl is now sourcedata
	mov     eax,dword ptr [8+edi]         ; Dest
	mov     ecx,dword ptr [eax]
	dec     ecx
        cmp     eax,dword ptr [_a7pointer]
        jne     i01_2j
        dec     ecx
i01_2j:
	mov     dword ptr [eax],ecx
	xor     edx,edx
	mov     ebp,ecx                          ; Save ecx for later use
        fetchb
        xor     eax,eax
        mov     al,byte ptr [_bcd2hex+edx]
	mov     dl,byte ptr _sr                  ; Flags
	test    dl,10h
	jz      i01_2a
	inc     eax
i01_2a: add     eax,ebx
	and     dl,0eh
	cmp     al,100                          ; Carry?
	jb      i01_2b
	or      dl,11h                          ; Carry!
	sub     al,100
i01_2b: test    al,al                           ; Zero?
	jz      i01_2c
	and     dl,01bh                         ; Non-Zero!
i01_2c: mov     byte ptr _sr,dl                 ; Flags end
        and     eax,0ffh
        mov     dl,byte ptr [_hex2bcd+eax]
	mov     ecx,ebp                         ; restore saved <ea>
        writeb
	mov     eax,18                          ; return cyclecount
	ret     


IMSK_XNZVC      =     0x8c1
MCLR_XNZVC      =     0
MSET_XNZVC      =     0x1f
		
SETFLAGS macro INTELMASK, M68CLEAR, M68SET
		pushfd
		pop	eax
		and	eax,INTELMASK
                mov     eax,dword ptr [_statustab+4*eax]
                if      M68SET eq 0x1f
                        mov     byte ptr [_sr],al
                else
                        mov     ah,byte ptr [_sr]
                        and     ah,M68CLEAR
                        and     al,M68SET
                        or      ah,al
                        mov     byte ptr [_sr],ah
                endif
endm
	 	
GETARG macro ROUTINE,REGISTER,DESTREG 
		mov	edx,dword ptr [REGISTER]
		call	dword ptr [ROUTINE]
                ifdif   DESTREG,edx
                        mov     DESTREG,edx
                endif
endm	

SETARG macro ROUTINE,REGISTER,SOURREG 
		mov	ebx,dword ptr [REGISTER]
                ifdif   SOURREG,edx
                        mov     edx,SOURREG
                endif
		call	dword ptr [ROUTINE]
endm	

GETREGVAL macro DESTREG , REGISTER , REGREG
                mov     REGREG,dword ptr [REGISTER]
                mov     DESTREG,dword ptr [REGREG]
endm

SETREGVAL macro SOURREG , REGISTER
                mov     eax,dword ptr [REGISTER]
                mov     dword ptr [eax],SOURREG
endm
				
SETREGVALHREG macro SOURREG , REGISTER , REGREG
                mov     dword ptr [REGREG],SOURREG
endm
				
;================================================
; ADD.X <ea>,Dn (case 1) / ADD.X Dn,<ea> (case 2)
; Flags: All
;================================================

public i02_B_1_
i02_B_1_:       GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                add             cl,dl
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
		ret

public i02_W_1_
i02_W_1_:       GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                add             cx,dx
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
		ret

public i02_L_1_
i02_L_1_:       GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                add             ecx,edx
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
		ret

public i02_B_2_
i02_B_2_:       GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,eax
                add             dl,cl
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETARG          edi+24,edi+8,edx
                mov             eax,dword ptr [edi+20]
		ret

public i02_W_2_
i02_W_2_:       GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,eax
                add             dx,cx
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETARG          edi+24,edi+8,edx
                mov             eax,dword ptr [edi+20]
		ret

public i02_L_2_
i02_L_2_:       GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,eax
                add             edx,ecx
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETARG          edi+24,edi+8,edx
                mov             eax,dword ptr [edi+20]
		ret

;
; ADDA.W/L <ea>,An
; Flags:  NONE
;

public i03_W_
i03_W_:         GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                movsx           edx,dx
                add             ecx,edx
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
                ret

public i03_L_
i03_L_:         GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                add             ecx,edx
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
                ret

;
; ADDI.X #,<ea>
; Flags: ALL,verified OK
;
public i04_B_
i04_B_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	add     dl,bl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
public i04_w_
i04_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	add     dx,bx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     byte ptr _sr,al             ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =38
public i04_L_
i04_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      3
	call    eax                         ; Les <ea>3      5
	add     edx,ebx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5

;
; ADDQ.X #,<ea>
;  0-rutinepeker 1-disasm rutine  2-eareg 3-ea les rutine
;                4-cycle count    5-ea skriv rutine 6-add immediate              
; Flags: ALL
;

                align   4

public i05_B_
i05_B_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                call    eax
                mov     ebx,dword ptr [edi+24]
                add     dl,bl
                pushfd
                pop     eax
                and     eax,0fffh
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+20]
                mov     byte ptr _sr,al      
                mov     ebx,dword ptr [edi+8]
                call    ecx                    
                mov     eax,dword ptr [edi+16] 
                ret                            


                align   4

public i05_W_
i05_W_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8] 
                call    eax                   
                mov     ebx,dword ptr [edi+24]
                add     dx,bx                   
                pushfd                          
                pop     eax                     
                and     eax,0fffh               
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+20]
                mov     byte ptr _sr,al       
                mov     ebx,dword ptr [edi+8]
                call    ecx                   
                mov     eax,dword ptr [edi+16]
                ret


                align   4

public i05_L_
i05_L_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8] 
                call    eax                   
                mov     ebx,dword ptr [edi+24]
                add     edx,ebx                 
                pushfd                          
                pop     eax                     
                and     eax,0fffh               
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+20]
                mov     byte ptr _sr,al       
                mov     ebx,dword ptr [edi+8]
                call    ecx                   
                mov     eax,dword ptr [edi+16]
                ret


                align   4

public i05_ADR_
i05_ADR_:       mov     eax,dword ptr [edi+8] 
                mov     edx,dword ptr [eax]
                mov     ebx,dword ptr [edi+24]
                add     edx,ebx               
                mov     dword ptr [eax],edx
                mov     eax,dword ptr [edi+16]
                ret

;
; Instruction 6   ADDX.X Dy,Dx    ADDX.X -(Ay),-(Ax)
; Tableusage  2 - rx*4(dest)  3 - ry*4
; Opcode*32 i edi
; Flags: ALL, Z unchanged if result is non-zero
;


                align   4

public i06_B_1_
i06_B_1_:       mov     ebx,dword ptr [12+edi]          ; Source
                mov     ecx,dword ptr [8+edi]           ; Dest
                mov     eax,dword ptr [ebx]             
                mov     ebx,dword ptr [ecx]             
                mov     edx,dword ptr _sr
                test    dl,10h
                jz      i06b1nc
                stc     
i06b1nc:        adc     bl,al
                pushfd                                  ; Flags  
                pop     eax                             
                and     eax,0fbfh                       ; No Z                       
                mov     dword ptr [ecx],ebx             
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    bl,bl                           ; Clear if nonzero
                jz      i06b1nz
                xor     ah,ah
i06b1nz:        or      al,ah
                mov     byte ptr [_sr],al
                mov     eax,4
                ret


                align   4

public i06_W_1_
i06_W_1_:       mov     ebx,dword ptr [12+edi]          ; Source
                mov     ecx,dword ptr [8+edi]           ; Dest
                mov     eax,dword ptr [ebx]
                mov     ebx,dword ptr [ecx]
                mov     edx,dword ptr _sr
                test    dl,10h
                jz      i06w1nc
                stc     
i06w1nc: 	adc     bx,ax
                pushfd                                
                pop     eax                           
                and     eax,0fbfh                     
                mov     dword ptr [ecx],ebx           
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    bx,bx                           ; Clear if nonzero
                jz      i06w1nz
                xor     ah,ah
i06w1nz:        or      al,ah
                mov     byte ptr _sr,al               
                mov     eax,4
                ret


                align   4

public i06_L_1_
i06_L_1_:       mov     ebx,dword ptr [12+edi]          ; Source
                mov     ecx,dword ptr [8+edi]           ; Dest
                mov     eax,dword ptr [ebx]             
                mov     ebx,dword ptr [ecx]             
                mov     edx,dword ptr _sr
                test    dl,10h
                jz      i06l1nc
                stc     
i06l1nc:   	adc     ebx,eax
                pushfd                           
                pop     eax                      
                and     eax,0fbfh                
                mov     dword ptr [ecx],ebx      
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    ebx,ebx                         ; Clear if nonzero
                jz      i06l1nz
                xor     ah,ah
i06l1nz:        or      al,ah
                mov     byte ptr _sr,al                 
                mov     eax,8
                ret


                align   4

public i06_B_2_
i06_B_2_:       mov     ebx,dword ptr [12+edi]          ; Source 
                mov     ecx,dword ptr [ebx]
                dec     ecx
                cmp     ebx,dword ptr [_a7pointer]
                jne     i06_B_2j
                dec     ecx
i06_B_2j:       mov     dword ptr [ebx],ecx
                fetchb
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]           ; Dest
                mov     ecx,dword ptr [eax]
                dec     ecx
                cmp     eax,dword ptr [_a7pointer]
                jne     i06_B_2i
                dec     ecx
i06_B_2i:       mov     dword ptr [eax],ecx
                mov     ebp,ecx                         ; Save <ea> for later use
                fetchb
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i06b2nc
                stc     
i06b2nc:        adc     dl,bl
                pushfd
                pop     eax
                and     eax,0fbfh
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dl,dl                           ; Clear if nonzero
                jz      i06b2nz
                xor     ah,ah
i06b2nz:        or      al,ah
                mov     byte ptr _sr,al                 
                mov     ecx,ebp                         ; restore saved <ea>
                writeb
                mov     eax,18
                ret


                align   4

public i06_W_2_
i06_W_2_:       mov     ebx,dword ptr [12+edi]          ; Source 
                mov     ecx,dword ptr [ebx]
                sub     ecx,2
                mov     dword ptr [ebx],ecx
                fetchw
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]           ; Dest
                mov     ecx,dword ptr [eax]
                sub     ecx,2
                mov     dword ptr [eax],ecx
                mov     ebp,ecx                         ; Save <ea> for later use
                fetchw
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i06w2nc
                stc     
i06w2nc:        adc     dx,bx
                pushfd                                  
                pop     eax                             
                and     eax,0fbfh                       
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dx,dx                           ; Clear if nonzero
                jz      i06w2nz
                xor     ah,ah
i06w2nz:        or      al,ah
                mov     byte ptr _sr,al             
                mov     ecx,ebp                         ; restore saved <ea>
                writew
                mov     eax,18
                ret


                align   4

public i06_L_2_
i06_L_2_:       mov     ebx,dword ptr [12+edi]          ; Source 
                mov     ecx,dword ptr [ebx]
                sub     ecx,4
                mov     dword ptr [ebx],ecx
                fetchl
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]           ; Dest
                mov     ecx,dword ptr [eax]
                sub     ecx,4
                mov     dword ptr [eax],ecx
                mov     ebp,ecx                         ; Save <ea> for later use
                fetchl
                mov     al,byte ptr _sr
                test    al,10h
                jz      i06l2nc
                stc     
i06l2nc:        adc     edx,ebx
                pushfd
                pop     eax
                and     eax,0fbfh 
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    edx,edx                         ; Clear if nonzero
                jz      i06l2nz
                xor     ah,ah
i06l2nz:        or      al,ah
                mov     byte ptr _sr,al                 
                mov     ecx,ebp                         ; restore saved <ea>
                writel
                mov     eax,30
                ret


;
; AND.X <ea>,Dn / AND.X Dn,<ea>
; Flags: X unaffected, N Z, V = C = 0, verfied OK
;
i07_B_1_:                                   
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	and     cl,dl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     dword ptr [ebx],ecx         ;        12      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h              ; Trenger ikke and p ebx
	or      eax,ebx
	mov     dword ptr _sr,eax           ;        11      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =31
i07_W_1_:
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]           ; Les Dn  5      4
	and     cx,dx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     dword ptr [ebx],ecx         ;        12      2
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax           ;        11      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =34
i07_L_1_:
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	and     ecx,edx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     dword ptr [ebx],ecx         ;        12      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax           ;        11      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =31
i07_B_2_:
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]           ; Les Dn  5      3
	and     dl,cl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i07_W_2_:
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      4
	and     dx,cx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ; C=0     9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =38
i07_L_2_:
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      3
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	and     edx,ecx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
;
; ANDI.X #,<ea>
; Flagg: X unaffected, N Z, V = C = 0, verfied OK
;
i08_B_: mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	and     dl,bl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i08_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	and     dx,bx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =38
i08_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      3
	call    eax                         ; Les <ea>3      5
	and     edx,ebx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5

i08_B_CCR_:
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	and     al,dl
	mov     dword ptr _sr,eax
	mov     eax,20
	ret

i08_W_SR_:
        test    byte ptr _sr+1,020h
        jz      privilegie_violation
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	and     eax,edx
	mov     edx,eax
	call    updateSR
	mov     eax,20
	ret

;
; ASX.X
; Tableusage:(imm) 0-rut 1-disrut 2-shcount 3-dreg 4-cyclecount
; Tableusage:(reg) 0-rut 1-disrut 2-shcountreg 3-dreg 4-cyclecount
; Tableusage:(mem) 0-rut 1-disrut 2-eareg 3-eales 4-easkriv 5-cyclecount
; Flags: ALL, XC unaffected if shift count is zero, only happens with shiftcount
;         in Dx, V set if sign bit changes, only happes during ASL 
;


i09_RI_I_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	sar     al,cl
	pushfd
	pop     ecx
	and     ecx,07ffh                                       ; Intel, OF undefined or 0
	mov     dword ptr [ebx],eax
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	mov     eax,dword ptr [edi+16]
	ret

i09_RI_I_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	sar     ax,cl
	pushfd
	pop     ecx
	and     ecx,07ffh
	mov     dword ptr [ebx],eax
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	mov     eax,dword ptr [edi+16]
	ret

i09_RI_I_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	sar     eax,cl
	pushfd
	pop     ecx
	and     ecx,07ffh
	mov     dword ptr [ebx],eax
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	mov     eax,dword ptr [edi+16]
	ret


; Over is OK

; Functions below, OK, only care about zero count

i09_RI_R_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
	jz      i09rirbz
        cmp     ecx,8
        jb      i09rirbok
        sar     al,7
        jmp     i09rirbnok
i09rirbok:
	sar     al,cl
i09rirbnok:
	pushfd
	mov     dword ptr [ebx],eax
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh
	mov     eax,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,al
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret
i09rirbz:
	or      al,al
	pushfd
	pop     ebx
	and     ebx,0c0h                ; We want sign and zero
	shr     ebx,4
	mov     bh,byte ptr _sr
        and     bh,010h         ; preserve X
	or      bh,bl
	mov     byte ptr _sr,bh
	mov     eax,dword ptr [edi+16]
	ret

i09_RI_R_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
	jz      i09rirwz
        cmp     ecx,16
        jb      i09rirwok
        sar     ax,15
        jmp     i09rirwnok
i09rirwok:
	sar     ax,cl
i09rirwnok:
	pushfd
	mov     dword ptr [ebx],eax
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh
	mov     eax,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,al
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret
i09rirwz:
	or      ax,ax
	pushfd
	pop     ebx
	and     ebx,0c0h                ; We want sign and zero
	shr     ebx,4
	mov     bh,byte ptr _sr
        and     bh,010h         ; preserve XC
	or      bh,bl
	mov     byte ptr _sr,bh
	mov     eax,dword ptr [edi+16]
	ret



i09_RI_R_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
	jz      i09rirlz
        cmp     ecx,32
        jb      i09rirlok
        sar     eax,31
        jmp     i09rirlnok
i09rirlok:
	sar     eax,cl
i09rirlnok:
	pushfd
	mov     dword ptr [ebx],eax
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh
	mov     eax,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,al
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret
i09rirlz:
	or      eax,eax
	pushfd
	pop     ebx
	and     ebx,0c0h                ; We want sign and zero
	shr     ebx,4
	mov     bh,byte ptr _sr
        and     bh,010h         ; preserve XC
	or      bh,bl
	mov     byte ptr _sr,bh
	mov     eax,dword ptr [edi+16]
	ret


; Functions for left shifts, immediate shift counts, must check for sign change
; Done by extendng the operand to twice its size, and checking:
; 1. if it is, then check if upper and lower part have same sign
; 2. is the upper part -1 or 0??
;

i09_LE_I_B_:
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     eax,dword ptr [ebx]             ; get dreg content

	movsx   eax,al

	mov       edx,eax
	sal     dl,cl
	pushfd
	sal     ax,cl
	pop     ecx
	and     ecx,07ffh
	mov     byte ptr [ebx],al
	mov     bl,byte ptr [_statustab+ecx]

; New
	mov     ecx,eax
	and     ecx,8080h
	cmp     ch,cl
	je      i09leibnb
	or      bl,2h
i09leibnb:
	or      ah,ah
	jz      i09leibna
	xor     ah,-1
	jz      i09leibna
	or      bl,2h
i09leibna:
	
; New end

	mov     byte ptr _sr,bl
	mov     eax,dword ptr [edi+16]
	ret

i09_LE_I_W_:
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ax,word ptr [ebx]             ; get dreg content

	movsx   eax,ax
	mov     edx,eax
	sal     dx,cl
	pushfd
	sal     eax,cl
	pop     ecx
	and     ecx,07ffh
	mov     word ptr [ebx],ax

	mov     ebx,dword ptr [_statustab+4*ecx]


; New
	mov     ecx,eax
	and     ecx,80008000h
	mov     edx,ecx
	shr     edx,16
	cmp     dx,cx
	je      i09leiwnb
	or      bl,2h
i09leiwnb:
	and     eax,0ffff0000h
	jz      i09leibna
	cmp     eax,0ffff0000h
	je      i09leiwna
	or      bl,2h
i09leiwna:
	
; New end



	mov     eax,dword ptr [edi+16]

	mov     byte ptr _sr,bl
	ret

i09_LE_I_L_:
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	
	mov     edx,-1                          ; Create mask
	mov     ecx,31                          ; edx is zero if sign change 
	sub     ecx,dword ptr [edi+8]
	shl     edx,cl
	mov     ebp,eax
	and     ebp,edx
	jnz     i09leilns
	xor     ebp,edx
	jnz     i09leilns
	xor     edx,edx
i09leilns:

	mov     ecx,dword ptr [edi+8]           ; get shcount


	sal     eax,cl
	pushfd
	pop     ecx
	and     ecx,07ffh
	mov     dword ptr [ebx],eax
	mov     ebx,dword ptr [_statustab+4*ecx]


; New
	or      edx,edx
	jnz     i09leilnb
	or      bl,2h
i09leilnb:
	
; New end

	mov     eax,dword ptr [edi+16]
	mov     byte ptr _sr,bl
	ret

; Left ashift count in Dx, must check for zero shift count, DONE
; Counts greater than size produce zero as result. DONE
; Detect sign change during shift. DONE

i09_LE_R_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	jz      i09lerbz
	mov     eax,dword ptr [ebx]             ; get dreg content
	cmp     ecx,8
	jae     i09lerbtoobig

	movsx   eax,al
	mov     edx,eax
	sal     dl,cl
	pushfd
	sal     ax,cl
	mov     byte ptr [ebx],al
	mov     ebp,ecx
	add     ebp,ebp                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh
	mov     ebx,dword ptr [_statustab+4*ecx]
; New
	mov     ecx,eax
	and     ecx,8080h
	cmp     ch,cl
	je      i09lerbnb
	or      bl,2h
i09lerbnb:
	or      ah,ah
	jz      i09lerbna
	cmp     ah,-1
	je      i09lerbna
	or      bl,2h
i09lerbna:
	
; New end
	mov     byte ptr _sr,bl
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret
i09lerbz:
	or      al,al
	pushfd
	pop     ebx
	and     ebx,0c0h                ; We want sign and zero
	shr     ebx,4
	mov     bh,byte ptr _sr
        and     bh,010h         ; preserve XC
	or      bh,bl


	mov     byte ptr _sr,bh
	mov     eax,dword ptr [edi+16]
	ret
; here, set zero as result, Set Z flag, if count == size then
; set xc to sign bit and set V flag if original isnt zero 
i09lerbtoobig:
	mov     byte ptr [ebx],0
	mov     bl,4h
	or      al,al
	jz      i09lerbtbz
	or      bl,2
i09lerbtbz:
	cmp     cl,8
	jne     i09lerbtbs
	test    al,80h
	jns     i09lerbtbs
	or      bl,11h
i09lerbtbs:
	mov     byte ptr _sr,bl
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret     

i09_LE_R_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	jz      i09lerwz
	mov     eax,dword ptr [ebx]             ; get dreg content
	cmp     ecx,16
	jae     i09lerwtoobig
	movsx   eax,ax
	mov     edx,eax
	sal     dx,cl
	pushfd
	sal     eax,cl
	mov     word ptr [ebx],ax
	mov     ebp,ecx
	add     ebp,ebp                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh
	mov     ebx,dword ptr [_statustab+4*ecx]
; New
	mov     ecx,eax
	and     ecx,80008000h
	mov     edx,ecx
	shr     edx,16
	cmp     dx,cx
	je      i09lerwnb
	or      bl,2h
i09lerwnb:
	and     eax,0ffff0000h
	jz      i09lerwna
	cmp     eax,0ffff0000h
	je      i09lerwna
	or      bl,2h
i09lerwna:
	
; New end
	
	mov     byte ptr _sr,bl
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret
i09lerwz:
	or      ax,ax
	pushfd
	pop     ebx
	and     ebx,0c0h                ; We want sign and zero
	shr     ebx,4
	mov     bh,byte ptr _sr
        and     bh,010h         ; preserve XC
	or      bh,bl
	mov     byte ptr _sr,bh
	mov     eax,dword ptr [edi+16]
	ret

; here, set zero as result, Set Z flag, if count == size then
; set xc to sign bit and set V flag if original isnt zero 
i09lerwtoobig:
	mov     word ptr [ebx],0
	mov     bl,4h
	or      al,al
	jz      i09lerwtbz
	or      bl,2
i09lerwtbz:
	cmp     cl,16
	jne     i09lerwtbs
        test    ah,80h
	jns     i09lerwtbs
	or      bl,11h
i09lerwtbs:
	mov     byte ptr _sr,bl
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret     

i09_LE_R_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	jz      i09lerlz
	mov     eax,dword ptr [ebx]             ; get dreg content
	cmp     ecx,32
	jae     i09lerltoobig

	push    ecx
	mov     ebp,ecx
	mov     edx,-1                          ; Create mask
	mov     ecx,31                          ; edx is zero if sign change 
	sub     ecx,ebp
	shl     edx,cl
	mov     ebp,eax
	and     ebp,edx
	jnz     i09lerlns
	xor     ebp,edx
	jnz     i09lerlns
	xor     edx,edx
i09lerlns:
	pop     ecx
	sal     eax,cl
	pushfd
	mov     dword ptr [ebx],eax
	mov     ebp,ecx
	add     ebp,ebp                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh
	mov     ebx,dword ptr [_statustab+4*ecx]
; New
	or      edx,edx
	jnz     i09lerlnb
	or      bl,2h
i09lerlnb:
	
; New end
	mov     byte ptr _sr,bl
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret
i09lerlz:
	or      eax,eax
	pushfd
	pop     ebx
	and     ebx,0c0h                ; We want sign and zero
	shr     ebx,4
	mov     bh,byte ptr _sr
        and     bh,010h         ; preserve XC
	or      bh,bl
	mov     byte ptr _sr,bh
	mov     eax,dword ptr [edi+16]
	ret
; here, set zero as result, Set Z flag, if count == size then
; set xc to sign bit and set V flag if original isnt zero 
i09lerltoobig:
	mov     dword ptr [ebx],0
	mov     bl,4h
	or      al,al
	jz      i09lerltbz
	or      bl,2
i09lerltbz:
	cmp     cl,32
	jne     i09lerltbs
        test    eax,eax           ;80000000h
	jns     i09lerltbs
	or      bl,11h
i09lerltbs:
	mov     byte ptr _sr,bl
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret     

; Here, shift count always 1.  Things to care about:
; 1. Sign change during shift, done in hardware when count is 1

i09_RI_M_W_:
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	mov     edx,ebx
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
	sar     dx,1
	pushfd
	pop     ecx
	and     ecx,0fffh               ; Overflow defined here!
	mov     eax,dword ptr [edi+16]          ; get dest rut ptr.
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	call    eax     
	mov     eax,dword ptr [edi+20]
	ret

i09_LE_M_W_:
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	mov     edx,ebx
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
	sal     dx,1
	pushfd
	pop     ecx
	and     ecx,0fffh               ; OF defined here
	mov     eax,dword ptr [edi+16]          ; get dest rut ptr.
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	call    eax     
	mov     eax,dword ptr [edi+20]
	ret


;
; Bcc
; Tableusage 0- rut 1- disrut 2-displacement(32bit)  3-handle routine
;

                align   4

public  i11_B_
i11_B_:         mov     eax,[edi+12]
                call    eax                             ; edx = 1 take branch
                test    dl,dl
                jz      i11bnob
                mov     ebx,[edi+8]                     ; get disp
                test    bl,1
                jnz     i11ex
                add     esi,ebx                         ; New PC
#ifdef PREFETCH
                mov     edx,esi
                call    prefetch_fill_
#endif
                mov     eax,8
                ret
i11bnob:        mov     eax,10
                ret
i11ex:          mov     ebx,0ch                         ; Jump to odd address
                mov     eax,44                          ; Raise exception
                jmp     prepare_exception_


                align   4

public i11_W_
i11_W_:         mov     eax,[edi+12]
                call    eax                         ; edx != 0 take branch
                test    dl,dl
                jz      i11wnob
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ebx,dx
                test    dl,1
                jnz     i11ex
                mov     eax,12
                add     esi,ebx
#ifdef PREFETCH
                mov     edx,esi
                call    prefetch_fill_
#endif
                ret
i11wnob:
#ifdef PREFETCH
                mov     ecx,esi
                fetchwopcode_inc_pos
#endif
                add     esi,2
                mov     eax,10
                ret
        

;
; BCHG.B Dn,<ea>
; Tableusage dynamisk:
; 2 - eareg 3-eales 4-reg 5-cycle count 6-easkriv
; Tableusage statisk:
; 2 - eareg 3-eales 4-cycle count 5-easkriv
; Flag: Z - state of the bit before the operation, others unaffected
;

; Dregister dest er long
i12_D_L_:
	mov     eax,dword ptr [edi+8]   ; get ea register pointer
	mov     ecx,dword ptr [edi+16]  ; get register with bit number
	mov     ebx,dword ptr [eax]     ; get ea register content
	mov     edx,dword ptr [ecx]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	btc     ebx,edx
	jc      i12dl1
	or      ecx,4
i12dl1: mov     dword ptr _sr,ecx
	mov     dword ptr [eax],ebx     ; write ea register content
	mov     eax,dword ptr [edi+20]
	ret
       
;  dest er byte ellers
i12_D_B_:
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax                     ; get ea-content
	mov     eax,dword ptr [edi+16]  ; get bit number register pointer
	mov     eax,dword ptr [eax]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     eax,07h                 ; modulo 8
	btc     edx,eax
	jc      i12db1
	or      ecx,4
i12db1: mov     dword ptr _sr,ecx
	mov     ebx,dword ptr [edi+8]
	mov     eax,dword ptr [edi+24]
	call    eax
	mov     eax,dword ptr [edi+20]
	ret
       
; Dregister dest er long
i12_S_L_:
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr [edi+8]   ; get register pointer
	mov     ebx,dword ptr [eax]     ; get register content
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	btc     ebx,edx
	jc      i12sl1
	or      ecx,4
i12sl1: mov     dword ptr _sr,ecx
	mov     dword ptr [eax],ebx
	mov     eax,dword ptr [edi+16]
	ret
       
;  dest er byte ellers
i12_S_B_:
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     ebx,07h                 ; modulo 8
	btc     edx,ebx
	jc      i12sb1
	or      ecx,4
i12sb1: mov     dword ptr _sr,ecx
	mov     ebx,dword ptr [edi+8]
	mov     eax,dword ptr [edi+20]
	call    eax
	mov     eax,dword ptr [edi+16]
	ret
       
;
; BCLR.B Dn,<ea>
; Tableusage dynamisk:
; 2 - eareg 3-eales 4-reg 5-cycle count 6-easkriv
; Tableusage statisk:
; 2 - eareg 3-eales 4-cycle count 5-easkriv
;

; Dregister dest er long
i13_D_L_:
	mov     eax,dword ptr [edi+8]   ; get ea register pointer
	mov     ecx,dword ptr [edi+16]  ; get register with bit number
	mov     ebx,dword ptr [eax]     ; get ea register content
	mov     edx,dword ptr [ecx]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	btr     ebx,edx
	jc      i13dl1
	or      ecx,4
i13dl1: mov     dword ptr _sr,ecx
	mov     dword ptr [eax],ebx     ; write ea register content
	mov     eax,dword ptr [edi+20]
	ret
       
;  dest er byte ellers
i13_D_B_:
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax                     ; get ea-content
	mov     eax,dword ptr [edi+16]  ; get bit number register pointer
	mov     eax,dword ptr [eax]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     eax,07h                 ; modulo 8
	btr     edx,eax
	jc      i13db1
	or      ecx,4
i13db1: mov     dword ptr _sr,ecx
	mov     ebx,dword ptr [edi+8]
	mov     eax,dword ptr [edi+24]
	call    eax
	mov     eax,dword ptr [edi+20]
	ret
       
; Dregister dest er long
i13_S_L_:
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr [edi+8]   ; get register pointer
	mov     ebx,dword ptr [eax]     ; get register content
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	btr     ebx,edx
	jc      i13sl1
	or      ecx,4
i13sl1: mov     dword ptr _sr,ecx
	mov     dword ptr [eax],ebx
	mov     eax,dword ptr [edi+16]
	ret
       
;  dest er byte ellers
i13_S_B_:
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
        mov     ebx,edx
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax
        mov     ecx,dword ptr _sr
        and     ecx,0fffffffbh
        and     ebx,07h                 ; modulo 8
        btr     edx,ebx
        jc      i13sb1
        or      ecx,4
i13sb1:
        mov     dword ptr _sr,ecx
	mov     ebx,dword ptr [edi+8]
	mov     eax,dword ptr [edi+20]
        and     edx,0ffh
        call    eax
	mov     eax,dword ptr [edi+16]
	ret

;
; BSET.B Dn,<ea>
; Tableusage dynamisk:
; 2 - eareg 3-eales 4-reg 5-cycle count 6-easkriv
; Tableusage statisk:
; 2 - eareg 3-eales 4-cycle count 5-easkriv
;

; Dregister dest er long
i15_D_L_:
	mov     eax,dword ptr [edi+8]   ; get ea register pointer
	mov     ecx,dword ptr [edi+16]  ; get register with bit number
	mov     ebx,dword ptr [eax]     ; get ea register content
	mov     edx,dword ptr [ecx]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	bts     ebx,edx
	jc      i15dl1
	or      ecx,4
i15dl1: mov     dword ptr _sr,ecx
	mov     dword ptr [eax],ebx     ; write ea register content
	mov     eax,dword ptr [edi+20]
	ret
       
;  dest er byte ellers
i15_D_B_:
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax                     ; get ea-content
	mov     eax,dword ptr [edi+16]  ; get bit number register pointer
	mov     eax,dword ptr [eax]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     eax,07h                 ; modulo 8
	bts     edx,eax
	jc      i15db1
	or      ecx,4
i15db1: mov     dword ptr _sr,ecx
	mov     ebx,dword ptr [edi+8]
	mov     eax,dword ptr [edi+24]
	call    eax
	mov     eax,dword ptr [edi+20]
	ret
       
; Dregister dest er long
i15_S_L_:
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr [edi+8]   ; get register pointer
	mov     ebx,dword ptr [eax]     ; get register content
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	bts     ebx,edx
	jc      i15sl1
	or      ecx,4
i15sl1: mov     dword ptr _sr,ecx
	mov     dword ptr [eax],ebx
	mov     eax,dword ptr [edi+16]
	ret
       
;  dest er byte ellers
i15_S_B_:
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     ebx,07h                 ; modulo 8
	bts     edx,ebx
	jc      i15sb1
	or      ecx,4
i15sb1: mov     dword ptr _sr,ecx
	mov     ebx,dword ptr [edi+8]
	mov     eax,dword ptr [edi+20]
	call    eax
	mov     eax,dword ptr [edi+16]
	ret

;
; BTST.B Dn,<ea>
; Tableusage dynamisk:
; 2 - eareg 3-eales 4-reg 5-cycle count 
; Tableusage statisk:
; 2 - eareg 3-eales 4-cycle count 
;
 
; Dregister dest er long
i17_D_L_:
	mov     eax,dword ptr [edi+8]   ; get ea register pointer
	mov     ecx,dword ptr [edi+16]  ; get register with bit number
	mov     ebx,dword ptr [eax]     ; get ea register content
	mov     edx,dword ptr [ecx]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	bt      ebx,edx
	jc      i17dl1
	or      ecx,4
i17dl1: mov     dword ptr _sr,ecx
	mov     eax,dword ptr [edi+20]
	ret
       
;  dest er byte ellers
i17_D_B_:
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax                     ; get ea-content
	mov     eax,dword ptr [edi+16]  ; get bit number register pointer
	mov     eax,dword ptr [eax]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     eax,07h                 ; modulo 8
	bt      edx,eax
	jc      i17db1
	or      ecx,4
i17db1: mov     dword ptr _sr,ecx
	mov     eax,dword ptr [edi+20]
	ret
       
; Dregister dest er long
i17_S_L_:
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr [edi+8]   ; get register pointer
	mov     ebx,dword ptr [eax]     ; get register content
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	bt      ebx,edx
	jc      i17sl1
	or      ecx,4
i17sl1: mov     dword ptr _sr,ecx
	mov     eax,dword ptr [edi+16]
	ret
       
;  dest er byte ellers
i17_S_B_:
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     ebx,07h                 ; modulo 8
	bt      edx,ebx
	jc      i17sb1
	or      ecx,4
i17sb1: mov     dword ptr _sr,ecx
	mov     eax,dword ptr [edi+16]
	ret

       
;
; CHK.W <ea>,Dn
; 2 - eareg 3-eales 4-reg 5-cycle count
; Gi faen i  optimalisere denne.  Den kalles aldri...
;

i18_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [ebx]
	and     dword ptr _sr,0fffffffbh
	or      ax,ax
	js      i18trapset
	cmp     ax,dx
	ja      i18trap
	mov     eax,dword ptr [edi+20]
	ret
i18TrapSet:
	or      dword ptr _sr,04h
i18Trap:mov     ebx,18h                         ; vector at $18
	mov     eax,34
	add     eax,dword ptr [edi+20]
        jmp    prepare_exception_

;
; CLR.? <ea>
; 2-eareg 3-easkriv 4-cyclecount
;

i19_:
        xor     edx,edx
	mov     eax,dword ptr [edi+12]
	mov     ebx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h                  ; X unaffected
	or      eax,04h                         ; 0100
	mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+16]
	ret

;
; CMP.X <ea>,Dn 
; Flag: All, X unaffected
;
i20_B_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     eax,dword ptr [edi+20]      ;        13      1
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	cmp     cl,dl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     ecx                         ;         8      1
	and     ecx,0fffh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*ecx];        10      3
	mov     ecx,dword ptr _sr           ;                1
	and     ecx,0fffffff0h              ;                1
	and     ebx,0fh                     ;                1
	or      ecx,ebx                     ;                1
	mov     dword ptr _sr,ecx           ;        11      1
	ret                                 ;        15      5

i20_W_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     eax,dword ptr [edi+20]      ;        13      1
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
        cmp     cx,dx                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     ecx                         ;         8      1
	and     ecx,0fffh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*ecx];        10      3
	mov     ecx,dword ptr _sr           ;                1
	and     ecx,0fffffff0h              ;                1
	and     ebx,0fh                     ;                1
	or      ecx,ebx                     ;                1
	mov     dword ptr _sr,ecx           ;        11      1
	ret                                 ;        15      5

i20_L_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     eax,dword ptr [edi+20]      ;        13      1
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	cmp     ecx,edx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     ecx                         ;         8      1
	and     ecx,0fffh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*ecx];        10      3
	mov     ecx,dword ptr _sr           ;                1
	and     ecx,0fffffff0h              ;                1
	and     ebx,0fh                     ;                1
	or      ecx,ebx                     ;                1
	mov     dword ptr _sr,ecx           ;        11      1
	ret                                 ;        15      5

;
; CMPA.W/L <ea>,An 
; Flag: All, X unaffected
;

i21_W_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     eax,dword ptr [edi+20]      ;        13      1
	movsx   edx,dx
	mov     ecx,dword ptr [ebx]         ; Les An  5      3
	cmp     ecx,edx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     ecx                         ;         8      1
	and     ecx,0fffh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*ecx];        10      3
	mov     ecx,dword ptr _sr           ;                1
	and     ecx,0fffffff0h              ;                1
	and     ebx,0fh                     ;                1
	or      ecx,ebx                     ;                1
	mov     dword ptr _sr,ecx           ;        11      1
	ret                                 ;        15      5

i21_L_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     eax,dword ptr [edi+20]      ;        13      1
	mov     ecx,dword ptr [ebx]         ; Les An  5      3
	cmp     ecx,edx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     ecx                         ;         8      1
	and     ecx,0fffh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*ecx];        10      3
	mov     ecx,dword ptr _sr           ;                1
	and     ecx,0fffffff0h              ;                1
	and     ebx,0fh                     ;                1
	or      ecx,ebx                     ;                1
	mov     dword ptr _sr,ecx           ;        11      1
	ret                                 ;        15      5

;
; CMPI.X #,<ea>
; Flag: NZCV, X unaffected
;
i22_B_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	cmp     dl,bl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     ecx                         ;         8      1
	and     ecx,0fffh                   ;         9      1
	mov     ecx,dword ptr [_statustab+4*ecx];        10      3
	mov     ebx,dword ptr _sr
	and     ebx,0fffffff0h
	and     ecx,0fh
	or      ebx,ecx
	mov     dword ptr _sr,ebx             ;        11      1
	ret                                 ;        16      5

i22_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	cmp     dx,bx                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     ecx                         ;         8      1
	and     ecx,0fffh                   ;         9      1
	mov     ecx,dword ptr [_statustab+4*ecx];        10      3
	mov     ebx,dword ptr _sr
	and     ebx,0fffffff0h
	and     ecx,0fh
	or      ebx,ecx
	mov     dword ptr _sr,ebx           ;        11      1
	ret                                 ;        16      5
					    ;              =36
i22_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	cmp     edx,ebx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     ecx                         ;         8      1
	and     ecx,0fffh                   ;         9      1
	mov     ecx,dword ptr [_statustab+4*ecx];        10      3
	mov     ebx,dword ptr _sr
	and     ebx,0fffffff0h
	and     ecx,0fh
	or      ebx,ecx
	mov     dword ptr _sr,ebx           ;        11      1
	ret                                 ;        16      5
					    ;              =36
;
; CMPM
; Tableusage 0- rut 1- disrut 2-soureg 3-destreg
; Flag: All, X unaffected
;

i23_b_:
        mov     eax,dword ptr [edi+8]
	mov     ecx,dword ptr [eax]
        fetchb
	inc     ecx
        cmp     eax,dword ptr [_a7pointer]
        jne     i23_b_j
        inc     ecx
i23_B_j:
	mov     dword ptr [eax],ecx
	mov     ebx,edx                         ; source in ebx
	mov     eax,dword ptr [edi+12]            
	mov     ecx,dword ptr [eax]
        fetchb
	inc     ecx
        cmp     eax,dword ptr [_a7pointer]
        jne     i23_b_i
        inc     ecx
i23_B_i:
	mov     dword ptr [eax],ecx             ; Dest in edx
	cmp     dl,bl
	pushfd
	pop     eax
	and     eax,0fffh                       ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax]    ;        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	and     ebx,0fh
	or      eax,ebx
	mov     dword ptr _sr,eax               ;        11      1
	mov     eax,12
	ret

i23_w_:
        mov     eax,dword ptr [edi+8]
	mov     ecx,dword ptr [eax]
        fetchw
	add     ecx,2
	mov     dword ptr [eax],ecx
	mov     ebx,edx                         ; source in ebx
	mov     eax,dword ptr [edi+12]            
	mov     ecx,dword ptr [eax]
        fetchw
	add     ecx,2
	mov     dword ptr [eax],ecx             ; Dest in edx
	cmp     dx,bx
	pushfd
	pop     eax
	and     eax,0fffh                       ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax]    ;        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	and     ebx,0fh
	or      eax,ebx
	mov     dword ptr _sr,eax               ;        11      1
	mov     eax,12
	ret

i23_l_:
        mov     eax,dword ptr [edi+8]
	mov     ecx,dword ptr [eax]
        fetchl
	add     ecx,4
	mov     dword ptr [eax],ecx
	mov     ebx,edx                         ; source in ebx
	mov     eax,dword ptr [edi+12]            
	mov     ecx,dword ptr [eax]
        fetchl
	add     ecx,4
	mov     dword ptr [eax],ecx             ; Dest in edx
	cmp     edx,ebx
	pushfd
	pop     eax
	and     eax,0fffh                       ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax]    ;        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	and     ebx,0fh
	or      eax,ebx
	mov     dword ptr _sr,eax               ;        11      1
	mov     eax,20
	ret

;
; DBcc
; Tableusage 0- rut 1- disrut 2-register*4+d 3-handle routine
; Flags: None
;

i24_:
        mov     eax,dword ptr [edi+12]
	call    eax
        test    dl,dl
	jnz     i24ferdig
	mov     ebx,dword ptr [edi+8]
	mov     edx,dword ptr [ebx]
	dec     dx
	mov     dword ptr [ebx],edx
        cmp     dx,-1
        je      i24out
	mov     ecx,esi
        fetchwopcode_inc_pos
	movsx   edx,dx
	add     esi,edx
#ifdef PREFETCH
        mov     edx,esi
        call    prefetch_fill_
#endif
	mov     eax,10
	ret
i24out: mov     eax,14
#ifdef PREFETCH
        mov     ecx,esi
        fetchwopcode_inc_pos
#endif
	add     esi,2
	ret
i24ferdig:
	mov     eax,12
#ifdef PREFETCH
        mov     ecx,esi
        fetchwopcode_inc_pos
#endif
	add     esi,2
	ret

;
; DIVS.W <ea>,Dx
; 2-reg 3-ea les rut 4-dreg*4+d
; Flags: X unaffected, C = 0, NZV
;
i25_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	movsx   ecx,dx
	or      ecx,ecx
	jz      i25divzero
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [ebx]
	xor     edx,edx
	or      eax,eax
	jns     i25ns
	dec     edx
i25ns:  idiv    ecx
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	cmp     eax,32768                       ; Sjekk resultat overflow
	jle     i25noov1
	or      ecx,1                           ; Overflow
	jmp     i25fin
i25noov1:
	cmp     eax,-32767                      ;overflow
	jge     i25noov2
	or      ecx,1
	jmp     i25fin
i25noov2:
	or      eax,eax
	jnz     i25noz
	or      ecx,4
	jmp     i25finish
i25noz: jns     i25finish
	or      ecx,8
i25finish:
	and     eax,0000ffffh
	shl     edx,16
	and     edx,0ffff0000h
	or      eax,edx
	mov     dword ptr [ebx],eax
i25fin: mov     dword ptr _sr,ecx
        mov     eax,148
	ret
i25divzero:
	mov     ebx,14h
	mov     eax,200
        jmp     prepare_exception_

;
; DIVU.W <ea>,Dx
; 2-reg 3-ea les rut 4-dreg*4+d
; Flags: X unaffected, C = 0, NZV
;

i26_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	movzx   ecx,dx
	or      ecx,ecx
	jz      i26divzero
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [ebx]
	xor     edx,edx
	idiv    ecx
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	cmp     eax,65536                       ; Sjekk resultat overflow
	jb      i26noov1
	or      ecx,1                           ; Overflow
	jmp     i26fin
i26noov1:
	or      eax,eax
	jnz     i26noz
	or      ecx,4
	jmp     i26finish
i26noz: jns     i26finish
	or      ecx,8
i26finish:
	and     eax,0000ffffh
	shl     edx,16
	and     edx,0ffff0000h
	or      eax,edx
	mov     dword ptr [ebx],eax
i26fin: mov     dword ptr _sr,ecx
        mov     eax,130 
	ret
i26divzero:
	mov     ebx,14h
	mov     eax,182
        jmp     prepare_exception_

;
; EOR.X Dn,<ea>
; Flag: X unaffected, V = C = 0, NZ
;
i27_B_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ebx,dword ptr [ebx]         ; Les Dn  5      3
	xor     dl,bl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i27_W_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ebx,dword ptr [ebx]         ; Les Dn  5      3
	xor     dx,bx                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i27_L_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ebx,dword ptr [ebx]         ; Les Dn  5      3
	xor     edx,ebx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
;
; EORI.X #,<ea>
; Flag: X unaffected, V = C = 0, NZ
;
i28_B_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	xor     dl,bl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i28_B_CCR_:
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	xor     al,dl
	mov     dword ptr _sr,eax
	mov     eax,20
	ret

i28_W_SR_:
        test    byte ptr [_sr+1],020h
        jz      privilegie_violation
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	xor     eax,edx
	mov     edx,eax
	call    updateSR
	mov     eax,20
	ret

i28_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	xor     dx,bx                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i28_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	xor     edx,ebx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
;
; Instruction EXG.L 
; Tableusage 0 - rutine  1 - disrut  2-reg1 3-reg2 
; Flag: NONE
;
i29_:
#ifdef PROF68
        inc     dword ptr [_profile+4*28]
#endif
        mov     eax,[edi+8]
	mov     ebx,[edi+12]
	mov     ecx,dword ptr [eax]
	mov     edx,dword ptr [ebx]
	mov     dword ptr [eax],edx
	mov     dword ptr [ebx],ecx
	mov     eax,6
	ret

;
; Instruction EXT.L 
; Tableusage 0 - rutine  1 - disrut  2-reg1  
; Flag: X unaffected, V = C = 0, NZ
;
i30_W_:
#ifdef PROF68
        inc     dword ptr [_profile+4*29]
#endif
        mov     ecx,[edi+8]
	mov     eax,4              ; AGI
	mov     edx,dword ptr _sr  ; AGI
	and     edx,0fffffff0h     ; AGI          
	mov     ebx,dword ptr [ecx]
	movsx   bx,bl              
	mov     dword ptr [ecx],ebx
	or      bx,bx
	jz      i30wz
	jns     i30wns
	or      edx,8       
	jmp     i30wns             
i30wz:  or      edx,4       
i30wns: mov     dword ptr _sr,edx
	ret

i30_L_:
#ifdef PROF68
        inc     dword ptr [_profile+4*29]
#endif
        mov     ecx,[edi+8]
	mov     eax,4              ; AGI
	mov     edx,dword ptr _sr  ; AGI
	and     edx,0fffffff0h     ; AGI          
	mov     ebx,dword ptr [ecx]
	movsx   ebx,bx              
	mov     dword ptr [ecx],ebx
	or      ebx,ebx
	jz      i30lz
	jns     i30lns
	or      edx,8       
	jmp     i30lns             
i30lz:  or      edx,4       
i30lns: mov     dword ptr _sr,edx
	ret

;
; Instruction JMP <ea>
; Tableusage 0 - rutine  1 - disrut  2 - eareg 3- eacalcrut 4- cycle time
; Flag: NONE
;

                align   4

public  i31_
i31_:           mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                call    eax
                mov     esi,edx
#ifdef PREFETCH
                call    prefetch_fill_
#endif
                mov     eax,dword ptr [edi+16]
                ret

;
; Instruction JSR <ea>
; Tableusage 0 - rutine  1 - disrut  2 - eareg 3- eacalcrut 4- cycle time
; Flag: NONE
;

                align   4

public i32_
i32_:           test    byte ptr [_config_memory_nokick],0xff
                jz      noio2
                pushad
                sub     esi,2
                cmp     esi,0200000h
                jae     noio
                mov     eax,dword ptr _cmem[esi]
                bswap   eax
                cmp     eax,04eaefe38h
                jne     noio
                call    doio_
                popad
                add     esi,2
#ifdef PREFETCH
                mov     edx,esi         ; doio wastes time anyway, so
                call    prefetch_fill_  ; let's waste some more time
#endif
                mov     eax,20
                mov     dword ptr _d,0
                ret
noio:           popad
noio2:          mov     eax,dword ptr [edi+12]          ; get new pc
                mov     edx,dword ptr [edi+8]
                call    eax
                xchg    esi,edx
                mov     ecx,dword ptr [_a+28]
                sub     ecx,4
                mov     dword ptr [_a+28],ecx
                writel
#ifdef PREFETCH
                mov     edx,esi
                call    prefetch_fill_
#endif
                mov     eax,dword ptr [edi+16]
                ret

;
; Instruction LEA <ea>
; Tableusage 0 - rutine  1 - disrut  2 - eareg 3- eacalcrut 4-areg 5-cycletime
; Flag: NONE
;
i33_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ecx,dword ptr [edi+16]
	mov     dword ptr [ecx],edx             ; Stapp ea i Areg
	mov     eax,dword ptr [edi+20]
	ret

;
; Instruction LINK An,#
; Tableusage 0 - rutine  1 - disrut  2 - Register
; Flag: NONE
;
i34_:
        mov     ebx,dword ptr [edi+8]
	mov     edx,dword ptr [ebx]
	mov     ecx,dword ptr [_a+28]
	sub     ecx,4
	mov     dword ptr [ebx],ecx        ; Load An with updated SP
        writel
	mov     ebx,ecx
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	movsx   edx,dx
	add     ebx,edx
	mov     dword ptr [_a+28],ebx           ; add disp to SP
	mov     eax,16
	ret

;
; LSX.X
; Tableusage:(imm) 0-rut 1-disrut 2-shcount 3-dreg 4-cyclecount
; Tableusage:(reg) 0-rut 1-disrut 2-shcountreg 3-dreg 4-cyclecount
; Tableusage:(mem) 0-rut 1-disrut 2-eareg 3-eales 4-easkriv 5-cyclecount
;
; Problem:  M68 used shift modulo 64, while the intel shX used modulo 32
;           In some cases this will not shift all bits out when expected.
;
;           Will not affect immediate shiftcount
;           Only when shiftcount is in a register.
;           Must check.
;
; Flag: ALL, V = 0
;

i35_zerocountb:
        test    al,al
        pushfd
        pop     ecx                     ; Only NZ, X is unaffected
        and     ecx,0c0h
        shr     ecx,4
        mov     ch,byte ptr [_sr]
        and     ch,10h
        or      ch,cl
        mov     byte ptr [_sr],ch
        mov     eax,4
        ret

i35_zerocountw:
        test    ax,ax
        pushfd
        pop     ecx                     ; Only NZ, X is unaffected
        and     ecx,0c0h
        shr     ecx,4
        mov     ch,byte ptr [_sr]
        and     ch,10h
        or      ch,cl
        mov     byte ptr [_sr],ch
        mov     eax,4
        ret

i35_zerocountl:
        test    eax,eax
        pushfd
        pop     ecx                     ; Only NZ, X is unaffected
        and     ecx,0c0h
        shr     ecx,4
        mov     ch,byte ptr [_sr]
        and     ch,10h
        or      ch,cl
        mov     byte ptr [_sr],ch
        mov     eax,4
        ret



i35_RI_I_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
        shr     al,cl
	pushfd
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     dword ptr [ebx],eax
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	mov     eax,dword ptr [edi+16]
	ret

i35_RI_I_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	shr     ax,cl
	pushfd
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     dword ptr [ebx],eax
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	mov     eax,dword ptr [edi+16]
	ret

i35_RI_I_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	shr     eax,cl
	pushfd
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     dword ptr [ebx],eax
	mov     ecx,dword ptr [_statustab+4*ecx]


	mov     byte ptr _sr,cl
	mov     eax,dword ptr [edi+16]
	ret

i35_RI_R_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountb

        cmp     ecx,8
        jb      i35rirbok
        xor     al,al
        jmp     i35rirbnok
i35rirbok:
	shr     al,cl
i35rirbnok:
	pushfd
	mov     dword ptr [ebx],eax
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     eax,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,al
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret

i35_RI_R_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountw

        cmp     ecx,16
        jb      i35rirwok
        xor     ax,ax
        jmp     i35rirwnok
i35rirwok:
	shr     ax,cl
i35rirwnok:
	pushfd
	mov     dword ptr [ebx],eax
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     eax,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,al
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret

i35_RI_R_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountl

        cmp     ecx,32
        jb      i35rirlok
        xor     eax,eax
        jmp     i35rirlnok
i35rirlok:
        shr     eax,cl
i35rirlnok:
	pushfd
	mov     dword ptr [ebx],eax
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     eax,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,al
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret

i35_LE_I_B_:
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     eax,dword ptr [ebx]             ; get dreg content
	shl     al,cl
	pushfd
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     dword ptr [ebx],eax
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,bl
	ret

i35_LE_I_W_:
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     eax,dword ptr [ebx]             ; get dreg content
	shl     ax,cl
	pushfd
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     dword ptr [ebx],eax
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,bl
	ret

i35_LE_I_L_:
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     eax,dword ptr [ebx]             ; get dreg content
	shl     eax,cl
	pushfd
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     dword ptr [ebx],eax
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,bl
	ret

i35_LE_R_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountb

        cmp     ecx,8
        jb      i35lerbok
        xor     al,al
        jmp     i35lerbnok
i35lerbok:
        shl     al,cl
i35lerbnok:
	pushfd
	mov     dword ptr [ebx],eax
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     eax,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,al
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret

i35_LE_R_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountw

        cmp     ecx,16
        jb      i35lerwok
        xor     ax,ax
        jmp     i35lerwnok
i35lerwok:
        shl     ax,cl
i35lerwnok:
	pushfd
	mov     dword ptr [ebx],eax
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     eax,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,al
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret

i35_LE_R_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountl

        cmp     ecx,32
        jb      i35lerlok
        xor     eax,eax
        jmp     i35lerlnok
i35lerlok:
        shl     eax,cl
i35lerlnok:
	pushfd
	mov     dword ptr [ebx],eax
	mov     edx,ecx
	add     edx,edx                         ; beregn cyclecount
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     eax,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,al
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret

i35_RI_M_W_:
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	mov     edx,ebx
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
	shr     dx,1
	pushfd
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     eax,dword ptr [edi+16]          ; get dest rut ptr.
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	call    eax     
	mov     eax,dword ptr [edi+20]
	ret

i35_LE_M_W_:
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	mov     edx,ebx
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
	shl     dx,1
	pushfd
	pop     ecx
	and     ecx,07ffh ; Overflow always 0
	mov     eax,dword ptr [edi+16]          ; get dest rut ptr.
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	call    eax     
	mov     eax,dword ptr [edi+20]
	ret

;
; Instruction 37   MOVE.X <ea>,<ea>
; Tableusage  2 - sourcereg ptr  3 - source get ea routine
;             4 - destreg ptr  5 - dest set ea routine  6 - cyclecount
; Opcode*32+_t in edi
; Flags: NZ, V=C=0, X unaffected
;


                align   4

public i37_b_
i37_b_:         mov     ecx,dword ptr [edi+12]   
                mov     ebx,dword ptr _sr        
                mov     edx,dword ptr [edi+8]    
                and     ebx,0fffffff0h           
                call    ecx                      
                mov     ebp,dword ptr [edi+20]   
                or      dl,dl                    
                pushfd                           
                pop     ecx                      
                and     ecx,07feh                
                mov     eax,dword ptr [edi+24]   
                or      ebx,dword ptr [_statustab+4*ecx]
                mov     dword ptr _sr,ebx     
                mov     ebx,dword ptr [edi+16]
                jmp     ebp      


                align   4

public i37_w_
i37_w_:         mov     ecx,dword ptr [edi+12]    
                mov     ebx,dword ptr _sr         
                mov     edx,dword ptr [edi+8]     
                and     ebx,0fffffff0h            
                call    ecx                       
                mov     ebp,dword ptr [edi+20]    
                and     edx,0ffffh
                or      dx,dx                     
                pushfd                            
                pop     ecx                       
                and     ecx,07feh                 
                mov     eax,dword ptr [edi+24]    
                or      ebx,dword ptr [_statustab+4*ecx]
                mov     dword ptr _sr,ebx        
                mov     ebx,dword ptr [edi+16]   
                jmp     ebp                      


                align   4

public i37_l_
i37_l_:         mov     ecx,dword ptr [edi+12]
                mov     ebx,dword ptr [_sr]     
                mov     edx,dword ptr [edi+8] 
                and     ebx,0fffffff0h        
                call    ecx                   
                mov     ebp,dword ptr [edi+20]
                or      edx,edx               
                pushfd                        
                pop     ecx                   
                and     ecx,07feh             
                mov     eax,dword ptr [edi+24]
                or      ebx,dword ptr [_statustab+4*ecx]
                mov     dword ptr [_sr],ebx      
                mov     ebx,dword ptr [edi+16] 
                jmp     ebp                    


;
; MOVE to CCR
; 2-_sreg 3-les 4-cycle time
;
i38_:
#ifdef PROF68
        inc     dword ptr [_profile+4*37]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     byte ptr _sr,dl
	mov     eax,dword ptr [edi+16]
	ret

;
; MOVE to SR
; 2-_sreg 3-les 4-cycle time
; Privileged instruction, cannot be executed by user state programs
;
i39_:
#ifdef PROF68
        inc     dword ptr [_profile+4*38]
#endif
        ;sub     esi,2
        test    byte ptr _sr+1,020h
        jz      privilegie_violation
        ;add     esi,2
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	call    updateSR
	mov     eax,dword ptr [edi+16]
	ret


;
; MOVE from SR
; 2-_dreg 3-dskriv 4-cycle time
;
i40_:
#ifdef PROF68
        inc     dword ptr [_profile+4*39]
#endif
        mov     eax,dword ptr [edi+12]
	mov     ebx,dword ptr [edi+8]
	mov     edx,dword ptr _sr
	call    eax
	mov     eax,dword ptr [edi+16]
	ret


;
; MOVE USP
; 2-_Areg
; Privileged instruction, cannot be executed by user state programs
;
; to Ax
i41_1_:
#ifdef PROF68
        inc     dword ptr [_profile+4*40]
#endif
        ;sub     esi,2
        test    byte ptr _sr+1,020h      ; Are we in supervisormode??
        jz      privilegie_violation
        ;add     esi,2
	mov     eax,4
	mov     edx,dword ptr _usp      
	mov     ecx,dword ptr [edi+8]
	mov     dword ptr [ecx],edx
	ret

; from Ax
i41_2_:
#ifdef PROF68
        inc     dword ptr [_profile+4*40]
#endif
        ;sub     esi,2
        test    byte ptr _sr+1,020h       ; Are we in supervisormode??
        jz      privilegie_violation
        ;add     esi,2
        mov     ebx,dword ptr [edi+8]
	mov     eax,4
	mov     edx,dword ptr [ebx]     
	mov     dword ptr _usp,edx
	ret

;
; MOVEA
; 2-_sreg 3-Sles  4-Areg 5-cycle time
; Flag: NONE
;

i42_W_:
#ifdef PROF68
		inc     dword ptr [_profile+4*41]
#endif
		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8]
		call    eax
		movsx   edx,dx
		mov     ebx,dword ptr [edi+16]
		mov     eax,dword ptr [edi+20]
		mov     dword ptr [ebx],edx
		ret

i42_L_:
#ifdef PROF68
		inc     dword ptr [_profile+4*41]
#endif
		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8] 
		call    eax                   
		mov     ebx,dword ptr [edi+16]
		mov     eax,dword ptr [edi+20]
		mov     dword ptr [ebx],edx
		ret
	
;
; MOVEM
; 2-reg 3-eacalc  4-cycle time
; Flag: NONE
;

; Predecrement, to memory
; Order: d0-d7,a0-a7   a7 first

i43_W_PREM_:
		mov     ecx,esi                   ; get register mask word
                fetchwopcode_inc_pos
		add     esi,2
		mov     ebx,edx                   ; Register mask in ebx
		xor     ebp,ebp			  ; count cycles in ebp
		mov     eax,offset _aend          ; pointer to A7
i43wpm2:	sub     eax,4                     ; Point to 1 register less
		shr     ebx,1
		jnc     i43wpm1                   ; Skip this register
		mov     edx,[eax]                 ; get register content
		mov     ecx,[edi+8]		  ; register to predecrement
		sub     dword ptr [ecx],2         ; Decrement register
		mov     ecx,dword ptr [ecx]       ; get ea
		add     ebp,4                     ; 4 cycles each register
		writew                            ; store word
i43wpm1:	cmp     eax,offset _d
		jne     i43wpm2
		lea     eax,8[ebp]
		ret

; Predecrement, to memory
; Order: d0-d7,a0-a7   a7 first

i43_L_PREM_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _aend                ; pointer to A7
i43lpm2:sub     eax,4
	shr     ebx,1
	jnc     i43lpm1                         ; Skip this register
	mov     edx,dword ptr [eax]             ; get register content
	mov     ecx,dword ptr [edi+8]           ; register to predecrement
	sub     dword ptr [ecx],4               ; Decrement register
	mov     ecx,dword ptr [ecx]             ; get ea
	add     ebp,8                           ; 4 cycles for each register
        writel                                  ; store word
i43lpm1:cmp     eax,offset _d
	jne     i43lpm2
	lea     eax,8[ebp]
	ret

; Postincrement, to registers
; Order: a7-a0,d7-d0   d0 first

i43_W_POSTR_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _d                   ; pointer to A7
i43wpr2:shr     ebx,1
	jnc     i43wpr1                         ; Skip this register
	mov     edx,dword ptr [edi+8]           ; register to postincrement
	add     ebp,4                           ; 4 cycles for each register
	mov     ecx,dword ptr [edx]             ; get ea
	add     dword ptr [edx],2               ; increment register
        fetchw                                  ; get memory content
	movsx   edx,dx
	mov     dword ptr [eax],edx             ; store to register
i43wpr1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43wpr2
	lea     eax,8[ebp]
	ret

; Postincrement, to registers
; Order: a7-a0,d7-d0   d0 first
i43_L_POSTR_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _d                   ; pointer to A7
i43lpr2:shr     ebx,1
	jnc     i43lpr1                         ; Skip this register
	mov     edx,dword ptr [edi+8]           ; register to postincrement
	add     ebp,8                           ; 4 cycles for each register
	mov     ecx,dword ptr [edx]             ; get ea
	add     dword ptr [edx],4               ; increment register
        fetchl                            ; get memory content
	mov     dword ptr [eax],edx             ; store to register
i43lpr1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43lpr2
	lea     eax,8[ebp]
	ret

; Control, to registers
; Order: a7-a0,d7-d0   d0 first
i43_W_CONR_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	mov     edx,dword ptr [edi+8]
	mov     ecx,dword ptr [edi+12]          ; calculate first ea
	call    ecx
	mov     ecx,edx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _d                   ; pointer to A7
i43wcr2:shr     ebx,1
	jnc     i43wcr1                         ; Skip this register
	add     ebp,4                           ; 4 cycles for each register
        fetchw                            ; get memory content
	add     ecx,2                           ; increment ea 
	movsx   edx,dx
	mov     dword ptr [eax],edx             ; store to register
i43wcr1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43wcr2
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret

; Control, to registers
; Order: a7-a0,d7-d0   d0 first
i43_L_CONR_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	mov     edx,dword ptr [edi+8]
	mov     ecx,dword ptr [edi+12]          ; calculate first ea
	call    ecx
	mov     ecx,edx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _d                   ; pointer to A7
i43lcr2:shr     ebx,1
	jnc     i43lcr1                         ; Skip this register
        fetchl                            ; get memory content
	add     ebp,8                           ; 8 cycles for each register
	add     ecx,4                           ; increment ea 
	mov     dword ptr [eax],edx             ; store to register
i43lcr1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43lcr2
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret

; Control, to memory
; Order: a7-a0,d7-d0   d0 first
i43_W_CONM_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
        push    edx
	mov     edx,dword ptr [edi+8]
	mov     ecx,dword ptr [edi+12]          ; calculate first ea
	call    ecx
        mov     ecx,edx                         ; ecx is ea
	xor     ebp,ebp                         ; count cycles in ebp
        mov     eax,offset _d                   ; pointer to d0
        pop     ebx
i43wcm2:shr     ebx,1
	jnc     i43wcm1                         ; Skip this register
	add     ebp,4                           ; 4 cycles for each register
	mov     edx,dword ptr [eax]
        writew                            ; get memory content
	add     ecx,2                           ; increment ea 
i43wcm1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43wcm2
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret

; Control, to memory
; Order: a7-a0,d7-d0   d0 first
i43_L_CONM_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	mov     edx,dword ptr [edi+8]
	mov     ecx,dword ptr [edi+12]          ; calculate first ea
	call    ecx
	mov     ecx,edx
	xor     ebp,ebp                         ; count cycles in ebp
        mov     eax,offset _d                   ; pointer to d0
i43lcm2:shr     ebx,1
	jnc     i43lcm1                         ; Skip this register
	add     ebp,8                           ; 4 cycles for each register
	mov     edx,dword ptr [eax]
        writel                            ; store memory content
	add     ecx,4                           ; increment ea 
i43lcm1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43lcm2
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret

;
; MOVEP
; Table:  2- areg 3-dreg
;

; word, mem to reg

i44_W_1_:
        mov     eax,dword ptr [edi+8]   ; Get areg
        mov     eax,dword ptr [eax]
        mov     ecx,esi
        fetchwopcode_inc_pos                    ; Get disp
        movsx   edx,dx                  ; Sign extend
        add     eax,edx                 ; Add
        mov     ecx,eax
        fetchb                    ; Get first byte
        mov     bh,dl
        add     eax,2
        mov     ecx,eax
        fetchb                    ; get second byte
        mov     bl,dl
        mov     eax,dword ptr [edi+12]  ; Get data reg
        mov     word ptr [eax],bx       ; Store word
        add     esi,2
        mov     eax,16
        ret

; Long, mem to reg

i44_L_1_:
        mov     eax,dword ptr [edi+8]   ; Get areg
        mov     eax,dword ptr [eax]
        mov     ecx,esi
        fetchwopcode_inc_pos                    ; Get disp
        movsx   edx,dx                  ; Sign extend
        add     eax,edx                 ; Add
        mov     ecx,eax
        fetchb                    ; Get first byte
        mov     bh,dl
        add     eax,2
        mov     ecx,eax
        fetchb                    ; get second byte
        mov     bl,dl
        shl     ebx,16
        add     eax,2
        mov     ecx,eax
        fetchb                    ; get third byte
        mov     bh,dl
        add     eax,2
        mov     ecx,eax
        fetchb                    ; get fourth byte
        mov     bl,dl
        mov     eax,dword ptr [edi+12]  ; Get data reg
        mov     dword ptr [eax],ebx      ; Store word
        add     esi,2
        mov     eax,20
        ret

; Word, reg to mem

i44_W_2_:
        mov     eax,dword ptr [edi+8]   ; Get areg
        mov     eax,dword ptr [eax]
        mov     ecx,esi
        fetchwopcode_inc_pos                    ; Get disp
        movsx   edx,dx                  ; Sign extend
        add     eax,edx                 ; Add
        mov     ebx,dword ptr [edi+12]  ; Get data reg
        mov     ebx,dword ptr [ebx]     ; get reg contents
        rol     bx,8
        mov     dl,bl
        mov     ecx,eax
        writeb                    ; Write first byte
        rol     bx,8
        mov     dl,bl
        add     eax,2
        mov     ecx,eax
        writeb                    ; Write second byte
        add     esi,2
        mov     eax,16
        ret

; Long, reg to mem

i44_L_2_:
        mov     eax,dword ptr [edi+8]   ; Get areg
        mov     eax,dword ptr [eax]
        mov     ecx,esi
        fetchwopcode_inc_pos                    ; Get disp
        movsx   edx,dx                  ; Sign extend
        add     eax,edx                 ; Add
        mov     ebx,dword ptr [edi+12]  ; Get data reg
        mov     ebx,dword ptr [ebx]     ; get reg contents
        rol     ebx,8
        mov     dl,bl
        mov     ecx,eax
        writeb                    ; Write first byte
        rol     ebx,8
        mov     dl,bl
        add     eax,2
        mov     ecx,eax
        writeb                    ; Write second byte
        rol     ebx,8
        mov     dl,bl
        add     eax,2
        mov     ecx,eax
        writeb                    ; Write third byte
        rol     ebx,8
        mov     dl,bl
        add     eax,2
        mov     ecx,eax
        writeb                    ; Write fourth byte
        add     esi,2
        mov     eax,20
        ret



;
; MOVEQ.L #,Dx
; 2-Dreg 3-32 bit immediate  4-flag byte
; Flag: NZ, X unaffected, V=C=0
;
i45_:
#ifdef PROF68
        inc     dword ptr [_profile+4*44]
#endif
        mov     ebx,dword ptr [edi+8]
	mov     ecx,dword ptr _sr
	mov     eax,dword ptr [edi+12]
	mov     dword ptr [ebx],eax
	mov     ebx,dword ptr [edi+16]
	and     ecx,0fffffff0h
	or      ecx,ebx
	mov     eax,4
	mov     dword ptr _sr,ecx
	ret


;
; MULS.W <ea>,Dx
; 2-reg 3-ea les rut 4-dreg*4+d
; Flag: NZ, X unaffected, V=C=0
;


i46_:
#ifdef PROF68
        inc     dword ptr [_profile+4*45]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	movsx   ecx,dx
        mov     ebp,edx
	mov     ebx,dword ptr [edi+16]
	movsx   eax,word ptr [ebx]
	imul    eax,ecx
	mov     dword ptr [ebx],eax
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	or      eax,eax
	jnz     i46noz
	or      ecx,4
	jmp     i46finish
i46noz: jns     i46finish
	or      ecx,8
i46finish:
	mov     dword ptr _sr,ecx
        mov     ebx,ebp
        mov     cl,bh
        and     ebx,0ffh
        and     ecx,0ffh
        mov     eax,38
        add     al,byte ptr _mulstab[ebx]
        add     al,byte ptr _mulstab[ecx]
	ret

;
; MULU.W <ea>,Dx
; 2-reg 3-ea les rut 4-dreg*4+d
; Flag: NZ, X unaffected, V=C=0
;
i47_:
#ifdef PROF68
        inc     dword ptr [_profile+4*46]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	movzx   ecx,dx
        mov     ebp,edx
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [ebx]
	movzx   eax,ax
	xor     edx,edx
i47ns:  imul    ecx
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	or      eax,eax
	jnz     i47noz
	or      ecx,4
	jmp     i47finish
i47noz: jns     i47finish
	or      ecx,8
i47finish:
	mov     dword ptr [ebx],eax
	mov     dword ptr _sr,ecx
        mov     ebx,ebp
        mov     cl,bh
        and     ebx,0ffh
        and     ecx,0ffh
        mov     eax,38
        add     al,byte ptr _mulutab[ebx]
        add     al,byte ptr _mulutab[ecx]
	ret

;
; Instruction NBCD <ea>
; Tableusage 0 - rutine  1 - disrut  2 - eareg 3- eales 4- easkriv 5-cycletime
;

i48_b_:
#ifdef PROF68
        inc     dword ptr [_profile+4*47]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]           ; get operand
	mov     ebp,edx
	call    eax
	movzx   edx,dl
	xor     eax,eax
	mov     ah,byte ptr [_bcd2hex+edx]      ; convert 2 hex
	mov     al,100
	sub     al,ah
	mov     ah,byte ptr _sr
	test    ah,010h
	jz      i48_bnx
	dec     al
i48_bnx:and     ah,0eeh  ; mask  1110 1110
	or      al,al
	jz      i48_bz
	and     ah,0eah
i48_bz: cmp     al,100
	je      i48_bnc
	or      ah,11h
	jmp     i48_bc
i48_bnc:xor     al,al
i48_bc: mov     byte ptr _sr,ah
        and     eax,0ffh
	mov     dl,byte ptr [_hex2bcd+eax]
	mov     eax,dword ptr [edi+16]
	mov     ebx,ebp
	call    eax
	mov     eax,dword ptr [edi+20]
	ret



;
; Instruction NEG <ea>
; Tableusage 0 - rutine  1 - disrut  2 - eareg 3- eales 4- easkriv 5-cycletime
; Flag: All, X=C
;


i49_b_:
#ifdef PROF68
        inc     dword ptr [_profile+4*48]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	neg     dl
	pushfd
	pop     eax
	and     eax,0fffh                   
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     byte ptr _sr,bl
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr [edi+20]
	ret

i49_w_:
#ifdef PROF68
        inc     dword ptr [_profile+4*48]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	neg     dx
	pushfd
	pop     eax
	and     eax,0fffh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     byte ptr _sr,bl             
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr [edi+20]
	ret

i49_l_:
#ifdef PROF68
        inc     dword ptr [_profile+4*48]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	neg     edx
	pushfd
	pop     eax
	and     eax,0fffh                   
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     byte ptr _sr,bl             
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr [edi+20]
	ret


;
; Instruction NEGX <ea>
; Tableusage 0 - rutine  1 - disrut  2 - eareg 3- eales 4- easkriv 5-cycletime
; Flag: All, Z unchanged if result is non-zero
;


                align   4

public i50_b_
i50_b_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                mov     ebp,edx
                call    eax
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i50_b1
                inc     dl
i50_b1:         neg     dl
                pushfd
                pop     eax
                and     eax,0fbfh                   
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dl,dl                           ; Clear if nonzero
                jz      i50bnz
                xor     ah,ah
i50bnz:         or      al,ah
                mov     byte ptr _sr,al              
                mov     eax,dword ptr [edi+16]
                mov     ebx,ebp
                call    eax
                mov     eax,dword ptr [edi+20]
                ret


                align   4
                
public i50_w_
i50_w_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                mov     ebp,edx
                call    eax
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i50_w1
                inc     dx
i50_w1:         neg     dx
                pushfd
                pop     eax
                and     eax,0fbfh                   
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dx,dx                           ; Clear if nonzero
                jz      i50wnz
                xor     ah,ah
i50wnz:         or      al,ah
                mov     byte ptr _sr,al
                mov     eax,dword ptr [edi+16]
                mov     ebx,ebp
                call    eax
                mov     eax,dword ptr [edi+20]
                ret


                align   4

public i50_l_
i50_l_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                mov     ebp,edx
                call    eax
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i50_l1
                inc     edx
i50_l1:         neg     edx
                pushfd
                pop     eax
                and     eax,0fbfh                   
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    edx,edx                         ; Clear if nonzero
                jz      i50lnz
                xor     ah,ah
i50lnz:         or      al,ah
                mov     byte ptr _sr,al           
                mov     eax,dword ptr [edi+16]
                mov     ebx,ebp
                call    eax
                mov     eax,dword ptr [edi+20]
                ret


;
; NOP
; Flag: NONE
;


                align   4

public i51_
i51_:           mov     eax,4
                ret


;
; Instruction NOT <ea>
; Tableusage 0 - rutine  1 - disrut  2 - eareg 3- eales 4- easkriv 5-cycletime
; Flag: NZ, V=C=0, X unaffected
;
i52_b_:
#ifdef PROF68
        inc     dword ptr [_profile+4*51]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	mov     ebp,edx
	call    eax
	not     dl
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      dl,dl
	js      i52_bn
	jnz     i52_bnz
	or      eax,4
	jmp     i52_bnz
i52_bn: or      eax,8
i52_bnz:mov     dword ptr _sr,eax 
	mov     eax,dword ptr [edi+16]
	mov     ebx,ebp
	call    eax
	mov     eax,dword ptr [edi+20]
	ret

i52_w_:
#ifdef PROF68
        inc     dword ptr [_profile+4*51]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	mov     ebp,edx
	call    eax
	not     dx
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      dx,dx
	js      i52_wn
	jnz     i52_wnz
	or      eax,4
	jmp     i52_wnz
i52_wn: or      eax,8
i52_wnz:mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+16]
	mov     ebx,ebp
	call    eax
	mov     eax,dword ptr [edi+20]
	ret

i52_l_:
#ifdef PROF68
        inc     dword ptr [_profile+4*51]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	mov     ebp,edx
	call    eax
	not     edx
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      edx,edx
	js      i52_ln
	jnz     i52_lnz
	or      eax,4
	jmp     i52_lnz
i52_ln: or      eax,8
i52_lnz:mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+16]
	mov     ebx,ebp
	call    eax
	mov     eax,dword ptr [edi+20]
	ret

;
; OR.X <ea>,Dn / OR.X Dn,<ea>
; Flagg: X unaffected, N Z, V = C = 0
;
i53_B_1_:                                   
#ifdef PROF68
        inc     dword ptr [_profile+4*52]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	or      cl,dl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     dword ptr [ebx],ecx         ;        12      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h              ; Trenger ikke and p ebx
	or      eax,ebx
	mov     dword ptr _sr,eax           ;        11      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =31
i53_W_1_:
#ifdef PROF68
        inc     dword ptr [_profile+4*52]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]           ; Les Dn  5      4
	or      cx,dx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     dword ptr [ebx],ecx         ;        12      2
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax           ;        11      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =34
i53_L_1_:
#ifdef PROF68
        inc     dword ptr [_profile+4*52]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	or      ecx,edx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     dword ptr [ebx],ecx         ;        12      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax           ;        11      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =31
i53_B_2_:
#ifdef PROF68
        inc     dword ptr [_profile+4*52]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     dh,byte ptr [ebx]           ; Les Dn  5      3
	or     dl,dh                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i53_W_2_:
#ifdef PROF68
        inc     dword ptr [_profile+4*52]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      4
	or      dx,cx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ; C=0     9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =38
i53_L_2_:
#ifdef PROF68
        inc     dword ptr [_profile+4*52]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      3
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	or      edx,ecx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
;
; ORI.X #,<ea>
; Flagg: X unaffected, N Z, V = C = 0
;
i54_B_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	or      dl,bl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i54_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	or      dx,bx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =38
i54_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      3
	call    eax                         ; Les <ea>3      5
	or      edx,ebx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     dword ptr _sr,eax           ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5

i54_B_CCR_:
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	or      al,dl
	mov     dword ptr _sr,eax
	mov     eax,20
	ret

i54_W_SR_:
        test    byte ptr _sr+1,020h
        jz      privilegie_violation
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	or      eax,edx
	mov     edx,eax
	call    updateSR
	mov     eax,20
	ret

;
; Instruction PEA <ea>
; Tableusage 0 - rutine  1 - disrut  2 - eareg 3- eacalcrut 4- cycle time
;
i55_:
#ifdef PROF68
        inc     dword ptr [_profile+4*54]
#endif
        mov     eax,dword ptr [edi+12]          ; get new pc
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ecx,dword ptr [_a+28]
	sub     ecx,4
	mov     dword ptr [_a+28],ecx
        writel
	mov     eax,dword ptr [edi+16]
	ret

;
; RESET (Probably wrong)
; Jump to location in $4 ($f80004)
;
i56_:
        mov     ecx,0f80004h
        fetchl
        mov     esi,edx
#ifdef PREFETCH
        call    prefetch_fill_
#endif
	mov     eax,132
	ret

;
; ROX.X
; Tableusage:(imm) 0-rut 1-disrut 2-shcount 3-dreg 4-cyclecount
; Tableusage:(reg) 0-rut 1-disrut 2-shcountreg 3-dreg 4-cyclecount
; Tableusage:(mem) 0-rut 1-disrut 2-eareg 3-eales 4-easkriv 5-cyclecount
;
i57_RI_I_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
        ror     al,cl
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      al,al
	jz      i57rib1
	jns     i57rib2
	or      edx,8                            ; set N flag
	jmp     i57rib2
i57rib1:or      edx,4                            ; set Z flag
i57rib2:mov     ecx,eax
	shr     cl,7
	or      dl,cl                            ; set C flag
	mov     dword ptr _sr,edx                ; Store flags
	mov     byte ptr [ebx],al
	mov     eax,dword ptr [edi+16]
	ret

i57_RI_I_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	ror     ax,cl
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      ax,ax
	jz      i57riw1
	jns     i57riw2
	or      edx,8                            ; set N flag
	jmp     i57riw2
i57riw1:or      edx,4                            ; set Z flag
i57riw2:mov     ecx,eax
	shr     ch,7
	or      dl,ch                            ; set C flag
	mov     dword ptr _sr,edx                ; Store flags
	mov     word ptr [ebx],ax
	mov     eax,dword ptr [edi+16]
	ret

i57_RI_I_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	ror     eax,cl
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      eax,eax
	jz      i57ril1
	jns     i57ril2
	or      edx,8                            ; set N flag
	jmp     i57ril2
i57ril1:or      edx,4                            ; set Z flag
i57ril2:mov     ecx,eax
	shr     ecx,31
	or      edx,ecx                          ; set C flag
	mov     dword ptr _sr,edx                  ; Store flags
	mov     dword ptr [ebx],eax
	mov     eax,dword ptr [edi+16]
	ret

i57_RI_R_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountb
        ror     al,cl
	add     ecx,ecx
	mov     ebp,dword ptr [edi+16]
	add     ebp,ecx
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      al,al
	jz      i57rrb1
	jns     i57rrb2
	or      edx,8                            ; set N flag
	jmp     i57rrb2
i57rrb1:or      edx,4                            ; set Z flag
i57rrb2:mov     ecx,eax
	shr     cl,7
	or      dl,cl                            ; set C flag
	mov     dword ptr _sr,edx                ; Store flags
	mov     byte ptr [ebx],al
	mov     eax,ebp
	ret

i57_RI_R_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountw
	ror     ax,cl
	add     ecx,ecx
	mov     ebp,dword ptr [edi+16]
	add     ebp,ecx
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      ax,ax
	jz      i57rrw1
	jns     i57rrw2
	or      edx,8                            ; set N flag
	jmp     i57rrw2
i57rrw1:or      edx,4                            ; set Z flag
i57rrw2:mov     ecx,eax
	shr     ch,7
	or      dl,ch                            ; set C flag
	mov     dword ptr _sr,edx                ; Store flags
	mov     word ptr [ebx],ax
	mov     eax,ebp
	ret

i57_RI_R_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountl
	ror     eax,cl
	add     ecx,ecx
	mov     ebp,dword ptr [edi+16]
	add     ebp,ecx
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      eax,eax
	jz      i57rrl1
	jns     i57rrl2
	or      edx,8                            ; set N flag
	jmp     i57rrl2
i57rrl1:or      edx,4                            ; set Z flag
i57rrl2:mov     ecx,eax
	shr     ecx,31
	or      edx,ecx                          ; set C flag
	mov     dword ptr _sr,edx                  ; Store flags
	mov     dword ptr [ebx],eax
	mov     eax,ebp
	ret

i57_LE_I_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	rol     al,cl
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      al,al
	jz      i57lib1
	jns     i57lib2
	or      edx,8                            ; set N flag
	jmp     i57lib2
i57lib1:or      edx,4                            ; set Z flag
i57lib2:mov     ecx,eax
	and     ecx,1
	or      edx,ecx                          ; set C flag
	mov     dword ptr _sr,edx                  ; Store flags
	mov     byte ptr [ebx],al
	mov     eax,dword ptr [edi+16]
	ret

i57_LE_I_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	rol     ax,cl
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      ax,ax
	jz      i57liw1
	jns     i57liw2
	or      edx,8                            ; set N flag
	jmp     i57liw2
i57liw1:or      edx,4                            ; set Z flag
i57liw2:mov     ecx,eax
	and     ecx,1
	or      edx,ecx                           ; set C flag
	mov     dword ptr _sr,edx                  ; Store flags
	mov     word ptr [ebx],ax
	mov     eax,dword ptr [edi+16]
	ret

i57_LE_I_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	rol     eax,cl
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      eax,eax
	jz      i57lil1
	jns     i57lil2
	or      edx,8                            ; set N flag
	jmp     i57lil2
i57lil1:or      edx,4                            ; set Z flag
i57lil2:mov     ecx,eax
	and     ecx,1
	or      edx,ecx                           ; set C flag
	mov     dword ptr _sr,edx                  ; Store flags
	mov     dword ptr [ebx],eax
	mov     eax,dword ptr [edi+16]
	ret

i57_LE_R_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountb
	rol     al,cl
	add     ecx,ecx
	mov     ebp,dword ptr [edi+16]
	add     ebp,ecx
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      al,al
	jz      i57lrb1
	jns     i57lrb2
	or      edx,8                            ; set N flag
	jmp     i57lrb2
i57lrb1:or      edx,4                            ; set Z flag
i57lrb2:mov     ecx,eax
	and     ecx,1
	or      edx,ecx                           ; set C flag
	mov     dword ptr _sr,edx                 ; Store flags
	mov     byte ptr [ebx],al
	mov     eax,ebp
	ret

i57_LE_R_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountw
	rol     ax,cl
	add     ecx,ecx
	mov     ebp,dword ptr [edi+16]
	add     ebp,ecx
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      ax,ax
	jz      i57lrw1
	jns     i57lrw2
	or      edx,8                            ; set N flag
	jmp     i57lrw2
i57lrw1:or      edx,4                            ; set Z flag
i57lrw2:mov     ecx,eax
	and     ecx,1
	or      edx,ecx                           ; set C flag
	mov     dword ptr _sr,edx                 ; Store flags
	mov     word ptr [ebx],ax
	mov     eax,ebp
	ret

i57_LE_R_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	mov     eax,dword ptr [ebx]             ; get dreg content
	and     ecx,3fh                         ; modulo 64
        jz      i35_zerocountl
	rol     eax,cl
	add     ecx,ecx
	mov     ebp,dword ptr [edi+16]
	add     ebp,ecx
	mov     edx,dword ptr _sr
	and     edx,0fffffff0h
	or      eax,eax
	jz      i57lrl1
	jns     i57lrl2
	or      edx,8                            ; set N flag
	jmp     i57lrl2
i57lrl1:or      edx,4                            ; set Z flag
i57lrl2:mov     ecx,eax
	and     ecx,1
	or      edx,ecx                           ; set C flag
	mov     dword ptr _sr,edx                 ; Store flags
	mov     dword ptr [ebx],eax
	mov     eax,ebp
	ret

i57_RI_M_W_:
        mov     edx,dword ptr [edi+8]           ; get ea reg ptr
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
        ror     dx,1
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      dx,dx
	jz      i57rmw1
	jns     i57rmw2
	or      eax,8                            ; set N flag
	jmp     i57rmw2
i57rmw1:or      eax,4                            ; set Z flag
i57rmw2:mov     ecx,edx
	shr     ch,7
	or      al,ch                           ; set C flag
	mov     dword ptr _sr,eax                  ; Store flags
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	call    eax
	mov     eax,dword ptr [edi+20]
	ret

i57_LE_M_W_:
        mov     edx,dword ptr [edi+8]           ; get ea reg ptr
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
        rol     dx,1
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      dx,dx
	jz      i57lmw1
	jns     i57lmw2
	or      eax,8                            ; set N flag
	jmp     i57lmw2
i57lmw1:or      eax,4                            ; set Z flag
i57lmw2:mov     ecx,edx
	and     ecx,1
	or      eax,ecx                           ; set C flag
	mov     dword ptr _sr,eax                 ; Store flags
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	call    eax
	mov     eax,dword ptr [edi+20]
	ret

;
; ROXX.X  100% correct flag handling, rewrite the others sometime
; Tableusage:(imm) 0-rut 1-disrut 2-shcount 3-dreg 4-cyclecount
; Tableusage:(reg) 0-rut 1-disrut 2-shcountreg 3-dreg 4-cyclecount
; Tableusage:(mem) 0-rut 1-disrut 2-eareg 3-eales 4-easkriv 5-cyclecount
;
i59_RI_I_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
	test    ch,10h
	jz      i59rib3
	stc
i59rib3:rcr     al,cl
	jc      i59ribcs
	xor     ch,ch
	jmp     i59ribnocs
i59ribcs:
	mov     ch,11h
i59ribnocs:
	or      al,al
	jz      i59rib1
	jns     i59rib2
	or      ch,8                            ; set N flag
	jmp     i59rib2
i59rib1:or      ch,4                            ; set Z flag
i59rib2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     byte ptr [ebx],al
	mov     eax,dword ptr [edi+16]
	ret

i59_RI_I_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
	test    ch,10h
	jz      i59riw3
	stc
i59riw3:rcr     ax,cl
	jc      i59riwcs
	xor     ch,ch
	jmp     i59riwnocs
i59riwcs:
	mov     ch,11h
i59riwnocs:
	or      ax,ax
	jz      i59riw1
	jns     i59riw2
	or      ch,8                            ; set N flag
	jmp     i59riw2
i59riw1:or      ch,4                            ; set Z flag
i59riw2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     word ptr [ebx],ax
	mov     eax,dword ptr [edi+16]
	ret

i59_RI_I_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
	test    ch,10h
	jz      i59ril3
	stc
i59ril3:rcr     eax,cl
	jc      i59rilcs
	xor     ch,ch
	jmp     i59rilnocs
i59rilcs:
	mov     ch,11h
i59rilnocs:
	or      eax,eax
	jz      i59ril1
	jns     i59ril2
	or      ch,8                            ; set N flag
	jmp     i59ril2
i59ril1:or      ch,4                            ; set Z flag
i59ril2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     dword ptr [ebx],eax
	mov     eax,dword ptr [edi+16]
	ret

i59_RI_R_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
        cmp     cl,20h
        jb      i59rrbok
        mov     dl,cl
        mov     cl,31
        sub     dl,cl
        test    ch,10h
        jz      i59rrbext
	stc
i59rrbext:
        rcr     al,cl
        mov     cl,dl
        jmp     i59rrb3
i59rrbok:
	test    ch,10h
	jz      i59rrb3
	stc
i59rrb3:rcr     al,cl
	jc      i59rrbcs
	xor     ch,ch
	jmp     i59rrbnocs
i59rrbcs:
	mov     ch,11h
i59rrbnocs:
	movzx   ebp,cl
	add     ebp,ebp
	add     ebp,dword ptr [edi+16]
	or      al,al
	jz      i59rrb1
	jns     i59rrb2
	or      ch,8                            ; set N flag
	jmp     i59rrb2
i59rrb1:or      ch,4                            ; set Z flag
i59rrb2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     byte ptr [ebx],al
	mov     eax,ebp
	ret

i59_RI_R_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
        cmp     cl,20h
        jb      i59rrwok
        mov     dl,cl
        mov     cl,31
        sub     dl,cl
        test    ch,10h
        jz      i59rrwext
	stc
i59rrwext:
        rcr     ax,cl
        mov     cl,dl
        jmp     i59rrw3
i59rrwok:
	test    ch,10h
	jz      i59rrw3
	stc
i59rrw3:rcr     ax,cl
	jc      i59rrwcs
	xor     ch,ch
	jmp     i59rrwnocs
i59rrwcs:
	mov     ch,11h
i59rrwnocs:
	movzx   ebp,cl
	add     ebp,ebp
	add     ebp,dword ptr [edi+16]
	or      ax,ax
	jz      i59rrw1
	jns     i59rrw2
	or      ch,8                            ; set N flag
	jmp     i59rrw2
i59rrw1:or      ch,4                            ; set Z flag
i59rrw2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     word ptr [ebx],ax
	mov     eax,ebp
	ret

i59_RI_R_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
        cmp     cl,20h
        jb      i59rrlok
        mov     dl,cl
        mov     cl,31
        sub     dl,cl
        test    ch,10h
        jz      i59rrlext
	stc
i59rrlext:
        rcr     eax,cl
        mov     cl,dl
        jmp     i59rrl3
i59rrlok:
	test    ch,10h
	jz      i59rrl3
	stc
i59rrl3:rcr     eax,cl
	jc      i59rrlcs
	xor     ch,ch
	jmp     i59rrlnocs
i59rrlcs:
	mov     ch,11h
i59rrlnocs:

	movzx   ebp,cl
	add     ebp,ebp
	add     ebp,dword ptr [edi+16]
	or      eax,eax
	jz      i59rrl1
	jns     i59rrl2
	or      ch,8                            ; set N flag
	jmp     i59rrl2
i59rrl1:or      ch,4                            ; set Z flag
i59rrl2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     dword ptr [ebx],eax
	mov     eax,ebp
	ret

i59_LE_I_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
	test    ch,10h
	jz      i59lib3
	stc
i59lib3:rcl     al,cl
	jc      i59libcs
	xor     ch,ch
	jmp     i59libnocs
i59libcs:
	mov     ch,11h
i59libnocs:
	or      al,al
	jz      i59lib1
	jns     i59lib2
	or      ch,8                            ; set N flag
	jmp     i59lib2
i59lib1:or      ch,4                            ; set Z flag
i59lib2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     byte ptr [ebx],al
	mov     eax,dword ptr [edi+16]
	ret

i59_LE_I_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
        test    ch,10h
	jz      i59liw3
	stc
i59liw3:rcl     ax,cl
	jc      i59liwcs
	xor     ch,ch
	jmp     i59liwnocs
i59liwcs:
	mov     ch,11h
i59liwnocs:
	or      ax,ax
	jz      i59liw1
	jns     i59liw2
	or      ch,8                            ; set N flag
	jmp     i59liw2
i59liw1:or      ch,4                            ; set Z flag
i59liw2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     word ptr [ebx],ax
	mov     eax,dword ptr [edi+16]
	ret

i59_LE_I_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
	test    ch,10h
	jz      i59lil3
	stc
i59lil3:rcl     eax,cl
	jc      i59lilcs
	xor     ch,ch
	jmp     i59lilnocs
i59lilcs:
	mov     ch,11h
i59lilnocs:
	or      eax,eax
	jz      i59lil1
	jns     i59lil2
	or      ch,8                            ; set N flag
	jmp     i59lil2
i59lil1:or      ch,4                            ; set Z flag
i59lil2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     dword ptr [ebx],eax
	mov     eax,dword ptr [edi+16]
	ret

i59_LE_R_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	mov     eax,dword ptr [ebx]             ; get dreg content
        mov     ch,byte ptr [_sr]
        cmp     cl,20h
        jb      i59lrbok
        mov     dl,cl
        mov     cl,31
        sub     dl,cl
        test    ch,10h
        jz      i59lrbext
	stc
i59lrbext:
        rcl     al,cl
        mov     cl,dl
        jmp     i59lrb3
i59lrbok:
        test    ch,10h
	jz      i59lrb3
	stc
i59lrb3:rcl     al,cl
	jc      i59lrbcs
	xor     ch,ch
	jmp     i59lrbnocs
i59lrbcs:
	mov     ch,11h
i59lrbnocs:
	movzx   ebp,cl
	add     ebp,ebp
	add     ebp,dword ptr [edi+16]
	or      al,al
	jz      i59lrb1
	jns     i59lrb2
	or      ch,8                            ; set N flag
	jmp     i59lrb2
i59lrb1:or      ch,4                            ; set Z flag
i59lrb2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     byte ptr [ebx],al
	mov     eax,ebp
	ret

i59_LE_R_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
        cmp     cl,20h
        jb      i59lrwok
        mov     dl,cl
        mov     cl,31
        sub     dl,cl
        test    ch,10h
        jz      i59lrwext
	stc
i59lrwext:
        rcl     ax,cl
        mov     cl,dl
        jmp     i59lrw3
i59lrwok:
	test    ch,10h
	jz      i59lrw3
	stc
i59lrw3:rcl     ax,cl
	jc      i59lrwcs
	xor     ch,ch
	jmp     i59lrwnocs
i59lrwcs:
	mov     ch,11h
i59lrwnocs:
	movzx   ebp,cl
	add     ebp,ebp
	add     ebp,dword ptr [edi+16]
	or      ax,ax
	jz      i59lrw1
	jns     i59lrw2
	or      ch,8                            ; set N flag
	jmp     i59lrw2
i59lrw1:or      ch,4                            ; set Z flag
i59lrw2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     word ptr [ebx],ax
	mov     eax,ebp
	ret

i59_LE_R_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	mov     eax,dword ptr [ebx]             ; get dreg content
	mov     ch,byte ptr _sr
        cmp     cl,20h
        jb      i59lrlok
        mov     dl,cl
        mov     cl,31
        sub     dl,cl
        test    ch,10h
        jz      i59lrlext
	stc
i59lrlext:
        rcl     eax,cl
        mov     cl,dl
        jmp     i59lrl3
i59lrlok:
	test    ch,10h
	jz      i59lrl3
	stc
i59lrl3:rcl     eax,cl
	jc      i59lrlcs
	xor     ch,ch
	jmp     i59lrlnocs
i59lrlcs:
	mov     ch,11h
i59lrlnocs:
	movzx   ebp,cl
	add     ebp,ebp
	add     ebp,dword ptr [edi+16]
	or      eax,eax
	jz      i59lrl1
	jns     i59lrl2
	or      ch,8                            ; set N flag
	jmp     i59lrl2
i59lrl1:or      ch,4                            ; set Z flag
i59lrl2:
	mov     byte ptr _sr,ch                  ; Store flags
	mov     dword ptr [ebx],eax
	mov     eax,ebp
	ret


i59_RI_M_W_:
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	mov     edx,ebx
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
	mov     al,byte ptr _sr
	test    al,10h
	jz      i59rmw3
	stc
i59rmw3:rcr     dx,1
	jc      i59rmwcs
	xor     al,al
	jmp     i59rmwnocs
i59rmwcs:
	mov     al,11h
i59rmwnocs:
	or      dx,dx
	jz      i59rmw1
	jns     i59rmw2
	or      al,8                            ; set N flag
	jmp     i59rmw2
i59rmw1:or      al,4                            ; set Z flag
i59rmw2:
	mov     byte ptr _sr,al                  ; Store flags
	mov     eax,dword ptr [edi+16]
	call    eax     
	mov     eax,dword ptr [edi+20]
	ret

i59_LE_M_W_:
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	mov     edx,ebx
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
	mov     al,byte ptr _sr
	test    al,10h
	jz      i59lmw3
	stc
i59lmw3:rcl     dx,1
	jc      i59lmwcs
	xor     al,al
	jmp     i59lmwnocs
i59lmwcs:
	mov     al,11h
i59lmwnocs:
	or      dx,dx
	jz      i59lmw1
	jns     i59lmw2
	or      al,8                            ; set N flag
	jmp     i59lmw2
i59lmw1:or      al,4                            ; set Z flag
i59lmw2:
	mov     byte ptr _sr,al                  ; Store flags
	mov     eax,dword ptr [edi+16]
	call    eax     
	mov     eax,dword ptr [edi+20]
	ret


;
; Instruction 61 RTE
; Opcode*32+t i edi
; Flag: From stack
;

                align   4

public i61_
i61_:           test    byte ptr _sr+1,020h
                jz      privilegie_violation
                mov     ecx,dword ptr [_a+28]
                fetchw
                mov     ebp,edx                         
                add     ecx,2
                mov     dword ptr [_a+28],ecx
                fetchl
                mov     ecx,dword ptr [_a+28]
#ifdef PREFETCH
                call    prefetch_fill_
#endif
                mov     esi,edx
                add     ecx,4
                mov     dword ptr [_a+28],ecx
                mov     edx,ebp
                call    updatesr
                mov     eax,20
                ret

;
; Instruction 62 RTR
; Opcode*32+t i edi
; Flag: From stack
;

                align   4

public i62_
i62_:           mov     ecx,dword ptr [_a+28]
                fetchw
                and     dl,01fh
                mov     byte ptr _sr,dl
                add     ecx,2
                mov     dword ptr [_a+28],ecx
                fetchl
                mov     ecx,dword ptr [_a+28]
#ifdef PREFETCH
                call    prefetch_fill_
#endif
                mov     esi,edx
                add     ecx,4
                mov     dword ptr [_a+28],ecx
                mov     eax,20
                ret

;
; Instruction 63 RTS
; Opcode*32+t i edi
; Flag: NONE
;

                align   4

public i63_
i63_:           mov     ecx,dword ptr [_a+28]
                fetchl
#ifdef PREFETCH
                call    prefetch_fill_
#endif
                mov     esi,edx
                add     ecx,4
                mov     dword ptr [_a+28],ecx
                mov     eax,16
                ret

;
; Instruction 64   SBCD.B Dy,Dx    SBCD.B -(Ay),-(Ax)
; Tableusage  2 - rx*4(dest)  3 - ry*4
; Opcode*32 i edi
;
i64_1_:
	mov     ebx,dword ptr [12+edi]          ; 1       Source
	xor     eax,eax                         ; 2 
	mov     ecx,dword ptr [8+edi]           ; 5       Dest
	mov     dl,byte ptr _sr                  ; 13      Flags
	mov     al,byte ptr [ebx]               ; 3       Reg er byte verdi, no xor
        xor     ebx,ebx
        mov     bl,byte ptr [_bcd2hex+eax]      ; 4 AGI 2
	mov     al,byte ptr [ecx]               ; 6
	test    dl,10h                          ; 9
	jz      i64_1a                          ; 10
	inc     ebx                             ; 11
i64_1a: mov     al,byte ptr [_bcd2hex+eax]      ; 7
	sub     eax,ebx                         ; 12
	and     dl,0eh                          ; 13
	or      eax,eax                         ; 14 Borrow?
	jns     i64_1b                          ; 15
	or      dl,11h                          ; 16 Borrow!
	add     eax,100                         ; 17
i64_1b: or      al,al                           ; 18 Zero?
	jz      i64_1c                          ; 19
	and     dl,01bh                         ; 20 Non-Zero!
i64_1c: mov     byte ptr _sr,dl                  ; 21 Flags end
        and     eax,0ffh
        mov     al,byte ptr [_hex2bcd+eax]      ; 22
	mov     byte ptr [ecx],al               ; 23
	mov     eax,6      ; 24      return cyclecount
	ret                                     ; 24



i64_2_:
#ifdef PROF68
        inc     dword ptr [_profile+4*63]
#endif
	mov     ebx,dword ptr [12+edi]        ; Source 
	mov     ecx,dword ptr [ebx]
	dec     ecx
        cmp     ebx,dword ptr [_a7pointer]
        jne     i64_2_j
        dec     ecx
i64_2_j:
	mov     dword ptr [ebx],ecx
	xor     edx,edx
        fetchb
        xor     ebx,ebx
	mov     bl,byte ptr [_bcd2hex+edx]                           ; bl is now sourcedata
	mov     eax,dword ptr [8+edi]         ; Dest
	mov     ecx,dword ptr [eax]
	dec     ecx
        cmp     eax,dword ptr [_a7pointer]
        jne     i64_2_i
        dec     ecx
i64_2_i:
	mov     dword ptr [eax],ecx
	xor     edx,edx
        fetchb
        xor     eax,eax
	mov     al,byte ptr [_bcd2hex+edx]
	mov     dl,byte ptr _sr                  ; Flags
	test    dl,10h
	jz      i64_2a
	inc     ebx
i64_2a: sub     eax,ebx
	and     dl,0eh
	or      eax,eax                         ; Carry?
	jns     i64_2b
	or      dl,11h                          ; Carry!
	add     eax,100
i64_2b: or      eax,eax                           ; Zero?
	jz      i64_2c
	and     dl,01bh                         ; Non-Zero!
i64_2c: mov     byte ptr _sr,dl                  ; Flags end
        and     eax,0ffh
        mov     dl,byte ptr [_hex2bcd+eax]
        writeb
	mov     eax,18     ; return cyclecount
	ret

;
; Scc <ea>
; Tableusage 0- rut 1- disrut 2-register*4+d 3-ea skriv rut 4-handle routine
;            5- cycle count/false  6-cycle count/true
; Flag: NONE
;

i65_:
#ifdef PROF68
        inc     dword ptr [_profile+4*64]
#endif
        mov     eax,dword ptr [edi+16]
	call    eax
	mov     eax,dword ptr [edi+12]
	mov     ebx,dword ptr [edi+8]
        test    dl,dl
	jz      i65false
	mov     dl,-1
	call    eax
	mov     eax,dword ptr [edi+24]
	ret
i65false:
	call    eax
	mov     eax,dword ptr [edi+20]
	ret

;
; STOP #xxx.W  | cycles OK
; Flag:  Settes til immediate operand
;
i66_:
        test    byte ptr _sr+1,020h
        jz      privilegie_violation
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
        mov     dword ptr _cpustopflag,1
	mov     dword ptr _interruptflag,1
	mov     ebx,edx
	call    updatesr

#ifdef DEBUGBUILD
; Log code from here
        mov     eax,dword ptr _loglast
        and     eax,EVENTMASK
        shl     eax,6
        cmp     dword ptr _logstop,1
        jne     i66no
        mov     dword ptr _logbuffer[eax],EVSTOP
	mov     ebx,dword ptr _frames
        mov     dword ptr _logbuffer+4[eax],ebx
	mov     ebx,dword ptr _ypos
        mov     dword ptr _logbuffer+8[eax],ebx
	mov     ebx,dword ptr _xpos
        mov     dword ptr _logbuffer+12[eax],ebx
        mov     ebx,dword ptr _pc
        mov     dword ptr _logbuffer+16[eax],ebx
        inc     dword ptr _loglast
        mov     ebx,dword ptr _loglast
        sub     ebx,dword ptr _logfirst
        cmp     ebx,EVENTCOUNT
        jne     i66no
        inc     dword ptr _logfirst
i66no:                               ; Exit point when logging isnt enabled
; Log code ended here
#endif

	mov     eax,16
	ret

;
; SUB.X <ea>,Dn / SUB.X Dn,<ea>
; Flag: ALL, X=C
;
i67_B_1_:
#ifdef PROF68
        inc     dword ptr [_profile+4*66]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     dh,byte ptr [ebx]           ; Les Dn  5      3
	sub     dh,dl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     byte ptr [ebx],dh           ;        12      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     byte ptr _sr,al              ;        11      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =31
i67_W_1_:
#ifdef PROF68
        inc     dword ptr [_profile+4*66]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     cx,word ptr [ebx]           ; Les Dn  5      4
	sub     cx,dx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     word ptr [ebx],cx           ;        12      2
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     byte ptr _sr,al              ;        11      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =34
i67_L_1_:
#ifdef PROF68
        inc     dword ptr [_profile+4*66]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	sub     ecx,edx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     dword ptr [ebx],ecx         ;        12      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     byte ptr _sr,al              ;        11      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =31
i67_B_2_:
#ifdef PROF68
        inc     dword ptr [_profile+4*66]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     dh,byte ptr [ebx]           ; Les Dn  5      3
	sub     dl,dh                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i67_W_2_:
#ifdef PROF68
        inc     dword ptr [_profile+4*66]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     cx,word ptr [ebx]           ; Les Dn  5      4
	sub     dx,cx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =38
i67_L_2_:
#ifdef PROF68
        inc     dword ptr [_profile+4*66]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      3
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	sub     edx,ecx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+24]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+20]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
;
; SUBA.W/L <ea>,An   Setter ikke flagg!
;
i68_W_:
#ifdef PROF68
        inc     dword ptr [_profile+4*67]
#endif
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	movsx   edx,dx
	sub     ecx,edx                     ;         6      1
	mov     dword ptr [ebx],ecx         ;        12      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =34
i68_L_:
#ifdef PROF68
        inc     dword ptr [_profile+4*67]
#endif
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+16]      ;         4      3
	mov     ecx,dword ptr [ebx]         ; Les Dn  5      3
	sub     ecx,edx                     ;         6      1
	mov     dword ptr [ebx],ecx         ;        12      1
	mov     eax,dword ptr [edi+20]      ;        13      1
	ret                                 ;        15      5
					    ;              =22
;
; SUBI.X #,<ea>
;  0-rutinepeker 1-disasm rutine  2-eareg 3-ea les rutine
;                4-cycle count    5-ea skriv rutine               
; Flag: ALL, X=C
;
i69_B_:
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	sub     dl,bl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5

i69_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	sub     dx,bx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =38
i69_L_:
	mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      3
	call    eax                         ; Les <ea>3      5
	sub     edx,ebx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5

;
; SUBQ.X #,<ea>
; Flag: ALL, X=C
; I think this one is OK. But what happens with SUBQ.W #1,Ax???
;
i70_B_:
#ifdef PROF68
        inc     dword ptr [_profile+4*69]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+24]
	sub     dl,bl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =36
i70_W_:
#ifdef PROF68
        inc     dword ptr [_profile+4*69]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+24]
	sub     dx,bx                       ;         6      2
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5
					    ;              =38
i70_L_:
#ifdef PROF68
        inc     dword ptr [_profile+4*69]
#endif
	mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      3
	call    eax                         ; Les <ea>3      5
	mov     ebx,dword ptr [edi+24]
	sub     edx,ebx                     ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,0fffh                   ;         9      1
	mov     eax,dword ptr [_statustab+4*eax];        10      3
	mov     ecx,dword ptr [edi+20]      ;        12      1
	mov     byte ptr _sr,al              ;        11      1
	mov     ebx,dword ptr [edi+8]
	call    ecx                         ;        13      5
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5

i70_ADR_:
#ifdef PROF68
        inc     dword ptr [_profile+4*69]
#endif
	mov     eax,dword ptr [edi+8]      ;         2      1
	mov     edx,dword ptr [eax]
	mov     ebx,dword ptr [edi+24]
	sub     edx,ebx                     ;         6      1
	mov     dword ptr [eax],edx
	mov     eax,dword ptr [edi+16]      ;        14      1
	ret                                 ;        16      5


;
; Instruction 71   SUBX.X Dy,Dx    SUBX.X -(Ay),-(Ax)
; Tableusage  2 - rx*4(dest)  3 - ry*4
; Flagg: ALL, Z unchanged if result non-zero
;


                align   4

public i71_B_1_
i71_B_1_:       mov     ebx,dword ptr [12+edi]         
                mov     ecx,dword ptr [8+edi]          
                mov     al,byte ptr [ebx]          
                mov     bl,byte ptr [ecx]          
                mov     edx,dword ptr _sr
                test    dl,10h
                jz      i71b1nc
                stc     
i71b1nc:        sbb     bl,al
                pushfd                             
                pop     eax                        
                and     eax,0fbfh                  
                mov     byte ptr [ecx],bl          
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    bl,bl                           ; Clear if nonzero
                jz      i71b1nz
                xor     ah,ah
i71b1nz:        or      al,ah
                mov     byte ptr _sr,al
                mov     eax,4
                ret


                align   4

public i71_W_1_
i71_W_1_:       mov     ebx,dword ptr [12+edi]         
                mov     ecx,dword ptr [8+edi]          
                mov     eax,dword ptr [ebx]             
                mov     ebx,dword ptr [ecx]             
                mov     edx,dword ptr _sr
                test    dl,10h
                jz      i71w1nc
                stc     
i71w1nc:        sbb     bx,ax
                pushfd         
                pop     eax    
                and     eax,0fbfh
                mov     word ptr [ecx],bx
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    bx,bx                           ; Clear if nonzero
                jz      i71w1nz
                xor     ah,ah
i71w1nz:        or      al,ah
                mov     byte ptr _sr,al
                mov     eax,4
                ret


                align   4

public i71_L_1_
i71_L_1_:       mov     ebx,dword ptr [12+edi]
                mov     ecx,dword ptr [8+edi]
                mov     eax,dword ptr [ebx]
                mov     ebx,dword ptr [ecx]
                mov     edx,dword ptr _sr
                test    dl,10h
                jz      i71l1nc
                stc     
i71l1nc:        sbb     ebx,eax
                pushfd                         
                pop     eax                    
                and     eax,0fbfh              
                mov     dword ptr [ecx],ebx    
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    ebx,ebx                         ; Clear if nonzero
                jz      i71l1nz
                xor     ah,ah
i71l1nz:        or      al,ah
                mov     byte ptr _sr,al             
                mov     eax,8
                ret


                align   4

public i71_B_2_
i71_B_2_:      	mov     ebx,dword ptr [12+edi]        ; Source
                mov     ecx,dword ptr [ebx]
                dec     ecx
                cmp     ebx,dword ptr [_a7pointer]
                jne     i71_B_2j
                dec     ecx
i71_B_2j:       mov     dword ptr [ebx],ecx
                fetchb
                mov     eax,dword ptr [8+edi]         ; Dest
                mov     ecx,dword ptr [eax]
                dec     ecx
                cmp     eax,dword ptr [_a7pointer]
                jne     i71_B_2i
                dec     ecx
i71_B_2i:       push    ecx
                mov     dword ptr [eax],ecx
                fetchb
                mov     ebx,edx
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i71b2nc
                stc     
i71b2nc:        sbb     dl,bl
                pushfd                             
                pop     eax                        
                and     eax,0fbfh                  
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dl,dl                           ; Clear if nonzero
                jz      i71b2nz
                xor     ah,ah
i71b2nz:        or      al,ah
                mov     byte ptr _sr,al            
                pop     ecx
                writeb
                mov     eax,18
                ret


                align   4

public i71_W_2_
i71_W_2_:   	mov     ebx,dword ptr [12+edi]        ; Source
                mov     ecx,dword ptr [ebx]
                sub     ecx,2
                mov     dword ptr [ebx],ecx
                fetchw
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]         ; Dest
                mov     ecx,dword ptr [eax]
                sub     ecx,2
                mov     dword ptr [eax],ecx
                push    ecx
                fetchw
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i71w2nc
                stc     
i71w2nc:        sbb     dx,bx
                pushfd             
                pop     eax        
                and     eax,0fbfh  
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dx,dx                           ; Clear if nonzero
                jz      i71w2nz
                xor     ah,ah
i71w2nz:        or      al,ah
                mov     byte ptr _sr,al         
                pop     ecx
                writew
                mov     eax,18
                ret


                align   4

public i71_L_2_
i71_L_2_: 	mov     ebx,dword ptr [12+edi]        ; Source 
                mov     ecx,dword ptr [ebx]
                sub     ecx,4
                mov     dword ptr [ebx],ecx
                fetchl
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]         ; Dest
                mov     ecx,dword ptr [eax]
                sub     ecx,4
                mov     dword ptr [eax],ecx
                push    ecx
                fetchl
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i71l2nc
                stc     
i71l2nc:        sbb     edx,ebx
                pushfd                          
                pop     eax                     
                and     eax,0fbfh               
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    edx,edx                         ; Clear if nonzero
                jz      i71l2nz
                xor     ah,ah
i71l2nz:        or      al,ah
                mov     byte ptr _sr,al
                pop     ecx
                writel
                mov     eax,30
                ret


;
; Instruction SWAP.W <ea>
; Tableusage 0 - rutine  1 - disrut  2 - reg 
; Flag: NZ, V=C=0, X unaffected
; I think this one is OK
;
i72_:
#ifdef PROF68
        inc     dword ptr [_profile+4*71]
#endif
        mov     eax,dword ptr [edi+8]
	mov     ebx,dword ptr [eax]
	ror     ebx,16
	mov     dword ptr [eax],ebx
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h        ; Always clear VC (and NZ)
	or      ebx,ebx                     ; Do the NZ flags
	jnz     i72b
	or      eax,04h
	mov     dword ptr _sr,eax
	mov     eax,4
	ret
i72b:   or      ebx,ebx
        jns     i72c
	or      eax,08h
	mov     dword ptr _sr,eax
i72c:   mov     eax,4
	ret

;
; Instruction TAS.B <ea>
; Tableusage 0-rutine  1-disrut  2-eareg  3-eale_srut 4-easkrivrut 5-cycletime
; Flag: NZ, V=C=0, X unaffected
; I think this one is OK
;
i73_:
#ifdef PROF68
        inc     dword ptr [_profile+4*72]
#endif
        mov     edx,dword ptr [edi+8]
	mov     ecx,dword ptr [edi+12]
	call    ecx
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        test    dl,dl
	jns     i73zer
	or      eax,8
i73zer: test    dl,dl
        jnz     i73mo
	or      eax,4
i73mo:  or      dl,80h
	mov     dword ptr _sr,eax
	mov     ecx,dword ptr [edi+16]
        mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret

;
; Instruction TRAP #
; Tableusage 0 - rutine  1 - disrut  2 - vektor*4+80h
; Flag: none
; I think this one is OK
;

                align   4

public i74_
i74_:           mov     ebx,dword ptr [edi+8]
                mov     eax,38
                jmp     prepare_exception_

;
; Instruction TRAPV      jumps to routine specified at $00001c
; Tableusage 0 - rutine  1 - disrut  
; Flag: none
; I think this one is OK
;

                align   4

public i75_
i75_:           test    byte ptr _sr,2
                jz      i75notra
                mov     ebx,01ch
                mov     eax,34
                jmp     prepare_exception_
i75notra:       mov     eax,4
                ret

;
; TST.? <ea>
; tableusage 0 - rutine  1 - disrut  2-eareg  3-ea_lesrut  4-cycle count
; Flag: NZ, V=C=0, X unaffected
; I think this one is OK
;
i76_B_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
        test    dl,dl                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3       
	mov     ecx,dword ptr _sr
        and     ebx,0fh
	and     ecx,0fffffff0h
        or      ecx,ebx
	mov     dword ptr _sr,ecx            ;        11      1
	mov     eax,dword ptr [edi+16]      ;        13      1
	ret                                 ;        15      5
i76_W_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
        test    dx,dx                       ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3       
	mov     ecx,dword ptr _sr
        and     ebx,0fh     
	and     ecx,0fffffff0h
        or      ecx,ebx
	mov     dword ptr _sr,ecx            ;        11      1
	mov     eax,dword ptr [edi+16]      ;        13      1
	ret                                 ;        15      5
i76_L_:
        mov     eax,dword ptr [edi+12]      ;         2      1
	mov     edx,dword ptr [edi+8]       ;         1      1
	call    eax                         ; Les <ea>3      5
        test    edx,edx                    ;         6      1
	pushfd                              ; Flags   7      3
	pop     eax                         ;         8      1
	and     eax,07feh                   ;         9      1
	mov     ebx,dword ptr [_statustab+4*eax];        10      3       
	mov     ecx,dword ptr _sr
        and     ebx,0fh
        and     ecx,0fffffff0h
	or      ecx,ebx
	mov     dword ptr _sr,ecx            ;        11      1
	mov     eax,dword ptr [edi+16]      ;        13      1
	ret                                 ;        15      5

;
; Instruction UNLK An
; tabellusage 0 - routine  1 - disrout  2 - Register
; Flag: none
; Think this one is OK
;

                align   4

public i77_
i77_:           mov     ebx,dword ptr [edi+8]
                mov     ecx,dword ptr [ebx]
                mov     edx,ecx
                add     edx,4
                mov     dword ptr [_a+28],edx
                fetchl
                mov     dword ptr [ebx],edx
                mov     eax,12
                ret












_TEXT ends

_DATA segment dword public 'DATA'

include data\memory.inc

#ifdef DEBUGBUILD
include data\log.inc
#endif

include data\inout.inc
include data\chip.inc
include data\floppy.inc
include data\sound.inc
include data\68000.inc
include data\bus.inc


extern _f12pressed:dword
_DATA ends

_BSS segment dword public 'DATA'
_BSS ends
end
